#ifndef BA0_GARBAGE_H
#define BA0_GARBAGE_H 1

#include "ba0_common.h"
#include "ba0_stack.h"
#include "ba0_list.h"
#include "ba0_table.h"
#include "ba0_format.h"

BEGIN_C_DECLS

/* Garbage collector of J.-C. Faugere */

typedef struct ba0_gc_info {
    ba0_int_p old_index_in_cells;
    void* old_addr;
    union {
        unsigned ba0_int_p size;
        void* new_addr;
    } u;
    char* text;
} *ba0_gc_info;

extern BA0_DLL void ba0_garbage (char*, struct ba0_mark*, ...);
extern BA0_DLL ba0_int_p ba0_garbage1 (char*, void*, enum ba0_garbage_code);
extern BA0_DLL void* ba0_garbage2 (char*, void*, enum ba0_garbage_code);
extern BA0_DLL ba0_int_p ba0_new_gc_info (void*, unsigned ba0_int_p, char*);
extern BA0_DLL void* ba0_new_addr_gc_info (void*, char*);

END_C_DECLS

#endif /* !BA0_GARBAGE_H */
