#ifndef BA0_GMP_H
#define BA0_GMP_H 1

#include "ba0_common.h"
#include "ba0_macros_mpz.h"
#include "ba0_macros_mpq.h"

BEGIN_C_DECLS

typedef struct ba0_tableof_mpz {
    ba0_int_p alloc;
    ba0_int_p size;
    __mpz_struct* *tab;
} *ba0_tableof_mpz;

typedef struct ba0_listof_mpz {
    __mpz_struct* value;
    struct ba0_listof_mpz* next;
} *ba0_listof_mpz;

typedef struct ba0_tableof_mpq {
    ba0_int_p alloc;
    ba0_int_p size;
    __mpq_struct* *tab;
} *ba0_tableof_mpq;

typedef struct ba0_listof_mpq {
    __mpq_struct* value;
    struct ba0_listof_mpq* next;
} *ba0_listof_mpq;

typedef void ba0_mp_set_memory_functions (void* (*) (size_t),
					  void* (*) (void*, size_t, size_t),
					  void (*) (void*, size_t));

#define ba0_gmp_set_memory_functions 	\
			ba0_initialized_global.gmp.set_memory_functions

extern BA0_DLL void ba0_set_settings_gmp (ba0_mp_set_memory_functions*);
extern BA0_DLL void ba0_get_settings_gmp (ba0_mp_set_memory_functions**);

extern BA0_DLL void ba0_record_gmp_memory_functions (void);
extern BA0_DLL void ba0_restore_gmp_memory_functions (void);

extern BA0_DLL bool ba0_domain_mpz (void);
extern BA0_DLL bool ba0_domain_mpq (void);

extern BA0_DLL void* ba0_gmp_alloc (size_t);
extern BA0_DLL void* ba0_gmp_realloc (void*, size_t, size_t);
extern BA0_DLL void  ba0_gmp_free (void*, size_t);

extern BA0_DLL __mpq_struct* ba0_new_mpq (void);
extern BA0_DLL __mpz_struct* ba0_new_mpz (void);

extern BA0_DLL ba0_scanf_function ba0_scanf_mpz;
extern BA0_DLL ba0_printf_function ba0_printf_mpz;
extern BA0_DLL ba0_garbage1_function ba0_garbage1_mpz;
extern BA0_DLL ba0_garbage2_function ba0_garbage2_mpz;
extern BA0_DLL ba0_copy_function ba0_copy_mpz;

extern BA0_DLL ba0_scanf_function ba0_scanf_mpq;
extern BA0_DLL ba0_printf_function ba0_printf_mpq;
extern BA0_DLL ba0_garbage1_function ba0_garbage1_mpq;
extern BA0_DLL ba0_garbage2_function ba0_garbage2_mpq;
extern BA0_DLL ba0_copy_function ba0_copy_mpq;

END_C_DECLS

#endif /* !BA0_GMP_H */
