#ifndef BA0_MACROS_MPFR_H
#define BA0_MACROS_MPFR_H 1

#include "ba0_common.h"
#include "ba0_mpfr.h"

/* Macros for mpfr */

#define ba0_mpfr_t mpfr_t

#define ba0_mpfr_affect(rop,op)		rop [0] = op [0]
#define ba0_mpfr_init(rop)		mpfr_init(rop)
#define ba0_mpfr_set(rop,op)		mpfr_set(rop,op,ba0_mpfr_rnd)
#define ba0_mpfr_swap(rop,op)		mpfr_swap(rop,op)
#define ba0_mpfr_set_si(rop,op)		mpfr_set_si(rop,op,ba0_mpfr_rnd)
#define ba0_mpfr_set_ui(rop,op)		mpfr_set_ui(rop,op,ba0_mpfr_rnd)

#define ba0_mpfr_init_set(rop,op)  					\
		do {							\
		mpfr_init(rop);						\
		mpfr_set(rop,op,ba0_mpfr_rnd);				\
		} while (0)

#define ba0_mpfr_init_set_si(rop,op)  					\
		do { 							\
		mpfr_init(rop);						\
		mpfr_set_si(rop,op,ba0_mpfr_rnd); 			\
		} while (0)

#define ba0_mpfr_init_set_ui(rop,op)  					\
		do { 							\
		mpfr_init(rop);						\
		mpfr_set_ui(rop,op,ba0_mpfr_rnd); 			\
		} while (0)

#define ba0_mpfr_sgn(op)		mpfr_sgn(op)
#define ba0_mpfr_cmp_ui(opa,opb)	mpfr_cmp_ui(opa,opb)
#define ba0_mpfr_is_one(op)		mpfr_cmp_ui(op,1) == 0
#define ba0_mpfr_cmp(opa,opb)		mpfr_cmp(opa,opb)
#define ba0_mpfr_neg(opa,opb)		mpfr_neg(opa,opb,ba0_mpfr_rnd)
#define ba0_mpfr_add(rop,opa,opb)	mpfr_add(rop,opa,opb,ba0_mpfr_rnd)
#define ba0_mpfr_sub(rop,opa,opb)	mpfr_sub(rop,opa,opb,ba0_mpfr_rnd)
#define ba0_mpfr_mul(rop,opa,opb)	mpfr_mul(rop,opa,opb,ba0_mpfr_rnd)
#define ba0_mpfr_mul_ui(rop,opa,opb)	mpfr_mul_ui(rop,opa,opb,ba0_mpfr_rnd)
#define ba0_mpfr_mul_si(rop,opa,opb)	mpfr_mul_si(rop,opa,opb,ba0_mpfr_rnd)
#define ba0_mpfr_pow_ui(rop,opa,opb)	mpfr_pow_ui(rop,opa,opb,ba0_mpfr_rnd)
#define ba0_mpfr_div(rop,opa,opb)	mpfr_div(rop,opa,opb,ba0_mpfr_rnd)
#define ba0_mpfr_invert(rop,op)		mpfr_si_div(rop,1,op,ba0_mpfr_rnd)

#endif /* !BA0_MACROS_MPFR_H */
