#ifndef BA0_MPFR_H
#define BA0_MPFR_H 1

#include "ba0_common.h"

#if HAVE_MPFR_H

#include "ba0_macros_mpfr.h"

BEGIN_C_DECLS

typedef struct ba0_tableof_mpfr {
    ba0_int_p alloc;
    ba0_int_p size;
    __mpfr_struct* *tab;
} *ba0_tableof_mpfr;

typedef struct ba0_listof_mpfr {
    __mpfr_struct* value;
    struct ba0_listof_mpfr* next;
} *ba0_listof_mpfr;

typedef struct ba0_arrayof_mpfr {
    ba0_int_p alloc;
    ba0_int_p size;
    __mpfr_struct *tab;
    ba0_int_p sizelt;
} *ba0_arrayof_mpfr;

#define ba0_mpfr_rnd		ba0_global.mpfr.rnd
#define ba0_mpfr_prec		ba0_global.mpfr.prec

extern BA0_DLL __mpfr_struct* ba0_new_mpfr (void);
extern BA0_DLL bool ba0_domain_mpfr (void);

extern BA0_DLL ba0_scanf_function ba0_scanf_mpfr;
extern BA0_DLL ba0_printf_function ba0_printf_mpfr;
extern BA0_DLL ba0_garbage1_function ba0_garbage1_mpfr;
extern BA0_DLL ba0_garbage2_function ba0_garbage2_mpfr;
extern BA0_DLL ba0_copy_function ba0_copy_mpfr;

END_C_DECLS

#endif /* !HAVE_MPFR_H */
#endif /* !BA0_MPFR_H */
