#include "ba0_exception.h"
#include "ba0_stack.h"
#include "ba0_format.h"
#include "ba0_basic_io.h"
#include "ba0_analex.h"
#include "ba0_scanf.h"
#include "ba0_printf.h"
#include "ba0_scanf_printf.h"
#include "ba0_global.h"

BA0_DLL void ba0_scanf_printf (char* sf, char* pf, ...)
{   ba0_format sformat, pformat;
    void **sobjet, **pobjet;
    va_list arg;
    struct ba0_exception_code code;
    ba0_int_p i;
    char* buffer = (char*)0;
    struct ba0_mark M;

    sformat = ba0_get_format (sf);
    pformat = ba0_get_format (pf);

    ba0_push_another_stack ();
    ba0_record (&M);

    sobjet = (void**) ba0_alloc (sizeof (void*) * sformat->linknmb);
    pobjet = (void**) ba0_alloc (sizeof (void*) * pformat->linknmb);

    va_start (arg, pf);
    for (i = 0; i < sformat->linknmb; i++)
	sobjet [i] = va_arg (arg, void*);
    for (i = 0; i < pformat->linknmb; i++)
	pobjet [i] = va_arg (arg, void*);
    va_end (arg);

    ba0_record_output ();
    ba0_set_output_counter ();

    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_set (code))
    {   ba0__printf__ (pformat, pobjet);

        buffer = (char*)ba0_alloc (ba0_output_counter () + 1);
	ba0_set_output_string (buffer);
	ba0__printf__ (pformat, pobjet);
	ba0_restore_output ();

        ba0_pull_exception (code);
    } else
    {
        ba0_restore_output ();
        BA0_RAISE_EXCEPTION (ba0_mesgerr);
    }

    ba0_pull_stack ();

    ba0_record_analex ();
    ba0_set_analex_string (buffer);

    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_set (code))
    {	ba0_get_token_analex ();
	ba0__scanf__ (sformat, sobjet, true);
	ba0_restore_analex ();
	ba0_pull_exception (code);
    } else
    {	ba0_restore_analex ();
	BA0_RAISE_EXCEPTION (ba0_mesgerr);
    }

    ba0_restore (&M);
}

