#ifndef BA0_X64_GMP_H
#define BA0_X64_GMP_H 1

#include "ba0_common.h"

/*
 * This file contains new interface functions for GMP.
 *
 * The problem comes from WINDOWS 64 bits since many GMP functions
 * expect "long" parameters while longs are 32 bits only in this setting.
 *
 * These functions are only called through the macros in ba0_macros_mp_.h
 */

BEGIN_C_DECLS

extern BA0_DLL void ba0_x64_mpz_set_si (__mpz_struct*, ba0_int_p);
extern BA0_DLL void ba0_x64_mpz_set_ui (__mpz_struct*, unsigned ba0_int_p);
extern BA0_DLL void ba0_x64_mpz_mul_si
		(__mpz_struct*, __mpz_struct*, ba0_int_p);
extern BA0_DLL void ba0_x64_mpz_mul_ui
		(__mpz_struct*, __mpz_struct*, unsigned ba0_int_p);
extern BA0_DLL void ba0_x64_mpz_mul_2exp
		(__mpz_struct*, __mpz_struct*, ba0_int_p);
extern BA0_DLL void ba0_x64_mpz_pow_ui
		(__mpz_struct*, __mpz_struct*, unsigned ba0_int_p);
extern BA0_DLL void ba0_x64_mpz_ui_pow_ui
		(__mpz_struct*, unsigned ba0_int_p, unsigned ba0_int_p);
extern BA0_DLL void ba0_x64_mpz_si_pow_ui
		(__mpz_struct*, ba0_int_p, unsigned ba0_int_p);

extern BA0_DLL void ba0_x64_mpq_set_si (__mpq_struct*, ba0_int_p, ba0_int_p);
extern BA0_DLL void ba0_x64_mpq_set_ui 
		(__mpq_struct*, unsigned ba0_int_p, unsigned ba0_int_p);

END_C_DECLS

#endif /* !BA0_X64_GMP_H */

