#include "ba0.h"

static void wedge 
	(ba0_tableof_int_p R, ba0_tableof_int_p A, ba0_tableof_int_p B)
{   struct ba0_tableof_int_p T;
    struct ba0_mark M;

    ba0_push_another_stack ();
    ba0_record (&M);

    ba0_init_table ((ba0_table)&T);
    ba0_realloc_table ((ba0_table)&T, 3);
    T.size = 3;
    T.tab [0] = A->tab [1]*B->tab [2] - A->tab [2]*B->tab [1];
    T.tab [1] = - A->tab [0]*B->tab [2] + A->tab [2]*B->tab [0];
    T.tab [2] = A->tab [0]*B->tab [1] - A->tab [1]*B->tab [0];

    ba0_pull_stack ();
    ba0_set_table ((ba0_table)R, (ba0_table)&T);
    ba0_restore (&M);
}

int main ()
{   ba0_tableof_int_p R, A, B;
    char buffer [32];

    ba0_restart (0, 0);

    R = (ba0_tableof_int_p)ba0_new_table ();
    A = (ba0_tableof_int_p)ba0_new_table ();
    B = (ba0_tableof_int_p)ba0_new_table ();

    ba0_sscanf2 ("[2, 3, 4]", "%t[%d]", A);
    ba0_sscanf2 ("[3, 1, -2]", "%t[%d]", B);

    wedge (R, A, B);

    ba0_sprintf (buffer, "%t[%d]", R);
    ba0_terminate (ba0_init_level);

    return strcmp (buffer, "[-10, 16, -7]") == 0 ? 0 : 1;
}
