#ifndef BAD_ATTCHAIN_H
#define BAD_ATTCHAIN_H 1

#include "bad_common.h"

BEGIN_C_DECLS

enum bad_structural_property_attchain { 
    bad_differential_structural_property, 
    bad_prime_structural_property };

enum bad_desired_property_attchain { 
    bad_coherence_desired_property, 
    bad_autoreduced_desired_property, 
    bad_squarefree_desired_property,
    bad_primitive_desired_property,
    bad_normalized_desired_property }; 

typedef struct bad_attchain {
    bav_Iordering ordering;
    ba0_int_p structural_property;
    ba0_int_p desired_property;
} *bad_attchain;

extern BAD_DLL void bad_init_attchain (bad_attchain);
extern BAD_DLL void bad_reset_attchain (bad_attchain);
extern BAD_DLL void bad_set_attchain (bad_attchain, bad_attchain);
extern BAD_DLL void bad_intersect_attchain (bad_attchain, bad_attchain);

extern BAD_DLL void bad_set_properties_attchain 
			(bad_attchain, ba0_tableof_string);
extern BAD_DLL void bad_set_automatic_properties_attchain (bad_attchain);
extern BAD_DLL void bad_set_structural_properties_attchain
			(bad_attchain, ba0_tableof_string);
extern BAD_DLL void bad_set_desired_properties_attchain
			(bad_attchain, ba0_tableof_string);

extern BAD_DLL void bad_set_structural_property_attchain
			(bad_attchain, enum bad_structural_property_attchain);
extern BAD_DLL void bad_set_desired_property_attchain
			(bad_attchain, enum bad_desired_property_attchain);

extern BAD_DLL void bad_clear_structural_property_attchain
			(bad_attchain, enum bad_structural_property_attchain);
extern BAD_DLL void bad_clear_desired_property_attchain
			(bad_attchain, enum bad_desired_property_attchain);

extern BAD_DLL bool bad_is_a_structural_property_attchain
			(char*, enum bad_structural_property_attchain*);
extern BAD_DLL bool bad_is_a_desired_property_attchain 
			(char*, enum bad_desired_property_attchain*);

extern BAD_DLL bool bad_has_structural_property_attchain
			(bad_attchain, enum bad_structural_property_attchain);
extern BAD_DLL bool bad_has_desired_property_attchain
			(bad_attchain, enum bad_desired_property_attchain);
extern BAD_DLL bool bad_defines_a_differential_ideal_attchain (bad_attchain);
extern BAD_DLL bool bad_defines_a_prime_ideal_attchain (bad_attchain);

extern BAD_DLL void bad_structural_properties_attchain 
			(ba0_tableof_string, bad_attchain);
extern BAD_DLL void bad_desired_properties_attchain 
			(ba0_tableof_string, bad_attchain);

extern BAD_DLL bool bad_equal_attchain (bad_attchain, bad_attchain);

END_C_DECLS

#endif /* !BAD_ATTCHAIN_H */
