#include "bad_common.h"
#include "bad_nonzero.h"
#include "bad_regchain.h"
#include "bad_intersectof_regchain.h"
#include "bad_reduction.h"
#include "bad_regularize.h"
#include "bad_base_field.h"
#include "bad_low_power_theorem.h"
#include "bad_critical_pair.h"
#include "bad_quadruple.h"
#include "bad_global.h"
#include "bad_stats.h"

BAD_DLL void bad_reset_all_settings (void)
{
    bad_set_settings_nonzero (0, 0);
    bad_set_settings_reduction (0, 0, 0);
    bad_set_settings_regularize (0);
    bad_set_settings_preparation (0);

    bap_reset_all_settings ();
}

BAD_DLL void bad_restart (ba0_int_p time_limit, ba0_int_p memory_limit)
{   enum ba0_restart_level level = ba0_actual_restart_level;
    bool no_oom, no_oot;

    ba0_get_settings_no_oot (&no_oot);
    ba0_set_settings_no_oot (true);
    ba0_get_settings_no_oom (&no_oom);
    ba0_set_settings_no_oom (true);

    bap_restart (time_limit, memory_limit);

    switch (level)
    {	case ba0_init_level:
	    ba0_define_format_with_sizelt 
			("regchain", sizeof (struct bad_regchain),
			&bad_scanf_regchain,
			&bad_printf_regchain,
			&bad_garbage1_regchain,
			&bad_garbage2_regchain,
			&bad_copy_regchain);

	    ba0_define_format_with_sizelt 
			("regchain_equations", sizeof (struct bad_regchain),
			&bad_scanf_regchain,
			&bad_printf_regchain_equations,
			&bad_garbage1_regchain,
			&bad_garbage2_regchain,
			&bad_copy_regchain);

	    ba0_define_format_with_sizelt 
			("pretend_regchain", sizeof (struct bad_regchain),
			&bad_scanf_pretend_regchain,
			&bad_printf_regchain,
			&bad_garbage1_regchain,
			&bad_garbage2_regchain,
			&bad_copy_regchain);

	    ba0_define_format_with_sizelt 
			("critic", sizeof (struct bad_critical_pair),
			&bad_scanf_critical_pair,
			&bad_printf_critical_pair,
			&bad_garbage1_critical_pair,
			&bad_garbage2_critical_pair,
			&bad_copy_critical_pair);

	    ba0_define_format_with_sizelt 
			("position", sizeof (struct bad_position),
			&bad_scanf_position,
			&bad_printf_position,
			&bad_garbage1_position,
			&bad_garbage2_position,
			&bad_copy_position);

	    ba0_define_format_with_sizelt 
			("quadruple", sizeof (struct bad_quadruple),
			&bad_scanf_quadruple,
			&bad_printf_quadruple,
			&bad_garbage1_quadruple,
			&bad_garbage2_quadruple,
			&bad_copy_quadruple);

	    ba0_define_format_with_sizelt 
			("intersectof_regchain", 
			sizeof (struct bad_intersectof_regchain),
			&bad_scanf_intersectof_regchain,
			&bad_printf_intersectof_regchain,
			&bad_garbage1_intersectof_regchain,
			&bad_garbage2_intersectof_regchain,
			&bad_copy_intersectof_regchain);

	    ba0_define_format_with_sizelt 
			("intersectof_regchain_equations", 
			sizeof (struct bad_intersectof_regchain),
			&bad_scanf_intersectof_regchain,
			&bad_printf_intersectof_regchain_equations,
			&bad_garbage1_intersectof_regchain,
			&bad_garbage2_intersectof_regchain,
			&bad_copy_intersectof_regchain);

	    ba0_define_format_with_sizelt 
			("intersectof_pretend_regchain", 
			sizeof (struct bad_intersectof_regchain),
			&bad_scanf_intersectof_pretend_regchain,
			&bad_printf_intersectof_regchain,
			&bad_garbage1_intersectof_regchain,
			&bad_garbage2_intersectof_regchain,
			&bad_copy_intersectof_regchain);

	    ba0_define_format
			("preparation_equation",
			 0,
			 &bad_printf_preparation_equation,
			 0, 0, 0);

	    ba0_define_format_with_sizelt
			("base_field",
			 sizeof (struct bad_base_field),
			 &bad_scanf_base_field,
			 &bad_printf_base_field,
			 0, 0, 0);

	case ba0_reset_level:
	case ba0_done_level:
	    break;
    }
    ba0_set_settings_no_oom (no_oom);
    ba0_set_settings_no_oot (no_oot);
}

BAD_DLL void bad_terminate (enum ba0_restart_level level)
{
    bap_terminate (level);
}

