#ifndef BAD_CRITICAL_PAIR_H
#define BAD_CRITICAL_PAIR_H 1

#include "bad_common.h"

BEGIN_C_DECLS

enum bad_typeof_critical_pair 
	{ bad_normal_critical_pair, bad_rejected_easy_critical_pair };

typedef struct bad_critical_pair {
    enum bad_typeof_critical_pair tag;
    struct bap_polynom_mpz p;
    struct bap_polynom_mpz q;
} *bad_critical_pair;

typedef struct bad_listof_critical_pair {
    bad_critical_pair value;
    struct bad_listof_critical_pair* next;
} *bad_listof_critical_pair;

#define bad_easy_criterion_penalty	bad_global.easy_criterion.penalty

extern BAD_DLL void bad_init_critical_pair (bad_critical_pair);
extern BAD_DLL bad_critical_pair bad_new_critical_pair (void);
extern BAD_DLL bad_critical_pair bad_new_critical_pair_polynom_mpz 
			(bap_polynom_mpz, bap_polynom_mpz);
extern BAD_DLL void bad_set_critical_pair 
			(bad_critical_pair, bad_critical_pair);
extern BAD_DLL void bad_set_critical_pair_polynom_mpz 
			(bad_critical_pair, bap_polynom_mpz, bap_polynom_mpz);
extern BAD_DLL void bad_delta_polynom_critical_pair 
			(bap_polynom_mpz, bad_critical_pair, 
			 bav_tableof_variable);
extern BAD_DLL bool bad_is_a_reduction_critical_pair (bad_critical_pair);
extern BAD_DLL bool bad_is_a_simpler_critical_pair
			(bad_critical_pair, bad_critical_pair);
extern BAD_DLL bool bad_is_a_listof_rejected_critical_pair
			(bad_listof_critical_pair);

extern BAD_DLL ba0_scanf_function bad_scanf_critical_pair;
extern BAD_DLL ba0_printf_function bad_printf_critical_pair;
extern BAD_DLL ba0_garbage1_function bad_garbage1_critical_pair;
extern BAD_DLL ba0_garbage2_function bad_garbage2_critical_pair;
extern BAD_DLL ba0_copy_function bad_copy_critical_pair;

END_C_DECLS

#endif /* !BAD_CRITICAL_PAIR_H */
