#include "bad_intersectof_regchain.h"

/*
 * Initializes {\em ideal}.
 */

BAD_DLL void bad_init_intersectof_regchain (bad_intersectof_regchain ideal)
{
    bad_init_attchain (&ideal->attrib);
    ba0_init_table ((ba0_table)&ideal->inter);
}

/*
 * Returns a new {\tt bad_intersectof_regchain}.
 */

BAD_DLL bad_intersectof_regchain bad_new_intersectof_regchain (void)
{   bad_intersectof_regchain ideal;

    ideal = (bad_intersectof_regchain)ba0_alloc 
				(sizeof (struct bad_intersectof_regchain));
    bad_init_intersectof_regchain (ideal);
    return ideal;
}

BAD_DLL void bad_reset_intersectof_regchain (bad_intersectof_regchain ideal)
{
    bad_reset_attchain (&ideal->attrib);
    ba0_reset_table ((ba0_table)&ideal->inter);
}

BAD_DLL void bad_realloc_intersectof_regchain 
				(bad_intersectof_regchain I, ba0_int_p n)
{
    ba0_realloc2_table ((ba0_table)&I->inter, n,
				(ba0_new_function*)&bad_new_regchain);
}

BAD_DLL void bad_set_intersectof_regchain_regchain
		(bad_intersectof_regchain I, bad_regchain ideal)
{
    bad_set_attchain (&I->attrib, &ideal->attrib);
    bad_realloc_intersectof_regchain (I, 1);
    if (I->inter.tab [0] != ideal)
	bad_set_regchain (I->inter.tab [0], ideal);
    I->inter.size = 1;
}

/*
 * It is assumed that the properties of I are compatible with those
 * of ideal. The prime structural property is cleared.
 */

BAD_DLL void bad_append_intersectof_regchain_regchain
		(bad_intersectof_regchain I, bad_regchain ideal)
{
    if (I->inter.size == 0)
	bad_set_intersectof_regchain_regchain (I, ideal);
    else
    {	bad_realloc_intersectof_regchain (I, I->inter.size + 1);
	if (! ba0_member_table (ideal, (ba0_table)&I->inter))
	{   bad_intersect_attchain (&I->attrib, &ideal->attrib);
	    bad_set_regchain (I->inter.tab [I->inter.size++], ideal);
	}
    }
}

/*
 * I = append (I, K)
 */

BAD_DLL void bad_append_intersectof_regchain
		(bad_intersectof_regchain I, bad_intersectof_regchain J)
{
    ba0_int_p i;

    if (I != J)
    {	bad_realloc_intersectof_regchain (I, I->inter.size + J->inter.size);
	for (i = 0; i < J->inter.size; i++)
	    bad_append_intersectof_regchain_regchain (I, J->inter.tab [i]);
    }
}

/*
 * Sets I to J.
 */

BAD_DLL void bad_set_intersectof_regchain 
		(bad_intersectof_regchain I, bad_intersectof_regchain J)
{   ba0_int_p i;

    if (I != J)
    {	bad_set_attchain (&I->attrib, &J->attrib);
	I->inter.size = 0;
	bad_realloc_intersectof_regchain (I, J->inter.size);
	for (i = 0; i < J->inter.size; i++)
	    bad_set_regchain (I->inter.tab [i], J->inter.tab [i]);
	I->inter.size = J->inter.size;
    }
}

BAD_DLL void bad_set_properties_intersectof_regchain
			(bad_intersectof_regchain I, ba0_tableof_string P)
{
    bad_set_properties_attchain (&I->attrib, P);
}

BAD_DLL void bad_remove_redundant_components_intersectof_regchain
		(bad_intersectof_regchain I, bad_intersectof_regchain J)
{   ba0_int_p i, k;
    bool found;

    if (I != J)
    {	bad_set_attchain (&I->attrib, &J->attrib);
	I->inter.size = 0;
	bad_realloc_intersectof_regchain (I, J->inter.size);
	for (i = 0; i < J->inter.size; i++)
	{   found = false;
	    for (k = 0; k < J->inter.size && !found; k++)
		found = i != k &&
			bad_is_included_regchain 
				(J->inter.tab [k], J->inter.tab [i]) == 
						bad_inclusion_test_positive;
	    if (!found)
	        bad_append_intersectof_regchain_regchain (I, J->inter.tab [i]);
	}
    } else
    {   for (i = J->inter.size - 1; i >= 0; i--)
	{   found = false;
	    for (k = 0; k < J->inter.size && !found; k++)
		found = i != k &&
			bad_is_included_regchain
				(J->inter.tab [k], J->inter.tab [i]) ==
						bad_inclusion_test_positive;
	    if (found)
		ba0_delete_table ((ba0_table)&J->inter, i);
	}
    }
}

void bad_fast_primality_test_intersectof_regchain 
					(bad_intersectof_regchain ideal)
{   ba0_int_p i;

    for (i = 0; i < ideal->inter.size; i++)
	bad_fast_primality_test_regchain (ideal->inter.tab [i]);
}

BAD_DLL void* bad_scanf_intersectof_regchain (void* I)
{   bad_intersectof_regchain ideal;
    ba0_tableof_string P;
    ba0_int_p i, differentiel;

    if (I == (void*)0)
	ideal = bad_new_intersectof_regchain ();
    else
	ideal = (bad_intersectof_regchain)I;

    P = (ba0_tableof_string)ba0_new_table ();
    ba0_scanf 
	("intersectof_regchain (%t[%regchain], %t[%s])", &ideal->inter, P);

    bad_set_properties_attchain (&ideal->attrib, P);

    differentiel = 0;
    if (bad_defines_a_differential_ideal_attchain (&ideal->attrib))
	differentiel++;
    for (i = 0; i < ideal->inter.size; i++)
	if (bad_defines_a_differential_ideal_attchain 
					(&ideal->inter.tab [i]->attrib))
	    differentiel++;
    if (differentiel > 0 && differentiel < 1 + ideal->inter.size)
	BA0_RAISE_EXCEPTION (BAD_ERRIRC);

    if (bad_defines_a_prime_ideal_attchain (&ideal->attrib))
    {	if (ideal->inter.size > 1)
	    BA0_RAISE_EXCEPTION (BAD_ERRIRC);
	else if (ideal->inter.size == 1 && 
		 ! bad_defines_a_prime_ideal_attchain 
					(&ideal->inter.tab [0]->attrib))
	    BA0_RAISE_EXCEPTION (BAD_ERRIRC);
    }

    return ideal;
}

BAD_DLL void* bad_scanf_intersectof_pretend_regchain (void* I)
{   bad_intersectof_regchain ideal;
    ba0_tableof_string P;
    ba0_int_p i, differentiel;

    if (I == (void*)0)
	ideal = bad_new_intersectof_regchain ();
    else
	ideal = (bad_intersectof_regchain)I;

    P = (ba0_tableof_string)ba0_new_table ();
    ba0_scanf 
	("intersectof_regchain (%t[%pretend_regchain], %t[%s])", 
	 &ideal->inter, P);

    bad_set_properties_attchain (&ideal->attrib, P);

    differentiel = 0;
    if (bad_defines_a_differential_ideal_attchain (&ideal->attrib))
	differentiel++;
    for (i = 0; i < ideal->inter.size; i++)
	if (bad_defines_a_differential_ideal_attchain 
					(&ideal->inter.tab [i]->attrib))
	    differentiel++;
    if (differentiel > 0 && differentiel < 1 + ideal->inter.size)
	BA0_RAISE_EXCEPTION (BAD_ERRIRC);

    if (bad_defines_a_prime_ideal_attchain (&ideal->attrib))
    {	if (ideal->inter.size > 1)
	    BA0_RAISE_EXCEPTION (BAD_ERRIRC);
	else if (ideal->inter.size == 1 && 
		 ! bad_defines_a_prime_ideal_attchain 
					(&ideal->inter.tab [0]->attrib))
	    BA0_RAISE_EXCEPTION (BAD_ERRIRC);
    }

    return ideal;
}

BAD_DLL void bad_printf_intersectof_regchain (void* I)
{   bad_intersectof_regchain ideal = (bad_intersectof_regchain)I;
    ba0_tableof_string P;
    struct ba0_mark M;

    ba0_record (&M);
    P = (ba0_tableof_string)ba0_new_table ();
    bad_structural_properties_attchain (P, &ideal->attrib);
    bad_desired_properties_attchain (P, &ideal->attrib);
    ba0_printf 
	("intersectof_regchain (%t[%regchain], %t[%s])", &ideal->inter, P);
    ba0_restore (&M);
}

BAD_DLL void bad_printf_intersectof_regchain_equations (void* I)
{   bad_intersectof_regchain ideal = (bad_intersectof_regchain)I;

    ba0_printf
        ("%t[%regchain_equations]", &ideal->inter);
}

/*
 * Readonly static data
 */

static char _struct_intersect [] = "bad_intersectof_regchain";
static char _struct_intersect_tab [] = "bad_intersectof_regchain->inter.tab";

BAD_DLL ba0_int_p bad_garbage1_intersectof_regchain 
				(void* I, enum ba0_garbage_code code)
{   bad_intersectof_regchain ideal = (bad_intersectof_regchain)I;
    ba0_int_p i, n = 0;

    if (code == ba0_isolated)
	n += ba0_new_gc_info 
		(ideal, sizeof(struct bad_intersectof_regchain), 
		_struct_intersect);

    if (ideal->inter.alloc > 0)
    {	n += ba0_new_gc_info 
		(ideal->inter.tab,
		 ideal->inter.alloc * sizeof(bad_regchain),
		 _struct_intersect_tab);
	for (i = 0; i < ideal->inter.alloc; i++)
	    n += bad_garbage1_regchain (ideal->inter.tab [i], ba0_isolated);
    }

    return n;
}

BAD_DLL void* bad_garbage2_intersectof_regchain 
				(void* I, enum ba0_garbage_code code)
{   bad_intersectof_regchain ideal;
    ba0_int_p i;

    if (code == ba0_isolated)
	ideal = (bad_intersectof_regchain)ba0_new_addr_gc_info
						(I,_struct_intersect);
    else
	ideal = (bad_intersectof_regchain)I;

    if (ideal->inter.alloc > 0)
    {	ideal->inter.tab = (bad_regchain*)ba0_new_addr_gc_info
		(ideal->inter.tab, _struct_intersect_tab);
	for (i = 0; i < ideal->inter.alloc; i++)
	    ideal->inter.tab [i] = 
		bad_garbage2_regchain (ideal->inter.tab [i], ba0_isolated);
    }

    return ideal;
}

BAD_DLL void* bad_copy_intersectof_regchain (void* I)
{   bad_intersectof_regchain ideal;

    ideal = bad_new_intersectof_regchain ();
    bad_set_intersectof_regchain (ideal, (bad_intersectof_regchain)I);
    return ideal;
}

