#include "bad_nonzero.h"
#include "bad_global.h"
#include "bad_base_field.h"

BAD_DLL void bad_set_settings_nonzero 
				(bad_nonzero_function* function, void* data)
{
    bad_nonzero = function ? function : &bad_nonzero_default;
    bad_nonzero_data = data ? data : (void*)0;
}

BAD_DLL void bad_get_settings_nonzero 
				(bad_nonzero_function** function, void** data)
{
    if (function) *function = bad_nonzero;
    if (data) *data = bad_nonzero_data;
}

BAD_DLL bool bad_nonzero_default (bap_polynom_mpz A)
{
    return bap_is_independent_polynom_mpz (A) && ! bap_is_zero_polynom_mpz (A);
}

/*
 * bad_nonzero_data is assumed to contain a table of algebraically
 * independent variables. Returns true if A only depends on independent
 * variables and/or elements of bad_nonzero_data.
 */

BAD_DLL bool bad_nonzero_tabvars (bap_polynom_mpz A)
{   bav_tableof_variable T = (bav_tableof_variable)bad_nonzero_data;
    enum bav_typeof_symbol type;
    ba0_int_p i;
    bool nzero;

    if (bap_is_numeric_polynom_mpz (A))
	return ! bap_is_zero_polynom_mpz (A);

    nzero = true;
    for (i = 0; nzero && i < A->rang_total.size; i++)
    {	type = bav_symbol_type_variable (A->rang_total.rg [i].var);
	if (type != bav_independent_symbol &&
		! ba0_member_table (A->rang_total.rg [i].var, (ba0_table)T))
	    nzero = false;
    }

    return nzero;
}

/*
 * Use only if the regchain to be computed has the autoreduced property
 * Returns true if A lies in the base field defined by bad_nonzero_data
 */

BAD_DLL bool bad_nonzero_reduced_polynom_base_field (bap_polynom_mpz A)
{   bad_base_field K = (bad_base_field)bad_nonzero_data;

    return bad_member_reduced_nonzero_polynom_base_field (A, K);
}

/*
 * Can always be used.
 * Returns true if A lies in the base field defined by bad_nonzero_data
 */

BAD_DLL bool bad_nonzero_polynom_base_field (bap_polynom_mpz A)
{   bad_base_field K = (bad_base_field)bad_nonzero_data;

    return bad_member_nonzero_polynom_base_field (A, K);
}

