#include "bad_nonzero.h"
#include "bad_reduction.h"
#include "bad_regularize.h"
#include "bad_quadruple.h"
#include "bad_pardi.h"
#include "bad_global.h"
#include "bad_stats.h"

static void bad_pardi_set_quadruple_regchain (bad_quadruple, bad_regchain);
static void bad_first_zero_factor_mod_regchain
			(bap_polynom_mpz, bap_product_mpz, bad_regchain);
static void bad_ensure_rank (bap_polynom_mpz, bad_quadruple, bad_regchain);

BAD_DLL void bad_pardi (bad_regchain Cbar, bav_Iordering rbar, bad_regchain C)
{   enum bad_typeof_reduction type_red;
    bad_tableof_quadruple tabG;
    bad_quadruple G;
    bad_intersectof_regchain tabCbar;
    struct bap_product_mpz prod;
    struct bap_tableof_polynom_mpz ineqs;
    struct bap_tableof_product_mpz factored_ineqs;
    struct bap_tableof_tableof_polynom_mpz tabV;
    struct bap_tableof_polynom_mpz V;
    struct bap_polynom_mpz p;
    bav_variable v;
    ba0_int_p  k, counter, choice;
    struct ba0_mark M;

    bad_init_stats (0);
    bad_stats_data.begin = time (0);

    ba0_push_another_stack ();
    ba0_record (&M);

    bav_R_push_ordering (rbar);
/*
   tabG is a table containing a unique quadruple : G.
   G is initialized to < [], [], C, H_C w.r.t. the ordering of C >
   The structural property of G->A are that of C (not primality !)
   The desired property of G->A are that of Cbar.
*/
    tabG = (bad_tableof_quadruple)ba0_new_table ();
    ba0_realloc2_table 
		((ba0_table)tabG, 1, (ba0_new_function*)&bad_new_quadruple);
    tabG->size = 1;

    G = tabG->tab [0];

    G->A.attrib.desired_property = Cbar->attrib.desired_property;
    if (bad_defines_a_differential_ideal_regchain (C))
    {	bad_set_structural_property_attchain 
			(&G->A.attrib, bad_differential_structural_property);
	bad_set_desired_property_attchain
			(&G->A.attrib, bad_squarefree_desired_property);
    }
    bad_pardi_set_quadruple_regchain (G, C);
/*
   Working variables
*/
    bap_init_product_mpz (&prod);
    ba0_init_table ((ba0_table)&ineqs);
    ba0_init_table ((ba0_table)&factored_ineqs);
    ba0_init_table ((ba0_table)&tabV);
    ba0_realloc_table ((ba0_table)&tabV, 1);
    tabV.tab [0] = &V;
    tabV.size = 1;
    ba0_init_table ((ba0_table)&V);
    bap_init_polynom_mpz (&p);
    type_red = bad_defines_a_differential_ideal_regchain (C) ? 
				bad_full_reduction : bad_algebraic_reduction;
/*
   Loop while a critical pair or a polynomial is waiting for being processed
*/
    counter = 0;
    choice = 0;
    bad_easy_criterion_penalty = 2;
    while (! bad_is_a_listof_rejected_critical_pair (G->D) || 
					G->P != (bap_listof_polynom_mpz)0)
    {   bad_critical_pair pair;
/*
   One picks a new equation (from P or a Delta-polynomial from D).
   One reduces it (here, fully) w.r.t. A.
   The reduction process outputs a product of factors.
   At least one of the factors lies in ideal (C). 
   One sets p to any of them and one ensures that the initial and the 
	separant of p does not lie in ideal (C).
 */
	counter += 1;
	bad_pick_and_remove_quadruple (&p, G, &pair, choice);
/*
   If the reduction to zero test is deterministic, we may as well
   skip it since we are going to reduce p anyway.

   If it is probabilistic, it is better to perform it before
   the reduction.
 */
	if (bad_redzero_strategy == bad_probabilistic_redzero_strategy)
	{   if (bad_is_a_reduced_to_zero_polynom_by_regchain 
						(&p, &G->A, type_red))
	    {	bad_stats_data.reductions_to_zero += 1;
	        continue;
	    }
	}

	bad_reduce_polynom_by_regchain 
				(&prod, (bap_product_mpz)0, &p, &G->A, 
				 type_red, bad_all_derivatives_to_reduce);
	bad_preprocess_equation (&prod, &ineqs, &factored_ineqs, G);
	bad_report_simplification_of_inequations
				(tabG, &ineqs, &factored_ineqs);
	if (tabG->size != 1)
	    BA0_RAISE_EXCEPTION (BA0_ERRALG);
	bad_first_zero_factor_mod_regchain (&p, &prod, C);
	bad_ensure_rank (&p, G, C);

	if (bap_is_zero_polynom_mpz (&p))
	{   bad_stats_data.reductions_to_zero += 1;
	    continue;
	}
/*
 * Some critical pairs would be discarded by the easy criterion
 * but give interesting nonzero polynomials. Since it happens
 * at the beginning of the computations, the penalty for some
 * pairs is increased.
 */
	if (pair && pair->tag != bad_normal_critical_pair)
	{   
	    bad_easy_criterion_penalty *= 2;
	}

	if ((*bad_nonzero) (&p))
	    BA0_RAISE_EXCEPTION (BA0_ERRALG);
	v = bap_leader_polynom_mpz (&p);

	if (! bad_is_leader_of_regchain (v, &G->A, &k))
	    bad_complete_quadruple (tabG, &p, C);
	else
	{    
	     bad_Euclid_mod_regchain (&tabV, tabG, bad_basic_Euclid, 
					G->A.decision_system.tab [k], &p, v, 
					true, true, 
					C, (bap_polynom_mpz*)0);
/*
   Completion only if the gcd is different from the element of A.
   Observe that the gcd is always different from the element of A when
	full reduction is performed.
*/
	    if (bap_leading_degree_polynom_mpz (V.tab [0]) !=
		bap_leading_degree_polynom_mpz (G->A.decision_system.tab [k]))
			bad_complete_quadruple (tabG, V.tab [0], C);
	}
    }
/*
   G = < A, [], [], S > and A = 0, S <> 0 is a regular differential system.
   One performs reg_characteristic.

   tabCbar is allocated in the working stack.
   This is not a problem for ideal (C) is prime hence no splittings will occur.
*/
    tabCbar = bad_new_intersectof_regchain ();
    ba0_realloc_table ((ba0_table)&tabCbar->inter, 1);
    tabCbar->inter.tab [0] = Cbar;
    tabCbar->inter.size = 0;
/*
   The structural properties of Cbar are inherited from C (even primality
	this time).
*/
    ba0_pull_stack ();

    bad_stats_data.end = time (0);

    bad_reg_characteristic_quadruple (tabCbar, G, C);
    Cbar->attrib.structural_property = C->attrib.structural_property;
    if (bad_defines_a_differential_ideal_regchain (Cbar))
	bad_set_desired_property_attchain 
			(&Cbar->attrib, bad_coherence_desired_property);

    ba0_restore (&M);
    bav_R_pull_ordering ();
}

/*
   Stores C in P and H_C (or I_C in the algebraic case) taken w.r.t. the
	ordering of C in S.

   The current ordering is rbar.
*/

static void bad_pardi_set_quadruple_regchain (bad_quadruple G, bad_regchain C)
{   struct bap_polynom_mpz pbar, init, sep;
    ba0_int_p i;

    bap_init_readonly_polynom_mpz (&pbar);

    bap_init_readonly_polynom_mpz (&init);
    if (bad_defines_a_differential_ideal_regchain (C))
	bap_init_polynom_mpz (&sep);

    for (i = 0; i < C->decision_system.size; i++)
    {	bap_sort_polynom_mpz (&pbar, C->decision_system.tab [i]);
	G->P = bad_insert_in_listof_polynom_mpz (&pbar, G->P);

	bav_R_push_ordering (C->attrib.ordering);

	bap_initial_polynom_mpz (&init, C->decision_system.tab [i]);
	if (! (*bad_nonzero) (&init))
	{   bav_R_pull_ordering ();
	    bap_sort_polynom_mpz (&pbar, &init);
	    bad_simplify_and_store_in_S_quadruple (G, &pbar);
	    bav_R_push_ordering (C->attrib.ordering);
	} 

	if (bad_defines_a_differential_ideal_regchain (C) &&
	    bap_leading_degree_polynom_mpz (C->decision_system.tab [i]) > 1)
	{   bap_separant_polynom_mpz (&sep, C->decision_system.tab [i]);
	    bav_R_pull_ordering ();    
	    bap_sort_polynom_mpz (&pbar, &sep);
	    bad_simplify_and_store_in_S_quadruple (G, &pbar);
	    bav_R_push_ordering (C->attrib.ordering);
	}

	bav_R_pull_ordering ();
    }
}

/*
   Sets p to the first factor of prod which is zero mod C.
*/

static void bad_first_zero_factor_mod_regchain 
		(bap_polynom_mpz p, bap_product_mpz prod, bad_regchain C)
{   enum bad_typeof_reduction type_red;
    ba0_int_p i;
    bool found;

    type_red = bad_defines_a_differential_ideal_regchain (C) ? 
				bad_full_reduction : bad_algebraic_reduction;

    if (bap_is_zero_product_mpz (prod))
	bap_set_polynom_zero_mpz (p);
    else 
    {	found = false;
	i = 0; 
	while (i < prod->size - 1 && ! found)
	{   if (! (*bad_nonzero) (&prod->tab [i].factor))
		found = bad_is_a_reduced_to_zero_polynom_by_regchain 
					(&prod->tab [i].factor, C, type_red);
	    if (! found)
		i++;
	}
	bap_set_polynom_mpz (p, &prod->tab [i].factor);
    }
}

/*
   If i_p is zero mod C then p := reductum (p)
   else if s_p is zero mod C then p := prem (p, s_p)

   If something is zero mod C but not mod A then it is stored in P.
*/

static void bad_ensure_rank (bap_polynom_mpz p, bad_quadruple G, bad_regchain C)
{   enum bad_typeof_reduction type_red;
    struct bap_polynom_mpz init, sep;
    bool rankfall;
    struct ba0_mark M;
    
    ba0_push_another_stack ();
    ba0_record (&M);

    bap_init_readonly_polynom_mpz (&init);
    if (bad_defines_a_differential_ideal_regchain (&G->A))
    {	bap_init_polynom_mpz (&sep);
	type_red = bad_full_reduction;
    } else if (bad_has_desired_property_attchain
			(&G->A.attrib, bad_squarefree_desired_property))
    {	bap_init_polynom_mpz (&sep);
	type_red = bad_algebraic_reduction;
    } else
	type_red = bad_algebraic_reduction;
    

    rankfall = true;
    while (rankfall)
    {   rankfall = false;
	if (bap_is_zero_polynom_mpz (p) || (*bad_nonzero) (p))
	    continue;
	bap_initial_polynom_mpz (&init, p);
	if (bad_is_a_reduced_to_zero_polynom_by_regchain (&init, C, type_red))
	{   if (! bad_is_a_reduced_to_zero_polynom_by_regchain 
						(&init, &G->A, type_red))
	    {	ba0_pull_stack ();
		bad_simplify_and_store_in_P_quadruple (G, &init);
		ba0_push_another_stack ();
	    }
	    ba0_pull_stack ();
	    bap_reductum_polynom_mpz (p, p);
	    ba0_push_another_stack ();
	    rankfall = true;
	} else if ((bad_defines_a_differential_ideal_regchain (&G->A) ||
		    bad_has_desired_property_attchain 
			(&G->A.attrib, bad_squarefree_desired_property)) && 
		   bap_leading_degree_polynom_mpz (p) > 1)
	{   bap_separant_polynom_mpz (&sep, p);
	    if (bad_is_a_reduced_to_zero_polynom_by_regchain 
							(&sep, C, type_red))
	    {	if (! bad_is_a_reduced_to_zero_polynom_by_regchain 
						(&sep, &G->A, type_red))
		{   ba0_pull_stack ();
		    bad_simplify_and_store_in_P_quadruple (G, &sep);
		    ba0_push_another_stack ();
		}
		ba0_pull_stack ();
		bap_prem_polynom_mpz 
			(p, (bav_Idegree*)0, p, &sep, BAV_NOT_A_VARIABLE);
		ba0_push_another_stack ();
		rankfall = true;
	    }
	}
    }

    ba0_pull_stack ();

    if (! bap_is_zero_polynom_mpz (p))
    {	bad_simplify_and_store_in_S_quadruple (G, &init);
	if ((bad_defines_a_differential_ideal_regchain (&G->A) ||
	     bad_has_desired_property_attchain
                        (&G->A.attrib, bad_squarefree_desired_property)) &&
	    bap_leading_degree_polynom_mpz (p) > 1)
		bad_simplify_and_store_in_S_quadruple (G, &sep);
    }

    ba0_restore (&M);
}

