#include "bad_position.h"

BAD_DLL void bad_init_position (bad_position pos)
{
    pos->index = 0;
    pos->number = 0;
    pos->type = bad_none_case;
}

BAD_DLL bad_position bad_new_position (void)
{   bad_position pos;

    pos = (bad_position)ba0_alloc (sizeof (struct bad_position));
    bad_init_position (pos);
    return pos;
}

BAD_DLL void bad_set_position (bad_position pos, bad_position qos)
{
    *pos = *qos;
}

BAD_DLL void bad_set_position_values 
	(bad_position pos, enum bad_typeof_case type, 
	 ba0_int_p index, ba0_int_p number)
{
    pos->type = type;
    pos->index = index;
    pos->number = number;
}

/*
 * readonly data
 */

static struct {
    enum bad_typeof_case type;
    char* ident;
} bad_cases [] =
{ { bad_none_case, "N" },
  { bad_first_case, "I" },
  { bad_factor_case, "F" },
  { bad_regularisation_case, "R" },
  { bad_splitting_case, "S" },
  { bad_euclid_case, "E" }
};

BAD_DLL void* bad_scanf_position (void* A)
{   bad_position pos;
    ba0_int_p i;
    char buffer [BA0_BUFSIZE];
    bool found;

    if (A == (void*)0)
	pos = bad_new_position ();
    else
	pos = (bad_position)A;

    ba0_scanf ("%s %d/%d", buffer, &pos->index, &pos->number);
    pos->index -= 1;
    pos->number -= 1;

    found = false;
    i = 0; 
    while (!found && i < sizeof (bad_cases) / sizeof (bad_cases [0]))
    {	found = ba0_strcasecmp (buffer, bad_cases [i].ident) == 0;
	if (! found)
	    i += 1;
    }

    if (found)
	pos->type = bad_cases [i].type;
    else
	BA0_RAISE_PARSER_EXCEPTION (BA0_ERRSYN);

    return pos;
}

BAD_DLL void bad_printf_position (void* A)
{   bad_position pos = (bad_position)A;
    ba0_int_p i;
    bool found;

    i = 0;
    found = false;
    while (!found && i < sizeof (bad_cases) / sizeof (bad_cases [0]))
    {	found = pos->type == bad_cases [i].type;
        if (! found)
            i += 1;
    }

    if (! found)
	BA0_RAISE_EXCEPTION (BA0_ERRALG);

    ba0_printf ("%s %d/%d", bad_cases [i].ident, pos->index+1, pos->number+1);
}

static char _struct_position [] = "struct bad_position";

BAD_DLL ba0_int_p bad_garbage1_position (void* A, enum ba0_garbage_code code)
{   bad_position pos = (bad_position)A;
    ba0_int_p n = 0;

    if (code == ba0_isolated)
        n += ba0_new_gc_info
                (pos, sizeof(struct bad_position), _struct_position);
    return n;
}

BAD_DLL void* bad_garbage2_position (void* A, enum ba0_garbage_code code)
{   bad_position pos;

    if (code == ba0_isolated)
        pos = (bad_position)ba0_new_addr_gc_info (A, _struct_position);
    else
        pos = (bad_position)A;

    return pos;
}

BAD_DLL void* bad_copy_position (void* A)
{   bad_position pos;

    pos = bad_new_position ();
    bad_set_position (pos, (bad_position)A);
    return pos;
}

BAD_DLL void bad_realloc_tableof_position (bad_tableof_position T, ba0_int_p n)
{
    ba0_realloc2_table ((ba0_table)T, n,
			(ba0_new_function*)&bad_new_position);
}

BAD_DLL void bad_set_tableof_position
                        (bad_tableof_position T, bad_tableof_position U)
{   ba0_int_p i;

    if (T != U)
    {	bad_realloc_tableof_position (T, U->size);
    	for (i = 0; i < U->size; i++)
	    bad_set_position (T->tab [i], U->tab [i]);
        T->size = U->size;
    }
}

BAD_DLL void bad_append_tableof_position
			(bad_tableof_position T, bad_tableof_position U,
			 enum bad_typeof_case type,
			 ba0_int_p index, ba0_int_p number)
{
    bad_realloc_tableof_position (T, U->size + 1);
    bad_set_tableof_position (T, U);
    T->tab [T->size]->type = type;
    T->tab [T->size]->index = index;
    T->tab [T->size]->number = number;
    T->size += 1;
}
