#include "bad_nonzero.h"
#include "bad_reduction.h"
#include "bad_regularize.h"
#include "bad_quadruple.h"
#include "bad_global.h"
#include "bad_stats.h"

BAD_DLL void bad_init_quadruple (bad_quadruple G)
{
    bad_init_regchain (&G->A);
    G->D = (bad_listof_critical_pair)0;
    G->P = G->S = (bap_listof_polynom_mpz)0;
    ba0_init_table ((ba0_table)&G->pos);
}

BAD_DLL bad_quadruple bad_new_quadruple (void)
{   bad_quadruple G;

    G = (bad_quadruple)ba0_alloc (sizeof (struct bad_quadruple));
    bad_init_quadruple (G);
    return G;
}

BAD_DLL void bad_set_quadruple (bad_quadruple P, bad_quadruple Q)
{
    bad_set_regchain (&P->A, &Q->A);
    P->D = (bad_listof_critical_pair)ba0_copy ("%l[%critic]", Q->D);
    P->P = (bap_listof_polynom_mpz)ba0_copy ("%l[%Az]", Q->P);
    P->S = (bap_listof_polynom_mpz)ba0_copy ("%l[%Az]", Q->S);
    bad_set_tableof_position (&P->pos, &Q->pos);
}

BAD_DLL void* bad_scanf_quadruple (void* A)
{   bad_quadruple G;

    if (A == (void*)0)
	G = bad_new_quadruple ();
    else
	G = (bad_quadruple)A;

    ba0_scanf 
	("quadruple (%regchain, D = %l[%critic], P = %l[%Az], S = %l[%Az], %t[%position])",
	 &G->A, &G->D, &G->P, &G->S, &G->pos);

    return G;
}

BAD_DLL void bad_printf_quadruple (void* A)
{   bad_quadruple G = (bad_quadruple)A;

    ba0_printf 
	("quadruple (%regchain,\nD = %l[\n%critic],\nP = %l[%Az],\nS = %l[%Az],\n%t[%position])",
	 &G->A, G->D, G->P, G->S, &G->pos);
}

/*
 * Readonly static data
 */

static char _struct_quadruple [] = "struct bad_quadruple";

BAD_DLL ba0_int_p bad_garbage1_quadruple (void* A, enum ba0_garbage_code code)
{   bad_quadruple G = (bad_quadruple)A;
    ba0_int_p n = 0;

    if (code == ba0_isolated)
	n += ba0_new_gc_info 
		(G, sizeof(struct bad_quadruple), _struct_quadruple);
	
    n += bad_garbage1_regchain (&G->A, ba0_embedded);
    n += ba0_garbage1 ("%l[%critic]", G->D, ba0_isolated);
    n += ba0_garbage1 ("%l[%Az]", G->P, ba0_isolated);
    n += ba0_garbage1 ("%l[%Az]", G->S, ba0_isolated);
    n += ba0_garbage1 ("%t[%position]", &G->pos, ba0_embedded);

    return n;
}

BAD_DLL void* bad_garbage2_quadruple (void* A, enum ba0_garbage_code code)
{   bad_quadruple G;

    if (code == ba0_isolated)
	G = (bad_quadruple)ba0_new_addr_gc_info (A, _struct_quadruple);
    else
	G = (bad_quadruple)A;

    bad_garbage2_regchain (&G->A, ba0_embedded);
    G->D = ba0_garbage2 ("%l[%critic]", G->D, ba0_isolated);
    G->P = ba0_garbage2 ("%l[%Az]", G->P, ba0_isolated);
    G->S = ba0_garbage2 ("%l[%Az]", G->S, ba0_isolated);
    ba0_garbage2 ("%t[%position]", &G->pos, ba0_embedded);

    return G;
}

BAD_DLL void* bad_copy_quadruple (void* A)
{   bad_quadruple G;

    G = bad_new_quadruple ();
    bad_set_quadruple (G, (bad_quadruple)A);
    return G;
}

/*
 * Returns true if G corresponds to a first case quadruple
 */

BAD_DLL bool bad_first_case_quadruple (bad_quadruple G)
{
    if (G->pos.size == 0)
	BA0_RAISE_EXCEPTION (BA0_ERRALG);
    return G->pos.tab [G->pos.size - 1]->type == bad_first_case;
}

/*
 * L is either the list P or the list S of some quadruple.
 * Inserts a copy of the polynomial p in L.
 * If p is already present in L, it is not duplicated.
 * 
 * The systematic use of this function keeps the lists sorted.
 */

BAD_DLL bap_listof_polynom_mpz bad_insert_in_listof_polynom_mpz
                        (bap_polynom_mpz p, bap_listof_polynom_mpz L)
{   bap_listof_polynom_mpz R, cour, prec, cons;
    ba0_int_p nbmon_p, nbmon_c;
    bool forget, found;

    nbmon_p = bap_nbmon_polynom_mpz (p);

    found = false;
    forget = false;

    prec = (bap_listof_polynom_mpz)0;
    cour = L;
    while (cour != (bap_listof_polynom_mpz)0 && !found && !forget)
    {   nbmon_c = bap_nbmon_polynom_mpz (cour->value);
        if (nbmon_p < nbmon_c)
            found = true;
        else if (nbmon_p == nbmon_c)
        {   if (bap_lt_rank_polynom_mpz (p, cour->value))
                found = true;
            else if (bap_equal_polynom_mpz (p, cour->value))
                forget = true;
        }
        if (!found && !forget)
        {   prec = cour;
            cour = cour->next;
        }
    }
/*
 * forget = true means that p is already present. Just forget it.
 * Otherwise, a new cons should be inserted in front of cour.
 */
    if (!forget)
    {   cons = (bap_listof_polynom_mpz)ba0_alloc
                        (sizeof (struct bap_listof_polynom_mpz));
        cons->next = cour;
        cons->value = (bap_polynom_mpz)bap_copy_polynom_mpz (p);
/*
 * Insertion at the beginning of the list ?
 */
        if (prec == (bap_listof_polynom_mpz)0)
            R = cons;
        else
        {   prec->next = cons;
            R = L;
        }
    } else
	R = L;
    return R;
}

/*
 * The list L should be the list P of S of some quadruple.
 * 
 * Removes p from the list L.
 *
 * The bool *deletion is set to true if p was found, else false.
 * The parameter deletion may be zero.
 */

BAD_DLL bap_listof_polynom_mpz bad_delete_from_listof_polynom_mpz
		(bap_polynom_mpz p, bap_listof_polynom_mpz L, bool* deletion)
{   bap_listof_polynom_mpz prec, cour, R;
    bool found;

    found = false;

    prec = (bap_listof_polynom_mpz)0;
    cour = L;
    while (cour != (bap_listof_polynom_mpz)0 && !found)
    {   found = bap_equal_polynom_mpz (p, cour->value);
	if (!found)
	{   prec = cour;
	    cour = cour->next;
	}
    }
/*
 * found = p is equal to cour->value
 */
    if (!found)
    {	if (deletion)
	    *deletion = false;
	R = L;
    } else 
    {   if (deletion)
	    *deletion = true;
/*
 * Deletion of the first element ?
 */
	if (prec == (bap_listof_polynom_mpz)0)
	    R = L->next;
	else
	{   prec->next = cour->next;
	    R = L;
	}
    }
    return R;
}

/*
 * Simplifies A using the inequations of the current quadruple G.
 *
 * Every exhibited simplification of any inequation is reported in
 * ineqs and factored_ineqs.
 */

BAD_DLL void bad_preprocess_equation
	(bap_product_mpz A, bap_tableof_polynom_mpz ineqs, 
	 bap_tableof_product_mpz factored_ineqs, bad_quadruple G)
{   
    struct bap_product_mpz prod, prod_gcd;
    struct bap_tableof_polynom_mpz polys;
    bap_listof_polynom_mpz S;
    struct bap_polynom_mpz gcd, cof;
    struct ba0_mark M;
    ba0_int_p i, length;
    bool removed, already_stored;

    ba0_reset_table ((ba0_table)ineqs);
    ba0_reset_table ((ba0_table)factored_ineqs);

    if (bap_is_numeric_product_mpz (A))
    {	if (! bap_is_zero_product_mpz (A))
	    ba0_mpz_set_si (A->num_factor, 1);
	return;
    }

    length = ba0_length_list ((ba0_list)G->S);
    ba0_realloc_table ((ba0_table)ineqs, length);
    ba0_realloc2_table ((ba0_table)factored_ineqs, length,
			(ba0_new_function*)&bap_new_product_mpz);

    ba0_push_another_stack ();
    ba0_record (&M);

    bap_init_product_mpz (&prod);
    bap_set_product_mpz (&prod, A);

    ba0_mpz_set_si (prod.num_factor, 1);

    ba0_init_table ((ba0_table)&polys);
    ba0_realloc_table ((ba0_table)&polys, 2);

    bap_init_product_mpz (&prod_gcd);
    bap_init_polynom_mpz (&gcd);
    bap_init_polynom_mpz (&cof);

    i = 0;
    while (i < prod.size)
    {	
/*
 * removed = the ith component of the product is removed (it corresponds
 *           to a polynomial which cannot vanish).
 */
	if ((*bad_nonzero) (&prod.tab [i].factor))
	{   BA0_SWAP (struct bap_polynom_mpz, prod.tab [i].factor,
			 prod.tab [prod.size - 1].factor);
	    prod.size -= 1;
	    removed = true;
	} else
	{   
	    removed = false;
	    S = G->S;
	    already_stored = false;
	    while (!removed && S != (bap_listof_polynom_mpz)0)
	    {
		polys.tab [0] = &prod.tab [i].factor;
		polys.tab [1] = S->value;
		polys.size = 2;
		bap_gcd_tableof_polynom_mpz (&prod_gcd, &polys, false);
		if (! bap_is_numeric_product_mpz (&prod_gcd))
		{	
/*
 * Non-trivial gcd between the ith component and the current inequation.
 * Factor the gcd out. May lead to a component that should be removed.
 */
		    bap_expand_product_mpz (&gcd, &prod_gcd);
		    bap_exquo_polynom_mpz 
			    (&prod.tab [i].factor, &prod.tab [i].factor, &gcd);
		    removed = (*bad_nonzero) (&prod.tab [i].factor);
		    if (! already_stored && 
			    (prod_gcd.size > 1 ||
			     ! bap_equal_polynom_mpz (S->value, &gcd)))
		    {   
/*
 * The non-trivial gcd is also a non-trivial factor of the current inequation.
 * Simplifies the inequations.
 */
			bap_exquo_polynom_mpz (&cof, S->value, &gcd);

			ba0_pull_stack ();

			ineqs->tab [ineqs->size] = S->value;
			bap_mul_product_polynom_mpz
				(factored_ineqs->tab [factored_ineqs->size], 
				 &prod_gcd, &cof, 1);

			ineqs->size += 1;
			factored_ineqs->size += 1;

			ba0_push_another_stack ();
			already_stored = true;
		    }
		} else
		{   S = S->next;
		    already_stored = false;
		}
	    } 
	}
	if (!removed)
	{   prod.tab [i].exponent = 1;
	    i += 1;
	}
    }

    ba0_pull_stack ();
    bap_set_product_mpz (A, &prod);
    ba0_restore (&M);
}

/*
 * Reports the simplifications exhibited (mostly) by bad_preprocess_equation.
 *
 * ineqs          = inequations that can be simplified in all quadruples.
 * factored_ineqs = the corresponding simplifications.
 *
 * Updates all the quadruples of tabG.
 */

BAD_DLL void bad_report_simplification_of_inequations
	(bad_tableof_quadruple tabG, 
	 bap_tableof_polynom_mpz ineqs, bap_tableof_product_mpz factored_ineqs)
{   bad_quadruple G;
    bap_product_mpz prod;
    bap_polynom_mpz p;
    ba0_int_p i, j, k;
    bool found;

    if (ineqs->size != factored_ineqs->size)
	BA0_RAISE_EXCEPTION (BA0_ERRALG);

    for (k = 0; k < ineqs->size; k++)
    {   p = ineqs->tab [k];
	prod = factored_ineqs->tab [k];
	for (i = 0; i < tabG->size; i++)
        {   G = tabG->tab [i];
	    G->S = bad_delete_from_listof_polynom_mpz (p, G->S, &found);
	    if (found)
	    {   for (j = 0; j < prod->size; j++)
		    G->S = bad_insert_in_listof_polynom_mpz 
					(&prod->tab [j].factor, G->S);
	    }
	}
    }
}

/*
 * G = the top element of tabG
 * For each factor p of prod1 do
 *    H = G + "p = 0"
 *    G = G + "p != 0"
 *    For each factor q of prod2 do
 *       I = I + "q = 0"
 *       H = H + "q != 0"
 *    done
 * done
 *
 * All the new quadruples are stored in the table tabG.
 * The updated quadruple G is moved in order to appear on the top
 *     of tabG.
 *
 * prod1 and prod2 are assumed to be "preprocessed equations" (see above).
 * So that each polynomial p or q is not an equation leading to an 
 * obviously inconsistent quadruple.
 *
 * prod1 may be a nonzero constant.
 * prod2 must either involve at least one factor, or be zero.
 */

BAD_DLL void bad_split_on_factors_of_equations
    (bad_tableof_quadruple tabG, bap_product_mpz prod1, bap_product_mpz prod2)
{   bad_quadruple G, H, I;
    bap_polynom_mpz p, q;
    ba0_int_p g, h, i, j;

    if (bap_is_zero_product_mpz (prod1) || 
	    (prod2 && prod2->size == 0 && ! bap_is_zero_product_mpz (prod2)))
	BA0_RAISE_EXCEPTION (BA0_ERRALG);

    g = tabG->size - 1;
    G = tabG->tab [g];
/*
 * G is on the top of tabG
 */
    ba0_realloc2_table 
	((ba0_table)tabG, 
	 tabG->size + prod1->size * (1 + (prod2 ? prod2->size : 0)), 
	 (ba0_new_function*)&bad_new_quadruple);

    for (i = 0; i < prod1->size; i++)
    {	
/*
 * H = G + "p = 0",
 * G = G + "p != 0"
 */
	p = &prod1->tab [i].factor;
	h = tabG->size;
	H = tabG->tab [h];
	bad_set_quadruple (H, G);
	H->P = bad_insert_in_listof_polynom_mpz (p, H->P);
	G->S = bad_insert_in_listof_polynom_mpz (p, G->S);
	tabG->size += 1;
/*
 * H is on the top of tabG
 */
	if (prod2 && prod2->size > 0)
	{   
/*
 * The last factor is handled separately in order not to generate
 * the case where all the factors of prod2 are inequations.
 */
	    for (j = 0; j < prod2->size - 1; j++)
	    {   
/*
 * I = H + "q = 0",
 * H = H + "q != 0"
 */
		q = &prod2->tab [j].factor;
		I = tabG->tab [tabG->size];
	        bad_set_quadruple (I, H);
		I->P = bad_insert_in_listof_polynom_mpz (q, I->P);
		H->S = bad_insert_in_listof_polynom_mpz (q, H->S);
	        tabG->size += 1;
	    }
	    q = &prod2->tab [prod2->size - 1].factor;
	    H->P = bad_insert_in_listof_polynom_mpz (q, H->P);

	    ba0_move_to_tail_table ((ba0_table)tabG, (ba0_table)tabG, h);
	}
/*
 * H is again of the top of tabG
 */
    }
    ba0_move_to_tail_table ((ba0_table)tabG, (ba0_table)tabG, g);
}

BAD_DLL bool bad_simplify_and_store_in_P_quadruple 
					(bad_quadruple G, bap_polynom_mpz p)
{
    struct bap_tableof_polynom_mpz ineqs;
    struct bap_tableof_product_mpz factored_ineqs;
    struct bap_product_mpz prod;
    bap_polynom_mpz q;
    struct ba0_mark M;

    if (bap_is_zero_polynom_mpz (p))
	return true;

    ba0_push_another_stack ();
    ba0_record (&M);

    ba0_init_table ((ba0_table)&ineqs);
    ba0_init_table ((ba0_table)&factored_ineqs);
    bap_init_product_mpz (&prod);
    bap_set_product_polynom_mpz (&prod, p, 1);
    bad_preprocess_equation (&prod, &ineqs, &factored_ineqs, G);

    ba0_pull_stack ();

    q = bap_new_polynom_mpz ();
    bap_expand_product_mpz (q, &prod);

    ba0_restore (&M);
/*
 * Nonzero factors of prod are removed by bad_simplify_relation_mod_quadruple
 * Might be useful for some bad_nonzero functions and when all factors
 * of prod are nonzero.
 */
    if ((*bad_nonzero) (q))
	return false;
    else
    {	G->P = bad_insert_in_listof_polynom_mpz (p, G->P);
	return true;
    }
}

/*
 * Returns false only when processing the input inequations of
 * Rosenfeld_Groebner
 */

BAD_DLL bool bad_simplify_and_store_in_S_quadruple 
					(bad_quadruple G, bap_polynom_mpz p)
{
    struct bap_tableof_polynom_mpz ineqs;
    struct bap_tableof_product_mpz factored_ineqs;
    struct bap_product_mpz prod;
    ba0_int_p i;
    bool consistent;
    struct ba0_mark M;

    if (bap_is_zero_polynom_mpz (p))
	return false;

    ba0_push_another_stack ();
    ba0_record (&M);

    ba0_init_table ((ba0_table)&ineqs);
    ba0_init_table ((ba0_table)&factored_ineqs);
    bap_init_product_mpz (&prod);
    bap_set_product_polynom_mpz (&prod, p, 1);
    bad_preprocess_equation (&prod, &ineqs, &factored_ineqs, G);

    consistent = true;
    for (i = 0; i < prod.size && consistent; i++)
    {   if (! (*bad_nonzero) (&prod.tab [i].factor))
        {   ba0_pull_stack ();
            G->S = bad_insert_in_listof_polynom_mpz 
						(&prod.tab [i].factor, G->S);
            ba0_push_another_stack ();
        } else if (bap_is_zero_polynom_mpz (p))
	    consistent = false;
    }

    ba0_pull_stack ();
    ba0_restore (&M);

    return consistent;
}

/***********************************************************************
 * PICK AND REMOVE FROM QUADRUPLE
 **********************************************************************/

/*
 * Picks a polynomial from G->P and stores it in p.
 */

static void bad_pick_from_P_quadruple
		(bap_polynom_mpz p, bad_quadruple G, bad_critical_pair* pair)
{
    if (G->P == (bap_listof_polynom_mpz)0)
	BA0_RAISE_EXCEPTION (BA0_ERRALG);

    bap_set_polynom_mpz (p, G->P->value);
    G->P = G->P->next;
    if (pair)
	*pair = (bad_critical_pair)0;
}

/*
 * Picks a pair from G->D. The picked pair is stored in *pair.
 * The Delta-polynomial is stored in p.
 */

static void bad_pick_from_D_quadruple
		(bap_polynom_mpz p, bad_quadruple G, bad_critical_pair* pair)
{   struct bav_tableof_variable nulles;
    struct ba0_mark M;

    if (G->D == (bad_listof_critical_pair)0)
        BA0_RAISE_EXCEPTION (BA0_ERRALG);

    ba0_push_another_stack ();
    ba0_record (&M);
    ba0_init_table ((ba0_table)&nulles);
    bad_reduced_to_zero_derivatives_by_regchain
                                        (&nulles, &G->A, bad_full_reduction);
    ba0_pull_stack ();
    bad_delta_polynom_critical_pair (p, G->D->value, &nulles);
    ba0_restore (&M);
    if (pair)
        *pair = G->D->value;
    G->D = G->D->next;
}
    
/*
 * Picks elements of P first
 */

static void bad_pick_and_remove_quadruple_P_first
		(bap_polynom_mpz p, bad_quadruple G, bad_critical_pair* pair)
{   
    if (G->P != (bap_listof_polynom_mpz)0)
	bad_pick_from_P_quadruple (p, G, pair);
    else
	bad_pick_from_D_quadruple (p, G, pair);
}

/*
 * Between a polynomial p and a critical pair {f, g}, picks
 * the one of lower "leader" (the leader of {f, g} being the 
 * lcd of the leaders of f and g).
 */
 
static void bad_pick_and_remove_quadruple_lower_leader_first
		(bap_polynom_mpz p, bad_quadruple G, bad_critical_pair* pair)
{   bav_variable u, v;

    if (G->P == (bap_listof_polynom_mpz)0)
	bad_pick_from_D_quadruple (p, G, pair);
    else if (G->D == (bad_listof_critical_pair)0)
	bad_pick_from_P_quadruple (p, G, pair);
    else
    {	u = bap_leader_polynom_mpz (G->P->value);
	v = bav_lcd_variable 
		(bap_leader_polynom_mpz (&G->D->value->p), 
		 bap_leader_polynom_mpz (&G->D->value->q));
	if (bav_R_variable_number (u) < bav_R_variable_number (v))
	    bad_pick_from_P_quadruple (p, G, pair);
	else
	    bad_pick_from_D_quadruple (p, G, pair);
    }
}

BAD_DLL void bad_pick_and_remove_quadruple 
	(bap_polynom_mpz p, bad_quadruple G, bad_critical_pair* pair, 
	 ba0_int_p n)
{
    switch (n)
    {	case 0:
	    bad_pick_and_remove_quadruple_P_first (p, G, pair);
	    break;
	case 1:
	    bad_pick_and_remove_quadruple_lower_leader_first (p, G, pair);
	    break;
	default:
	    BA0_RAISE_EXCEPTION (BA0_ERRNYP);
    }
}

BAD_DLL void bad_reg_characteristic_quadruple 
	(bad_intersectof_regchain tabC, bad_quadruple G, bad_regchain ideal)
{
    ba0_realloc2_table ((ba0_table)&tabC->inter, tabC->inter.size + 1, 
				(ba0_new_function*)&bad_new_regchain);
    tabC->inter.size++;
    bad_set_regchain (tabC->inter.tab [tabC->inter.size - 1], &G->A);
    bad_reg_characteristic_regchain (tabC, G->S, ideal);
}

/***************************************************************************
 COMPLETE
 ***************************************************************************/

static void bad_insert_in_regchain 
		(bad_regchain, bap_polynom_mpz, ba0_int_p*, ba0_int_p*);
static void bad_update_D (bad_quadruple, ba0_int_p, bap_polynom_mpz);
static bool bad_partially_reduce_S (bad_quadruple);

BAD_DLL void bad_complete_quadruple 
	(bad_tableof_quadruple tabG, bap_polynom_mpz r, bad_regchain ideal)
{   bad_quadruple G, H;
    bad_intersectof_regchain tabC;
    bad_critical_pair pair;
    bav_variable v;
    ba0_int_p  j, k, l;

    G = tabG->tab [tabG->size - 1];
    v = bap_leader_polynom_mpz (r);
/*
   A copy of r is inserted at the right place in $A$.
   In the differential case, 
	o the list D of critical pairs is updated,
	o the elements of S are partially reduced w.r.t. r

   k = the position of r in A
   A->tab [A->size .. l-1] = the polynomials thrown away from A 
*/
    bad_insert_in_regchain (&G->A, r, &k, &l);

    if (bad_defines_a_differential_ideal_attchain (&G->A.attrib))
    {   if (bav_R.ders.size == 1)
	{   if (l != G->A.decision_system.size)
	    {   pair = bad_new_critical_pair_polynom_mpz
				(r, G->A.decision_system.tab [l - 1]);
		G->D = (bad_listof_critical_pair)ba0_insert_list
			(pair, (ba0_list)G->D,
			 (ba0_cmp_function*)&bad_is_a_simpler_critical_pair);
	    }
	} else
	    bad_update_D (G, l, r);
	if (! bad_partially_reduce_S (G))
	{   tabG->size--;
	    return;
	}
    }
/*
   One forms a table of regchain whose first element is the component A of G.
   The quenching operation may enlarge this table.
   The component A is modified.

   Observe tabC lies in the same stack as tabG.
*/
    tabC = bad_new_intersectof_regchain ();
    ba0_realloc_table ((ba0_table)&tabC->inter, 1);
    tabC->inter.tab [0] = &G->A;
    tabC->inter.size = 1;

    bad_quench_and_handle_exceptions_regchain (tabC, k, ideal);

    ba0_realloc2_table ((ba0_table)tabG, tabG->size + tabC->inter.size - 1,
			(ba0_new_function*)&bad_new_quadruple);
/*
 * See tests/rg7.c
 *
 * tabC->inter.tab [0] may be modified by 
 * 			bad_quench_and_handle_exceptions_regchain
 */
    if (tabC->inter.size > 0)
    {	G->A = *tabC->inter.tab [0];
	bad_append_tableof_position 
		(&G->pos, &G->pos, bad_regularisation_case,
		 0, tabC->inter.size-1);
    }
/*
 * For each extra regchain generated by the quenching operation, a quadruple
 * is generated and stored in tabG.
 */
    for (j = 1; j < tabC->inter.size; j++)
    {	H = bad_new_quadruple ();
	H->A = *tabC->inter.tab [j];
	H->D = (bad_listof_critical_pair)ba0_copy ("%l[%critic]", G->D);
	H->P = (bap_listof_polynom_mpz)ba0_copy ("%l[%Az]", G->P);
	H->S = (bap_listof_polynom_mpz)ba0_copy ("%l[%Az]", G->S);

	bad_set_tableof_position (&H->pos, &G->pos);
	H->pos.tab [H->pos.size - 1]->index = j;

	tabG->tab [tabG->size + j - 1] = H;
    }

    tabG->size = tabG->size + tabC->inter.size - 1;
}

/*
 *    Inserts r in A.
 *    If A involves an element with the same leader as r then this
 * element is overwritten with r.
 *    Otherwise, a copy of r is inserted at the right place in A.
 *    The index of r in A is stored in *k.
 * 
 *    In the differential case, some polynomials may be thrown away
 * from A (the ones the leader of which is a derivative of the leader
 * of r). 
 *    These polynomials, which may be needed by the calling function,
 * are stored at the end of A (at indices > A->decision_system.size).
 * The first index after the last of these polynomials is stored in *l.
 * 
 *    At the end we therefore have
 * 
 * 			+------------------+-------------------+
 * A->decision_system	| kept pols.  r    | thrown away pols  |
 * 			+------------------+-------------------+
 * 				      ^     ^			^
 * 				      *k    size		*l
 * 
 *    Quenching is not called so that the resulting A is not yet a
 * regular chain.
 */

static void bad_insert_in_regchain 
		(bad_regchain A, bap_polynom_mpz r, ba0_int_p* k, ba0_int_p *l)
{
    bav_variable u, v = BAV_NOT_A_VARIABLE;
    ba0_int_p i, old_size, new_size;
    bool found;
    ba0_mpz_t* lc;

    u = bap_leader_polynom_mpz (r);

    if (u->root->type != bav_dependent_symbol &&
		    u->root->type != bav_temporary_symbol)
	BA0_RAISE_EXCEPTION (BA0_ERRALG);

    old_size = A->decision_system.size;
    if (bad_defines_a_differential_ideal_attchain (&A->attrib))
    {   for (i = A->decision_system.size - 1; i >= 0; i--)
	{   v = bap_leader_polynom_mpz (A->decision_system.tab [i]);
	    if (bav_is_proper_derivative (v, u))
		ba0_delete_table ((ba0_table)&A->decision_system, i);
	}
    }
    new_size = A->decision_system.size;
/*
 * We now have
 *	+---------------------------+----------------+
 *   A  | polynomials kept in A     | thrown away    |
 *      +---------------------------+----------------+
 *                                   size             old_size
 */
    i = 0;
    found = false;
    while (i < new_size && ! found)
    {	v = bap_leader_polynom_mpz (A->decision_system.tab [i]);
	if (bav_R_variable_number (u) <= bav_R_variable_number (v))
	    found = true;
	else
	    i += 1;
    }
/*
 * The polynomial r must be inserted at index i.
 * If u = v then A->decision_system.tab [i] is overwritten else a part
 * of A->decision_system must be shifted to the right.
 */
    if (k != (ba0_int_p*)0)
	*k = i;

    if (found && u == v)
    {	bap_set_polynom_mpz (A->decision_system.tab [i], r);
	if (l != (ba0_int_p*)0)
	    *l = old_size;
    } else
    {   
/*
 * Creates a new entry and moves it at index i (shifting to the
 * right, all the elements of A at index greater than or equal to i).
 */
	A->decision_system.size = old_size;
	bad_realloc_regchain (A, A->decision_system.size + 1);
	A->decision_system.size += 1;
	ba0_move_from_tail_table 
	   ((ba0_table)&A->decision_system, (ba0_table)&A->decision_system, i);
	bap_set_polynom_mpz (A->decision_system.tab [i], r);
	A->decision_system.size = new_size + 1;

	if (l != (ba0_int_p*)0)
	    *l = old_size + 1;
    }
/*
 * Should be useless
 */
    lc = bap_numeric_initial_polynom_mpz (A->decision_system.tab [i]);
    if (ba0_mpz_sgn (*lc) < 0)
	bap_neg_polynom_mpz 
		(A->decision_system.tab [i], A->decision_system.tab [i]);
}

/*
 * Updates the list D of G in the case of PDE.
 *
 * The thrown away elements of A are located in A->tab [A->size .. l-1].
 */

static void bad_update_D (bad_quadruple G, ba0_int_p l, bap_polynom_mpz r)
{   bad_listof_critical_pair cour;
    bad_critical_pair pair;
    struct bav_rank rkp, rkq;
    bav_variable u, v;
    ba0_int_p i;
/*
 * One throws away non reduction critical pairs which involve one of
 *	the thrown away polynomials.
 *
 * remove = true if the pair is a triangular pair involving one of 
 * the thrown away elements.
 */
    cour = G->D;
    while (cour != (bad_listof_critical_pair)0)
    {	pair = cour->value;
	if (! bad_is_a_reduction_critical_pair (pair))
	{   rkp = bap_rank_polynom_mpz (&pair->p);
	    rkq = bap_rank_polynom_mpz (&pair->q);
	    if (! bad_is_rank_of_regchain (&rkp, &G->A, (ba0_int_p*)0) ||
		    ! bad_is_rank_of_regchain (&rkq, &G->A, (ba0_int_p*)0))
		pair->tag = bad_rejected_easy_critical_pair;
	}
	cour = cour->next;
    }
/*
 * One now generates all the new critical pairs between r and all the
 * former elements of A (apart the possible one which had the same leader
 * as r).
 */
    u = bap_leader_polynom_mpz (r);
    for (i = 0; i < l; i++)
    {   v = bap_leader_polynom_mpz (G->A.decision_system.tab [i]);
	if (u != v && u->root == v->root)
	{   pair = bad_new_critical_pair_polynom_mpz 
					(r, G->A.decision_system.tab [i]);
	    G->D = (bad_listof_critical_pair)ba0_cons_list
							(pair, (ba0_list)G->D);
	}
    }
/*
 * The list of critical pairs is now sorted by increasing order.
 * The simplest pairs to process occur at the beginning of the list
 *
 * The tagged pairs have a penalty.
 */
    G->D = (bad_listof_critical_pair)ba0_sort_list 
		((ba0_list)G->D, 
		 (ba0_cmp_function*)&bad_is_a_simpler_critical_pair);
}

/*
 * Reduces S partially w.r.t. A.
 * Returns false if some element of S simplifies to zero.
 */

static bool bad_partially_reduce_S (bad_quadruple G)
{   bap_listof_polynom_mpz prec, cour, rmov;
    struct bap_product_mpz prod;
    ba0_int_p  i;
    bool consistent;
    struct ba0_mark M;
/*
 * One first removes from S all the non partially reduced elements.
 * These discarded elements are stored in the list rmov.
 */
    prec = (bap_listof_polynom_mpz)0;
    cour = G->S;
    rmov = (bap_listof_polynom_mpz)0;
    while (cour != (bap_listof_polynom_mpz)0)
    {	if (bad_is_a_partially_reduced_polynom_wrt_regchain 
						(cour->value, &G->A))
	{   prec = cour;
	    cour = cour->next;
	} else
	{   if (prec == (bap_listof_polynom_mpz)0)
		G->S = cour->next;
	    else
		prec->next = cour->next;
	    cour->next = rmov;
	    rmov = cour;
	    if (prec == (bap_listof_polynom_mpz)0)
		cour = G->S;
	    else
	    	cour = prec->next;
	}
    }
/*
 * One then reduces each element of rmov partially w.r.t. A
  * and stores the factors of the so obtained products in S.
 */
    ba0_push_another_stack ();
    ba0_record (&M);
    bap_init_product_mpz (&prod);
    consistent = true;
    while (rmov != (bap_listof_polynom_mpz)0 && consistent)
    {	bad_reduce_polynom_by_regchain 
		(&prod, (bap_product_mpz)0, rmov->value, &G->A, 
		 bad_partial_reduction, bad_all_derivatives_to_reduce);
/*
 * Modified Dec/11 2008. Led to a modification of test/inclusion.c
 */
	consistent = ! bap_is_zero_product_mpz (&prod);

	ba0_pull_stack ();
	for (i = 0; i < prod.size && consistent; i++)
	    consistent = bad_simplify_and_store_in_S_quadruple 
						(G, &prod.tab [i].factor);
	ba0_push_another_stack ();
	rmov = rmov->next;
    }

    ba0_pull_stack ();
    ba0_restore (&M);

    return consistent;
}
