#ifndef BAD_QUADRUPLE_H
#define BAD_QUADRUPLE_H 1

#include "bad_common.h"
#include "bad_regchain.h"
#include "bad_intersectof_regchain.h"
#include "bad_critical_pair.h"
#include "bad_position.h"

BEGIN_C_DECLS

typedef struct bad_quadruple {
    struct bad_regchain A;
    bad_listof_critical_pair D;
    bap_listof_polynom_mpz P;
    bap_listof_polynom_mpz S;
    struct bad_tableof_position pos;
} *bad_quadruple;

typedef struct bad_tableof_quadruple {
    ba0_int_p alloc;
    ba0_int_p size;
    bad_quadruple* tab;
} *bad_tableof_quadruple;

typedef struct bad_listof_quadruple {
    bad_quadruple value;
    struct bad_listof_quadruple* next;
} *bad_listof_quadruple;

extern BAD_DLL void bad_init_quadruple (bad_quadruple);
extern BAD_DLL bad_quadruple bad_new_quadruple (void);
extern BAD_DLL void bad_set_quadruple (bad_quadruple, bad_quadruple);

extern BAD_DLL bool bad_first_case_quadruple (bad_quadruple);

extern BAD_DLL ba0_scanf_function bad_scanf_quadruple;
extern BAD_DLL ba0_printf_function bad_printf_quadruple;
extern BAD_DLL ba0_garbage1_function bad_garbage1_quadruple;
extern BAD_DLL ba0_garbage2_function bad_garbage2_quadruple;
extern BAD_DLL ba0_copy_function bad_copy_quadruple;

extern BAD_DLL bap_listof_polynom_mpz bad_insert_in_listof_polynom_mpz
			(bap_polynom_mpz, bap_listof_polynom_mpz);

extern BAD_DLL bap_listof_polynom_mpz bad_delete_from_listof_polynom_mpz
			(bap_polynom_mpz, bap_listof_polynom_mpz, bool*);

extern BAD_DLL void bad_preprocess_equation
			(bap_product_mpz, bap_tableof_polynom_mpz,
			 bap_tableof_product_mpz, bad_quadruple);

extern BAD_DLL void bad_report_simplification_of_inequations
                        (bad_tableof_quadruple,
                         bap_tableof_polynom_mpz, bap_tableof_product_mpz);

extern BAD_DLL void bad_split_on_factors_of_equations
			(bad_tableof_quadruple, 
			 bap_product_mpz, bap_product_mpz);

extern BAD_DLL bool bad_simplify_and_store_in_P_quadruple 
			(bad_quadruple, bap_polynom_mpz);
extern BAD_DLL bool bad_simplify_and_store_in_S_quadruple 
			(bad_quadruple, bap_polynom_mpz);

extern BAD_DLL void bad_pick_and_remove_quadruple 
			(bap_polynom_mpz, bad_quadruple, bad_critical_pair*,
			 ba0_int_p);

extern BAD_DLL void bad_reg_characteristic_quadruple 
			(bad_intersectof_regchain, bad_quadruple, 
			 bad_regchain);

extern BAD_DLL void bad_complete_quadruple 
			(bad_tableof_quadruple, bap_polynom_mpz, bad_regchain);

extern BAD_DLL ba0_scanf_function bad_scanf_quadruple;
extern BAD_DLL ba0_printf_function bad_printf_quadruple;
extern BAD_DLL ba0_garbage1_function bad_garbage1_quadruple;
extern BAD_DLL ba0_garbage2_function bad_garbage2_quadruple;
extern BAD_DLL ba0_copy_function bad_copy_quadruple;

END_C_DECLS

#endif /* !BAD_QUADRUPLE_H */
