#ifndef BAD_REDUCTION_H
#define BAD_REDUCTION_H 1

#include "bad_common.h"
#include "bad_regchain.h"

BEGIN_C_DECLS

enum bad_typeof_reduction { 
	bad_full_reduction, 
	bad_partial_reduction, 
	bad_algebraic_reduction };

enum bad_typeof_derivative_to_reduce { 
	bad_all_derivatives_to_reduce, 
	bad_all_but_leader_to_reduce };

enum bad_typeof_reduction_strategy { 
	bad_prem_reduction_strategy = 1,
	bad_prem_and_change_of_ordering_reduction_strategy,
	bad_gcd_prem_reduction_strategy,
	bad_gcd_prem_and_factor_reduction_strategy };

enum bad_typeof_redzero_strategy { 
	bad_deterministic_redzero_strategy = 1,
	bad_probabilistic_redzero_strategy,
	bad_deterministic_using_probabilistic_redzero_strategy };

enum bad_typeof_inclusion_test_result {
	bad_inclusion_test_positive,
	bad_inclusion_test_negative,
	bad_inclusion_test_uncertain };

#define bad_reduction_strategy	\
		bad_initialized_global.reduction.reduction_strategy
#define bad_redzero_strategy \
		bad_initialized_global.reduction.redzero_strategy
#define bad_number_of_redzero_tries \
		bad_initialized_global.reduction.number_of_redzero_tries

extern BAD_DLL void bad_set_settings_reduction
			(enum bad_typeof_reduction_strategy,
			 enum bad_typeof_redzero_strategy, ba0_int_p);
extern BAD_DLL void bad_get_settings_reduction
			(enum bad_typeof_reduction_strategy*,
			 enum bad_typeof_redzero_strategy*, ba0_int_p*);

extern BAD_DLL void bad_reduce_easy_polynom_by_regchain
			(bap_polynom_mpz, bap_polynom_mpz,
			 bad_regchain, enum bad_typeof_reduction);

extern BAD_DLL void bad_ensure_initial_mod_regchain
			(bap_polynom_mpz, bap_polynom_mpz,
			 bad_regchain, enum bad_typeof_reduction);

extern BAD_DLL void bad_reduce_polynom_by_regchain
			(bap_product_mpz, bap_product_mpz, bap_polynom_mpz, 
			 bad_regchain, enum bad_typeof_reduction, 
			 enum bad_typeof_derivative_to_reduce);

extern BAD_DLL void bad_reduce_product_by_regchain
			(bap_product_mpz, bap_product_mpz, bap_product_mpz, 
			 bad_regchain, enum bad_typeof_reduction, 
			 enum bad_typeof_derivative_to_reduce);

extern BAD_DLL bool bad_is_a_reduced_to_zero_polynom_by_regchain 
			(bap_polynom_mpz, bad_regchain, 
			 enum bad_typeof_reduction);

extern BAD_DLL enum bad_typeof_inclusion_test_result bad_is_included_regchain 
			(bad_regchain, bad_regchain);

extern BAD_DLL bool bad_is_a_reduced_to_zero_product_by_regchain
			(bap_product_mpz, bad_regchain, 
			 enum bad_typeof_reduction);

extern BAD_DLL bool bad_is_a_reducible_polynom_by_regchain 
			(bap_polynom_mpz, bad_regchain, 
			 enum bad_typeof_reduction, 
			 enum bad_typeof_derivative_to_reduce, 
			 struct bav_rank*, ba0_int_p*);

extern BAD_DLL bool bad_is_a_reducible_product_by_regchain
			(bap_product_mpz, bad_regchain, 
			 enum bad_typeof_reduction,
			 enum bad_typeof_derivative_to_reduce, ba0_int_p*);

extern BAD_DLL bool bad_is_a_partially_reduced_polynom_wrt_regchain 
			(bap_polynom_mpz, bad_regchain);

extern BAD_DLL bool bad_is_a_partially_reduced_product_wrt_regchain
			(bap_product_mpz, bad_regchain);

extern BAD_DLL void bad_reduced_to_zero_derivatives_by_regchain 
			(bav_tableof_variable, bad_regchain, 
			 enum bad_typeof_reduction);

END_C_DECLS

#endif /* !BAD_REDUCTION_H */
