#ifndef BAD_REGCHAIN_H
#define BAD_REGCHAIN_H 1

#include "bad_common.h"
#include "bad_attchain.h"

BEGIN_C_DECLS

typedef struct bad_regchain {
    struct bad_attchain attrib;
    struct bap_tableof_polynom_mpz decision_system;
/*
    struct bap_tableof_polynom_mpz simplification_system;
*/
} *bad_regchain;

typedef struct bad_tableof_regchain {
    ba0_int_p alloc;
    ba0_int_p size;
    bad_regchain* tab;
} *bad_tableof_regchain;

extern BAD_DLL void bad_init_regchain (bad_regchain);
extern BAD_DLL void bad_reset_regchain (bad_regchain);
extern BAD_DLL bad_regchain bad_new_regchain (void);
extern BAD_DLL void bad_realloc_regchain (bad_regchain, ba0_int_p);
extern BAD_DLL void bad_set_regchain (bad_regchain, bad_regchain); 
extern BAD_DLL ba0_int_p bad_product_of_leading_degrees_regchain 
			(bad_regchain);
extern BAD_DLL void 
	bad_remove_zero_derivatives_of_tableof_parameter_from_regchain
			(bad_regchain, bad_regchain, bav_tableof_parameter);
extern BAD_DLL void bad_set_and_extend_regchain_tableof_polynom_mpz 
			(bad_regchain, bap_tableof_polynom_mpz, 
			 bav_tableof_parameter, ba0_tableof_string, 
			 bool, bool);
extern BAD_DLL void bad_set_and_extend_regchain_tableof_ratfrac_mpz 
			(bad_regchain, bap_tableof_ratfrac_mpz, 
			 bav_tableof_parameter, ba0_tableof_string, 
			 bool, bool);
extern BAD_DLL void bad_fast_primality_test_regchain (bad_regchain);
extern BAD_DLL void bad_set_properties_regchain 
			(bad_regchain, ba0_tableof_string);
extern BAD_DLL void bad_set_structural_properties_regchain 
			(bad_regchain, ba0_tableof_string);
extern BAD_DLL void bad_set_desired_properties_regchain
			(bad_regchain, ba0_tableof_string);
extern BAD_DLL bool bad_has_desired_property_regchain
			(bad_regchain, enum bad_desired_property_attchain);
extern BAD_DLL bool bad_has_structural_property_regchain
			(bad_regchain, enum bad_structural_property_attchain);
extern BAD_DLL bool bad_defines_a_differential_ideal_regchain (bad_regchain);
extern BAD_DLL bool bad_defines_a_prime_ideal_regchain (bad_regchain);

extern BAD_DLL void bad_sort_regchain (bad_regchain, bad_regchain);

extern BAD_DLL bav_Iordering bad_ordering_eliminating_leaders_of_regchain 
			(bad_regchain);
extern BAD_DLL bool bad_is_rank_of_regchain 
			(bav_rank, bad_regchain, ba0_int_p*);
extern BAD_DLL bool bad_is_leader_of_regchain 
			(bav_variable, bad_regchain, ba0_int_p*);
extern BAD_DLL bool bad_is_derivative_of_leader_of_regchain
			(bav_variable, bad_regchain, ba0_int_p*);
extern BAD_DLL bool bad_is_solved_regchain (bad_regchain);
extern BAD_DLL bool bad_is_orthonomic_regchain (bad_regchain);
extern BAD_DLL bool bad_is_explicit_regchain (bad_regchain);
extern BAD_DLL bool bad_is_zero_regchain (bad_regchain);
extern BAD_DLL void bad_quench_regchain 
			(bad_regchain, bad_regchain, ba0_int_p, 
			 bap_polynom_mpz*);

struct bad_base_field;

extern BAD_DLL ba0_int_p bad_codimension_regchain 
			(bad_regchain, struct bad_base_field*);

struct bad_intersectof_regchain;

extern BAD_DLL void bad_quench_and_handle_exceptions_regchain 
			(struct bad_intersectof_regchain*, 
			 ba0_int_p, bad_regchain);
extern BAD_DLL void bad_handle_splitting_exceptions_regchain
			(struct bad_intersectof_regchain*, bap_polynom_mpz, 
			 bad_regchain, char*);

extern BAD_DLL unsigned ba0_int_p bad_sizeof_regchain (bad_regchain);
extern BAD_DLL void bad_switch_ring_regchain 
			(bad_regchain, bav_differential_ring);

extern BAD_DLL ba0_scanf_function bad_scanf_regchain;
extern BAD_DLL ba0_scanf_function bad_scanf_pretend_regchain;
extern BAD_DLL ba0_printf_function bad_printf_regchain;
extern BAD_DLL ba0_printf_function bad_printf_regchain_equations;
extern BAD_DLL ba0_garbage1_function bad_garbage1_inline_regchain;
extern BAD_DLL ba0_garbage2_function bad_garbage2_inline_regchain;
extern BAD_DLL ba0_garbage1_function bad_garbage1_regchain;
extern BAD_DLL ba0_garbage2_function bad_garbage2_regchain;
extern BAD_DLL ba0_copy_function bad_copy_regchain;

END_C_DECLS

#endif /* !BAD_REGCHAIN_H */
