#ifndef BAD_REGULARIZE_H
#define BAD_REGULARIZE_H 1

#include "bad_common.h"
#include "bad_regchain.h"
#include "bad_quadruple.h"

BEGIN_C_DECLS

enum bad_typeof_regularize_strategy { 
	bad_subresultant_regularize_strategy = 1,
	bad_gcd_prem_regularize_strategy,
	bad_gcd_prem_and_factor_regularize_strategy };

#define bad_regularize_strategy	bad_initialized_global.regularize.strategy

enum bad_typeof_Euclid { 
	bad_basic_Euclid, 
	bad_half_extended_Euclid, 
	bad_extended_Euclid };

enum bad_typeof_context {
        bad_inverse_context,
        bad_pardi_context,
        bad_rg_context };

extern BAD_DLL void bad_set_settings_regularize 
	(enum bad_typeof_regularize_strategy);

extern BAD_DLL void bad_get_settings_regularize
	(enum bad_typeof_regularize_strategy*);

extern BAD_DLL void bad_Euclid_mod_regchain 
	(bap_tableof_tableof_polynom_mpz, bad_tableof_quadruple, 
	 enum bad_typeof_Euclid,
	 bap_polynom_mpz, bap_polynom_mpz, bav_variable, 
	 bool, bool,
	 bad_regchain, bap_polynom_mpz*);

extern BAD_DLL void bad_check_regularity_polynom_mod_regchain 
	(bap_polynom_mpz, bad_regchain, bap_polynom_mpz*);

extern BAD_DLL void bad_reg_characteristic_regchain
	(bad_intersectof_regchain, bap_listof_polynom_mpz, bad_regchain);

extern BAD_DLL void bad_invert_polynom_mod_regchain
	(bap_product_mpz, bap_product_mpz, bap_polynom_mpz,
	 bad_regchain, bap_polynom_mpz*);

extern BAD_DLL void bad_invert_product_mod_regchain 
	(bap_product_mpz, bap_product_mpz, bap_product_mpz, 
	 bad_regchain, bap_polynom_mpz*);

extern BAD_DLL void bad_normal_form_polynom_mod_regchain
	(bap_ratfrac_mpz, bap_polynom_mpz, bad_regchain, bap_polynom_mpz*);

extern BAD_DLL void bad_normal_form_ratfrac_mod_regchain
	(bap_ratfrac_mpz, bap_ratfrac_mpz, bad_regchain, bap_polynom_mpz*);

extern BAD_DLL void bad_normal_form_ratfrac_mod_intersectof_regchain
	(bap_tableof_ratfrac_mpz, bap_ratfrac_mpz, 
	 bad_intersectof_regchain, bap_polynom_mpz*);

extern BAD_DLL void bad_normal_form_handling_exceptions_ratfrac_mod_regchain
	(bap_tableof_ratfrac_mpz, bad_intersectof_regchain, 
	 bad_intersectof_regchain, bap_ratfrac_mpz);

END_C_DECLS

#endif /* !BAD_REGULARIZE_H */
