#include "bad.h"

int main ()
{
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns;
    bad_intersectof_regchain T, U;
    struct ba0_mark M;
    char buffer [4096];

    bad_restart (0, 0);
    ba0_record (&M);

    bad_reduction_strategy = bad_gcd_prem_and_factor_reduction_strategy;

    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [[u,v]])",
		 "%ordering", &r);

    bav_R_push_ordering (r);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    T = bad_new_intersectof_regchain ();
    U = bad_new_intersectof_regchain ();
/*
 * First test. Reduction to zero. Exhibited a bug.
 */
    ba0_sscanf2 ("[u[x]^2 - 4*u]", "%t[%Az]", eqns);
    ba0_sscanf2
        ("intersectof_regchain ([], \
                [differential, squarefree, coherent, primitive, autoreduced])",
         "%intersectof_regchain", T);
    bad_Rosenfeld_Groebner
		(T, eqns, (bap_tableof_polynom_mpz)0, 
		 (bad_base_field)0, (bad_splitting_control)0);

    if (T->inter.size != 2)
        return 1;

    bad_remove_redundant_components_intersectof_regchain (U, T);

    if (U->inter.size != 2)
	return 1;
/*
 * Second test. Two components removed.
 */
    ba0_sscanf2 ("[u[x]^2 - 4*u, u[x,y]*v[y] - u + 1, v[x,x] - u[x]]",
    		 "%t[%Az]", eqns);
    ba0_sscanf2 
	("intersectof_regchain ([], \
		[differential, squarefree, coherent, primitive, autoreduced])",
	 "%intersectof_regchain", T);

    bad_Rosenfeld_Groebner 
		(T, eqns, (bap_tableof_polynom_mpz)0, 
		 (bad_base_field)0, (bad_splitting_control)0);

    ba0_sprintf (buffer, "%intersectof_regchain", T);

    if (T->inter.size != 1)
	return 1;

    bad_remove_redundant_components_intersectof_regchain (U, T);
    ba0_sprintf (buffer, "%intersectof_regchain", U);

    if (U->inter.size != 1 ||
	strcmp (buffer, "intersectof_regchain ([regchain ([2*v[y]^2 - u^2 + 2*u - 1, u[y]^2 - 2*u, u[x]*u - u[x] - 2*u[y]*v[y], v[x,x]*u - v[x,x] - 2*u[y]*v[y]], [differential, autoreduced, primitive, squarefree, coherent])], [differential, autoreduced, primitive, squarefree, coherent])") != 0)
	return 1;

    bad_remove_redundant_components_intersectof_regchain (T, T);
    ba0_sprintf (buffer, "%intersectof_regchain", T);

    if (T->inter.size != 1 ||
        strcmp (buffer, "intersectof_regchain ([regchain ([2*v[y]^2 - u^2 + 2*u - 1, u[y]^2 - 2*u, u[x]*u - u[x] - 2*u[y]*v[y], v[x,x]*u - v[x,x] - 2*u[y]*v[y]], [differential, autoreduced, primitive, squarefree, coherent])], [differential, autoreduced, primitive, squarefree, coherent])") != 0)
        return 1;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return 0;
}
