#include "bad.h"

int main ()
{   struct bad_base_field K;
    struct bad_regchain fieldrels;
    struct bad_intersectof_regchain T;
    struct bap_tableof_polynom_mpz eqns, ineqns, nulles;
    struct bap_ratfrac_mpz NF;
    struct bap_polynom_mpz poly;
    bav_Iordering r;
    struct ba0_mark M;
    bool b;
    char buffer [1024];

    bad_restart (0, 0);
    ba0_record (&M);

    bav_set_settings_variable 
		(&bav_scanf_diff_variable, &bav_printf_diff_variable, 0);
/*
 * Definition of the differential ring.
 */
    ba0_sscanf2 ("ordering (derivations = [t], \
                            blocks = [[F[1], F[-1]], [E, ES, P, S], \
                                      [k[1], k[-1], k[2]], \
                                      [E0, S0, ES0, P0], [K, Vmax]])", 
                 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_sscanf2 ("[k[1], k[-1], k[2], E0, S0, ES0, P0, K, Vmax]", 
		 "%t[%param]", &bav_parameters);
/*
 * The base field
 */
    bad_init_regchain (&fieldrels);
    ba0_sscanf2 
        ("regchain ([P0, ES0, K - k[-1]/k[1], Vmax - k[2]*E0], \
                    [differential, squarefree, coherent, \
                     primitive, autoreduced, normalized, prime])", 
         "%pretend_regchain", &fieldrels);
    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations 
	(&K, (bav_tableof_variable)0, &fieldrels, &bav_parameters, true, false);
/*
 * The equations to be processed: the DAE plus the conservation laws
 */
    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[diff(E(t),t)+F[1](t)-F[-1](t)-k[2]*ES(t), \
		   diff(S(t),t)+F[1](t)-F[-1](t), \
		   diff(ES(t),t)-F[1](t)+F[-1](t)+k[2]*ES(t), \
		   diff(P(t),t)-k[2]*ES(t), \
		   -k[1]*E(t)*S(t)+k[-1]*ES(t), \
		   E(t)+ES(t)-E0-ES0, \
		   S(t)+ES(t)+P(t)-S0-ES0-P0]", "%t[%Az]", &eqns);
/*
 * Plus the equations which express the fact that parameters are constant
 */
    ba0_init_table ((ba0_table)&nulles);
    bap_zero_derivatives_of_tableof_parameter_mpz (&nulles, &bav_parameters);
    ba0_concat_table ((ba0_table)&eqns, (ba0_table)&eqns, (ba0_table)&nulles);
/*
 * No inequation
 */
    ba0_init_table ((ba0_table)&ineqns);
    ba0_sscanf2 ("[]", "%t[%Az]", &ineqns);
/*
 * The elimination. Should lead to a single component
 */
    bad_init_intersectof_regchain (&T);
    ba0_sscanf2
        ("intersectof_regchain ([], \
                [differential, squarefree, coherent, primitive, autoreduced, normalized])",
         "%intersectof_regchain", &T);

    bad_Rosenfeld_Groebner (&T, &eqns, &ineqns, &K, (bad_splitting_control)0);
    bad_remove_redundant_components_intersectof_regchain (&T, &T);

    b = T.inter.size == 1;
/*
 * The normal form computation for diff (P(t), t)
 */
    bap_init_polynom_mpz (&poly);
    bap_init_ratfrac_mpz (&NF);
    ba0_sscanf2 ("diff(P(t),t)", "%Az", &poly);
    bad_normal_form_polynom_mod_regchain 
			(&NF, &poly, T.inter.tab [0], (bap_polynom_mpz*)0);

    ba0_sprintf (buffer, "%Qz", &NF);
    b = b && strcmp (buffer, "(S(t)*Vmax)/(S(t) + K)") == 0;

#define DO_PRINT 1
#undef DO_PRINT
#if defined (DO_PRINT)
    ba0_printf ("diff(P(t),t) = %Qz\n", &NF);
#endif 

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
