#include "bad.h"

/*
 * A purely algebraic computation which showed a runtime error.
 * It exhibited two different bugs. June 2010
 */

int main ()
{   struct bad_base_field K;
    struct bad_regchain fieldrels;
    struct bad_intersectof_regchain T;
    struct bap_tableof_polynom_mpz eqns, ineqns, nulles;
    bav_Iordering r;
    struct ba0_mark M;
    bool b;
    char buffer [1024];

    bad_restart (0, 0);
    ba0_record (&M);

    bav_set_settings_variable (&bav_scanf_diff_variable, 0, 0);
/*
 * Definition of the differential ring.
 */
    ba0_sscanf2 ("ordering (derivations = [t], \
                            blocks = [[T[y],T[x],x,y],[m, g, l]])",
                 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_sscanf2 ("[m, g, l]", "%t[%param]", &bav_parameters);
/*
 * The base field
 */
    bad_init_regchain (&fieldrels);
    ba0_sscanf2 
        ("regchain ([], \
                    [differential, squarefree, coherent, \
                     primitive, autoreduced, normalized, prime])", 
         "%pretend_regchain", &fieldrels);
    bad_init_base_field (&K);
    bad_set_base_field_generators_and_relations 
	(&K, (bav_tableof_variable)0, &fieldrels, &bav_parameters, true, false);
/*
 * The equations to be processed
 */
    ba0_init_table ((ba0_table)&eqns);
    ba0_sscanf2 ("[(diff(T[x](t), t))*y(t)^2*l^2-(diff(T[x](t), t))*l^4-(diff(y(t), t))*T[x](t)*y(t)*l^2-3*(diff(y(t), t))*x(t)*y(t)^2*m*g+3*(diff(y(t), t))*x(t)*m*g*l^2, (diff(y(t), t))^2*m*l^2-T[x](t)*x(t)*l^2-y(t)^3*m*g+y(t)*m*g*l^2, T[y](t)*y(t)^2-T[y](t)*l^2+T[x](t)*x(t)*y(t), x(t)^2+y(t)^2-l^2, x(t)]", "%t[%Az]", &eqns);
/*
 * Plus the equations which express the fact that parameters are constant
 */
    ba0_init_table ((ba0_table)&nulles);
    bap_zero_derivatives_of_tableof_parameter_mpz (&nulles, &bav_parameters);
    ba0_concat_table ((ba0_table)&eqns, (ba0_table)&eqns, (ba0_table)&nulles);
/*
 * No inequation
 */
    ba0_init_table ((ba0_table)&ineqns);
    ba0_sscanf2 ("[]", "%t[%Az]", &ineqns);
/*
 * The elimination. Should lead to a single component
 */
    bad_init_intersectof_regchain (&T);
    ba0_sscanf2
        ("intersectof_regchain ([], [autoreduced])",
         "%intersectof_regchain", &T);

    bad_Rosenfeld_Groebner (&T, &eqns, &ineqns, &K, (bad_splitting_control)0);
    bad_remove_redundant_components_intersectof_regchain (&T, &T);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &T);
    b = strcmp (buffer, "[[l[t], g[t], m[t], y^2 - l^2, x, y[t]]]") == 0;

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
