#include "bad.h"

int main ()
{   struct bad_base_field K;
    struct bad_splitting_control C;
    bav_Iordering r;
    bap_tableof_polynom_mpz eqns, ineqns;
    bad_intersectof_regchain T;
    struct ba0_mark M;
    ba0_int_p i;
    char buffer [4096];
    bool b;

    bad_restart (0, 0);
    ba0_record (&M);

    ba0_sscanf2 
	("ordering (derivations = [t], blocks = [x,y,p])", "%ordering", &r);

    bav_R_push_ordering (r);
    T = bad_new_intersectof_regchain ();
    ba0_sscanf2 ("intersectof_regchain ([], [differential, squarefree, coherent, primitive, autoreduced])", "%intersectof_regchain", T);
    eqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ineqns = (bap_tableof_polynom_mpz)ba0_new_table ();
    ba0_sscanf2 ("[x[t]^2+y[]+p[], x[]*y[t]+x[t]+1]", "%t[%Az]", eqns);
    ba0_sscanf2 ("[x[], x[t]]", "%t[%Az]", ineqns);

    bad_init_base_field (&K);
    bad_init_splitting_control (&C);

    bad_Rosenfeld_Groebner (T, eqns, ineqns, &K, &C);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", T);
/*
 * The ideal is prime. One component must involve 2 equations.
 * So far, the other components (their number depend on the strategy)
 * involve 3 equations.
 */

    b = T->inter.size > 0;
    for (i = 1; b && i < T->inter.size; i++)
	if (T->inter.tab [i]->decision_system.size != 3)
	    b = false;
/*
 * Let us apply the dimension conjecture
 */
    bad_set_dimension_lower_bound_splitting_control
				(&C, bad_ode_dimension_lower_bound, true);
    bad_Rosenfeld_Groebner (T, eqns, ineqns, &K, &C);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", T);
    b = b && T->inter.size == 1;

    if (b)
    {	ba0_sprintf (buffer, "%regchain_equations", T->inter.tab [0]);
	b = strcmp (buffer, "[4*y[t,t]^2*y^2 + 8*y[t,t]^2*y*p + 4*y[t,t]^2*y + 4*y[t,t]^2*p^2 + 4*y[t,t]^2*p - 8*y[t,t]*y[t]^2*y^2 - 16*y[t,t]*y[t]^2*y*p - 4*y[t,t]*y[t]^2*y - 8*y[t,t]*y[t]^2*p^2 - 4*y[t,t]*y[t]^2*p - 4*y[t,t]*y[t]*y*p[t] - 4*y[t,t]*y[t]*p[t]*p + 4*y[t]^4*y^2 + 8*y[t]^4*y*p + 4*y[t]^4*y + 4*y[t]^4*p^2 + 4*y[t]^4*p + y[t]^4 + 4*y[t]^3*y*p[t] + 4*y[t]^3*p[t]*p + 2*y[t]^3*p[t] + y[t]^2*p[t]^2, 2*x*y[t,t]*y[t] + 2*y[t,t]*y + 2*y[t,t]*p + 2*y[t,t] - 2*y[t]^2*y - 2*y[t]^2*p - y[t]^2 - y[t]*p[t]]") == 0;
    }

    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return b ? 0 : 1;
}
