#include "bad.h"

#define FNAME "edgardo08.in"

int main ()
{   struct bad_intersectof_regchain ideal;
    struct bad_regchain relations;
    struct bad_splitting_control control;
    struct bad_base_field K;
    struct bap_tableof_polynom_mpz eqns, ineqs, fieldeqns;
    struct bav_tableof_variable gens, X;
    bav_Iordering r;
    struct ba0_table blks;
    struct ba0_tableof_string ders, pars;
    struct ba0_exception_code code;
    ba0_int_p timelimit;
    FILE* f;
    bool b = true;
    char nota [64], dring [64], singsol [64];
    static char buffer [32768];
/*
 * edgardo -> ok
 * edgardo file -> tests the file (debugger)
 * edgardo file timelimit -> tests the file with time limit
 */
    f = fopen (FNAME, "r");
    if (f == NULL)
    {	fprintf (stderr, "unable to open: %s\n", FNAME);
	return 1;
    }

    timelimit = 0;
    bad_restart (timelimit, 0);

    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_raised (code))
    {	if (ba0_mesgerr != BA0_ERRALR)
	    BA0_RAISE_EXCEPTION (ba0_mesgerr);
	fprintf (stderr, "Timelimit %d expired\n", (int)timelimit);
	return 2;
    }

    ba0_set_input_FILE (f);
/*
 * {--> enter DifferentialAlgebra:-DifferentialRing, args = blocks = [...],
 *      parameters = [...], derivations = [...], notation = diff
 */
    ba0_get_token_analex ();
    while (ba0_type_token_analex () != ba0_no_token &&
		strcmp (ba0_value_token_analex (), "DifferentialRing") != 0)
	ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
	return 1;

    ba0_init_table (&blks);
    ba0_init_table ((ba0_table)&pars);
    ba0_init_table ((ba0_table)&ders);

    ba0_scanf ("DifferentialRing, args = blocks = %t[%b], parameters = %t[%s], derivations = %t[%s], notation = %s", &blks, &pars, &ders, nota);
/*
 * The notation (output = jet, for legibility)
 */
    if (strcmp (nota, "diff") != 0)
	return 1;
    bav_set_settings_variable (&bav_scanf_diff_variable, 0, 0);
/*
 * The ordering
 */
    ba0_sprintf (buffer, "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering", "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_parameters, &pars);
/*
 * Optionally:
 * {--> enter DifferentialAlgebra:-PretendRegularDifferentialChain,
 *      args = [_z1^2+1]
 *
 * Followed by:
 * {--> enter DifferentialAlgebra:-RosenfeldGroebner, args = [...],
 *      [...], DRing, 
 *      basefield = field(generators = [...], relations = regchain),
 *      singsol = none
 *
 * The basefield is optional.
 * The relations = regchain (which refers to the PretendRDC above) is
 * optional also.
 */
    while (ba0_type_token_analex () != ba0_no_token &&
	     strcmp (ba0_value_token_analex (), "RosenfeldGroebner") != 0 &&
	     strcmp (ba0_value_token_analex (), 
				"PretendRegularDifferentialChain") != 0)
	ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
	return 1;
/*
 * The PretendRegularDifferentialChain. Will be used later.
 */
    bad_init_regchain (&relations);
    if (strcmp (ba0_value_token_analex (), 
				"PretendRegularDifferentialChain") == 0)
    {	ba0_init_table ((ba0_table)&fieldeqns);
	ba0_scanf ("PretendRegularDifferentialChain, args = %t[%Az]",
			&fieldeqns);
	if (bav_R.ders.size > 0)
	    ba0_scanf_printf ("%pretend_regchain", 
			      "regchain (%t[%Az], [differential, normalized])",
				&relations, &fieldeqns);
	else
	    ba0_scanf_printf ("%pretend_regchain", 
			      "regchain (%t[%Az], [normalized])", 
				&relations, &fieldeqns);
    } else
    {	if (bav_R.ders.size > 0)
	    ba0_sscanf2 ("regchain ([], [differential, normalized])", 
				"%pretend_regchain", &relations);
	else
	    ba0_sscanf2 ("regchain ([], [normalized])",
                                "%pretend_regchain", &relations);
    }
/*
 * The lists of equations and inequations
 */
    while (ba0_type_token_analex () != ba0_no_token &&
	      strcmp (ba0_value_token_analex (), "RosenfeldGroebner") != 0)
	ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
	return 1;

    ba0_init_table ((ba0_table)&eqns);
    ba0_init_table ((ba0_table)&ineqs);
    ba0_scanf ("RosenfeldGroebner, args = %t[%Az], %t[%Az], %s,",
							&eqns, &ineqs, dring);

    ba0_sprintf (buffer, "eqns = %t[%Az]\n", &eqns);
    ba0_sprintf (buffer, "ineqs = %t[%Az]\n", &ineqs);
/*
 * The base field. Uses the relations, parsed above.
 */
    bad_init_base_field (&K);
    ba0_get_token_analex ();
    if (strcmp (ba0_value_token_analex (), "basefield") == 0)
    {   ba0_init_table ((ba0_table)&gens);
	ba0_scanf ("basefield = field");
	ba0_get_token_analex ();
	ba0_get_token_analex ();
	ba0_scanf ("generators = %t[%v]", &gens);
	bad_set_base_field_generators_and_relations 
			(&K, &gens, &relations, &bav_parameters, false, false);
	ba0_init_table ((ba0_table)&X);
	bad_base_field_implicit_generators (&X, &K, &gens, 0);
	if (X.size != 0)
	{   ba0_fprintf (stderr, "implicit generators: %t[%v]\n", &X);
	    return 1;
	}
    } else
	ba0_unget_token_analex ();
    ba0_sprintf (buffer, "basefield = %base_field\n", &K);
/*
 * singsol
 */
    bad_init_splitting_control (&control);
    singsol [0] = '\0';
    while (ba0_type_token_analex () != ba0_no_token &&
	     strcmp (ba0_value_token_analex (), "singsol") != 0)
	ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
	return 1;

    ba0_scanf ("singsol = %s", singsol);	 
    ba0_sprintf (buffer, "singsol = %s\n", singsol);
    if (strcmp (singsol, "none") != 0)
	return 1;
    bad_set_first_branch_only_splitting_control (&control, true);
/*
 * go
 */
    bad_init_intersectof_regchain (&ideal);
#define NORM 1
#if defined NORM
    ba0_sscanf2 ("intersectof_regchain ([], [differential, normalized])",
		 "%intersectof_regchain", &ideal);
#else
    ba0_sscanf2 ("intersectof_regchain ([], [differential, primitive, autoreduced])",
		"%intersectof_regchain", &ideal);
#endif
    bad_Rosenfeld_Groebner (&ideal, &eqns, &ineqs, &K, &control);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &ideal);

    fclose (f);

    b = strcmp (buffer, "[[a[z], a[b], _F1 - f, 2*f[z]^3 - 3*f[z]^2*a - 27*f^4 - 54*f^2*b + a^3 - 27*b^2, 324*f[b,b]*f^6*a^3 - 8748*f[b,b]*f^6*b^2 + 972*f[b,b]*f^4*a^3*b - 26244*f[b,b]*f^4*b^3 - 12*f[b,b]*f^2*a^6 + 1296*f[b,b]*f^2*a^3*b^2 - 26244*f[b,b]*f^2*b^4 - 12*f[b,b]*a^6*b + 648*f[b,b]*a^3*b^3 - 8748*f[b,b]*b^5 + 16*f[b]^2*f[z]^2*f*a^4 - 432*f[b]^2*f[z]^2*f*a*b^2 - 8*f[b]^2*f[z]*f*a^5 + 216*f[b]^2*f[z]*f*a^2*b^2 - 432*f[b]^2*f^5*a^3 + 11664*f[b]^2*f^5*b^2 - 864*f[b]^2*f^3*a^3*b + 23328*f[b]^2*f^3*b^3 - 8*f[b]^2*f*a^6 - 216*f[b]^2*f*a^3*b^2 + 11664*f[b]^2*f*b^4 + 16*f[b]*f[z]^2*a^4 - 432*f[b]*f[z]^2*a*b^2 - 8*f[b]*f[z]*a^5 + 216*f[b]*f[z]*a^2*b^2 - 17496*f[b]*f^6*b - 432*f[b]*f^4*a^3 - 40824*f[b]*f^4*b^2 - 216*f[b]*f^2*a^3*b - 29160*f[b]*f^2*b^3 - 8*f[b]*a^6 + 432*f[b]*a^3*b^2 - 5832*f[b]*b^4 + 108*f[z]^2*f^3*a + 216*f[z]^2*f*a*b + 1215*f[z]*f^6*z + 3645*f[z]*f^4*b*z - 54*f[z]*f^3*a^2 - 45*f[z]*f^2*a^3*z + 3645*f[z]*f^2*b^2*z - 108*f[z]*f*a^2*b - 45*f[z]*a^3*b*z + 1215*f[z]*b^3*z + 3645*f^7 + 8019*f^5*b - 297*f^3*a^3 + 5103*f^3*b^2 - 351*f*a^3*b + 729*f*b^3]]") == 0;

    return b ? 0 : 1;
}

