#include "bad.h"

#define FNAME "edgardo17.in"

int main ()
{   struct bad_intersectof_regchain ideal;
    struct bad_regchain relations;
    struct bad_splitting_control control;
    struct bad_base_field K;
    struct bap_tableof_polynom_mpz eqns, ineqs, fieldeqns;
    struct bav_tableof_variable gens, X;
    bav_Iordering r;
    struct ba0_table blks;
    struct ba0_tableof_string ders, pars;
    struct ba0_exception_code code;
    ba0_int_p timelimit;
    FILE* f;
    bool b = true;
    char nota [64], dring [64], singsol [64];
    static char buffer [32768];
/*
 * edgardo -> ok
 * edgardo file -> tests the file (debugger)
 * edgardo file timelimit -> tests the file with time limit
 */
    f = fopen (FNAME, "r");
    if (f == NULL)
    {	fprintf (stderr, "unable to open: %s\n", FNAME);
	return 1;
    }

    timelimit = 0;
    bad_restart (timelimit, 0);

    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_raised (code))
    {	if (ba0_mesgerr != BA0_ERRALR)
	    BA0_RAISE_EXCEPTION (ba0_mesgerr);
	fprintf (stderr, "Timelimit %d expired\n", (int)timelimit);
	return 2;
    }

    ba0_set_input_FILE (f);
/*
 * {--> enter DifferentialAlgebra:-DifferentialRing, args = blocks = [...],
 *      parameters = [...], derivations = [...], notation = diff
 */
    ba0_get_token_analex ();
    while (ba0_type_token_analex () != ba0_no_token &&
		strcmp (ba0_value_token_analex (), "DifferentialRing") != 0)
	ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
	return 1;

    ba0_init_table (&blks);
    ba0_init_table ((ba0_table)&pars);
    ba0_init_table ((ba0_table)&ders);

    ba0_scanf ("DifferentialRing, args = blocks = %t[%b], parameters = %t[%s], derivations = %t[%s], notation = %s", &blks, &pars, &ders, nota);
/*
 * The notation (output = jet, for legibility)
 */
    if (strcmp (nota, "diff") != 0)
	return 1;
    bav_set_settings_variable (&bav_scanf_diff_variable, 0, 0);
/*
 * The ordering
 */
    ba0_sprintf (buffer, "ordering (derivations = %t[%s], blocks = %t[%b])\n", &ders, &blks);
    ba0_scanf_printf ("%ordering", "ordering (derivations = %t[%s], blocks = %t[%b])", &r, &ders, &blks);
    bav_R_push_ordering (r);
/*
 * The parameters
 */
    ba0_sprintf (buffer, "parameters = %t[%s]\n", &pars);
    ba0_scanf_printf ("%t[%param]", "%t[%s]", &bav_parameters, &pars);
/*
 * Optionally:
 * {--> enter DifferentialAlgebra:-PretendRegularDifferentialChain,
 *      args = [_z1^2+1]
 *
 * Followed by:
 * {--> enter DifferentialAlgebra:-RosenfeldGroebner, args = [...],
 *      [...], DRing, 
 *      basefield = field(generators = [...], relations = regchain),
 *      singsol = none
 *
 * The basefield is optional.
 * The relations = regchain (which refers to the PretendRDC above) is
 * optional also.
 */
    while (ba0_type_token_analex () != ba0_no_token &&
	     strcmp (ba0_value_token_analex (), "RosenfeldGroebner") != 0 &&
	     strcmp (ba0_value_token_analex (), 
				"PretendRegularDifferentialChain") != 0)
	ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
	return 1;
/*
 * The PretendRegularDifferentialChain. Will be used later.
 */
    bad_init_regchain (&relations);
    if (strcmp (ba0_value_token_analex (), 
				"PretendRegularDifferentialChain") == 0)
    {	ba0_init_table ((ba0_table)&fieldeqns);
	ba0_scanf ("PretendRegularDifferentialChain, args = %t[%Az]",
			&fieldeqns);
	if (bav_R.ders.size > 0)
	    ba0_scanf_printf ("%pretend_regchain", 
			      "regchain (%t[%Az], [differential, normalized])",
				&relations, &fieldeqns);
	else
	    ba0_scanf_printf ("%pretend_regchain", 
			      "regchain (%t[%Az], [normalized])", 
				&relations, &fieldeqns);
    } else
    {	if (bav_R.ders.size > 0)
	    ba0_sscanf2 ("regchain ([], [differential, normalized])", 
				"%pretend_regchain", &relations);
	else
	    ba0_sscanf2 ("regchain ([], [normalized])",
                                "%pretend_regchain", &relations);
    }
/*
 * The lists of equations and inequations
 */
    while (ba0_type_token_analex () != ba0_no_token &&
	      strcmp (ba0_value_token_analex (), "RosenfeldGroebner") != 0)
	ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
	return 1;

    ba0_init_table ((ba0_table)&eqns);
    ba0_init_table ((ba0_table)&ineqs);
    ba0_scanf ("RosenfeldGroebner, args = %t[%Az], %t[%Az], %s,",
							&eqns, &ineqs, dring);

    ba0_sprintf (buffer, "eqns = %t[%Az]\n", &eqns);
    ba0_sprintf (buffer, "ineqs = %t[%Az]\n", &ineqs);
/*
 * The base field. Uses the relations, parsed above.
 */
    bad_init_base_field (&K);
    ba0_get_token_analex ();
    if (strcmp (ba0_value_token_analex (), "basefield") == 0)
    {   ba0_init_table ((ba0_table)&gens);
	ba0_scanf ("basefield = field");
	ba0_get_token_analex ();
	ba0_get_token_analex ();
	ba0_scanf ("generators = %t[%v]", &gens);
	bad_set_base_field_generators_and_relations 
			(&K, &gens, &relations, &bav_parameters, false, false);
	ba0_init_table ((ba0_table)&X);
	bad_base_field_implicit_generators (&X, &K, &gens, 0);
	if (X.size != 0)
	{   ba0_fprintf (stderr, "implicit generators: %t[%v]\n", &X);
	    return 1;
	}
    } else
	ba0_unget_token_analex ();
    ba0_sprintf (buffer, "basefield = %base_field\n", &K);
/*
 * singsol
 */
    bad_init_splitting_control (&control);
    singsol [0] = '\0';
    while (ba0_type_token_analex () != ba0_no_token &&
	     strcmp (ba0_value_token_analex (), "singsol") != 0)
	ba0_get_token_analex ();
    if (ba0_type_token_analex () == ba0_no_token)
	return 1;

    ba0_scanf ("singsol = %s", singsol);	 
    ba0_sprintf (buffer, "singsol = %s\n", singsol);
    if (strcmp (singsol, "none") != 0)
	return 1;
    bad_set_first_branch_only_splitting_control (&control, true);
/*
 * go
 */
    bad_init_intersectof_regchain (&ideal);
#define NORM 1
#if defined NORM
    ba0_sscanf2 ("intersectof_regchain ([], [differential, normalized])",
		 "%intersectof_regchain", &ideal);
#else
    ba0_sscanf2 ("intersectof_regchain ([], [differential, primitive, autoreduced])",
		"%intersectof_regchain", &ideal);
#endif
    bad_Rosenfeld_Groebner (&ideal, &eqns, &ineqs, &K, &control);

    ba0_sprintf (buffer, "%intersectof_regchain_equations", &ideal);

    fclose (f);

    b = strcmp (buffer, "[[_F1 - f, 144*f[z]^3*a^2 + 144*f[z]^2*f^2*a^2 - 432*f[z]^2*f*a*z*b + 324*f[z]^2*z^2*b^2 - 96*f[z]*f[b]*f*a^4 + 2592*f[z]*f[b]*f*a*b^2 + 144*f[z]*f[b]*a^3*z*b - 3888*f[z]*f[b]*z*b^3 - 432*f[z]*f^2*a*b + 24*f[z]*f*a^3*z + 648*f[z]*f*z*b^2 - 36*f[z]*a^3 - 36*f[z]*a^2*z^2*b + 16*f[b]^2*a^6 - 864*f[b]^2*a^3*b^2 + 11664*f[b]^2*b^4 + 144*f[b]*f*a^3*b - 3888*f[b]*f*b^3 - 8*f[b]*a^5*z + 216*f[b]*a^2*z*b^2 + 324*f^2*b^2 - 36*f*a^2*z*b + a^4*z^2 + 36*a^2*b, 4*f[a]*a - f[z]*z + 6*f[b]*b - f, 8*f[b,b]*a^7 - 432*f[b,b]*a^4*b^2 + 5832*f[b,b]*a*b^4 + 144*f[z]^2*f*a^3 - 216*f[z]^2*a^2*z*b + 48*f[z]*f[b]*a^5 - 1296*f[z]*f[b]*a^2*b^2 + 144*f[z]*f^3*a^3 - 648*f[z]*f^2*a^2*z*b + 216*f[z]*f*a^2*b + 972*f[z]*f*a*z^2*b^2 + 18*f[z]*a^4*z - 810*f[z]*a*z*b^2 - 486*f[z]*z^3*b^3 - 48*f[b]*f^2*a^5 + 1296*f[b]*f^2*a^2*b^2 + 144*f[b]*f*a^4*z*b - 3888*f[b]*f*a*z*b^3 - 288*f[b]*a^4*b - 108*f[b]*a^3*z^2*b^2 + 7776*f[b]*a*b^3 + 2916*f[b]*z^2*b^4 - 216*f^3*a^2*b + 12*f^2*a^4*z + 648*f^2*a*z*b^2 - 6*f*a^4 - 36*f*a^3*z^2*b - 486*f*a*b^2 - 486*f*z^2*b^3 + 36*a^3*z*b + 27*a^2*z^3*b^2]]") == 0;
    return b ? 0 : 1;
}

