#include "bai_common.h"
#include "bai_odex.h"

BAI_DLL void bai_reset_all_settings (void)
{
    bad_reset_all_settings ();
}

BAI_DLL void bai_restart (ba0_int_p time_limit, ba0_int_p memory_limit)
{   enum ba0_restart_level level = ba0_actual_restart_level;
    bool no_oom, no_oot;

    ba0_get_settings_no_oot (&no_oot);
    ba0_set_settings_no_oot (true);
    ba0_get_settings_no_oom (&no_oom);
    ba0_set_settings_no_oom (true);

    bad_restart (time_limit, memory_limit);

    switch (level)
    {	case ba0_init_level:

	     ba0_define_format_with_sizelt ("odex",
                 sizeof (struct bai_odex_system),
                 &bai_scanf_odex_system,
                 &bai_printf_odex_system,
                 &bai_garbage1_odex_system,
                 &bai_garbage2_odex_system,
                 &bai_copy_odex_system);

	case ba0_reset_level:
	case ba0_done_level:
	    break;
    }
    ba0_set_settings_no_oom (no_oom);
    ba0_set_settings_no_oot (no_oot);
}

BAI_DLL void bai_terminate (enum ba0_restart_level level)
{
    bad_terminate (level);
}

