#ifndef BAI_ODEX_H
#define BAI_ODEX_H 1

#include "bai_common.h"

BEGIN_C_DECLS

typedef struct bai_odex_system {
    bav_variable t;
    struct bav_tableof_variable lhs;
    struct bap_tableof_ratfrac_mpz rhs;
    struct bav_tableof_variable params;
    struct bav_tableof_variable commands;
} *bai_odex_system;

extern BAI_DLL void bai_init_odex_system (bai_odex_system);
extern BAI_DLL void bai_reset_odex_system (bai_odex_system);
extern BAI_DLL bai_odex_system bai_new_odex_system (void);
extern BAI_DLL void bai_set_odex_system (bai_odex_system, bai_odex_system);
extern BAI_DLL void bai_set_odex_system_tables
	(bai_odex_system, bav_variable,
	 bav_tableof_variable, bav_tableof_variable, bav_tableof_variable, 
	 bap_tableof_ratfrac_mpz);
extern BAI_DLL void bai_set_odex_system_regchain 
	(bai_odex_system, bav_variable,
	 bav_tableof_variable, bav_tableof_variable, bav_tableof_variable,
	 bad_regchain);
extern BAI_DLL bool bai_odex_is_lhs 
	(bav_variable, bai_odex_system, ba0_int_p*);

extern BAI_DLL ba0_scanf_function bai_scanf_odex_system;
extern BAI_DLL ba0_printf_function bai_printf_odex_system;
extern BAI_DLL ba0_garbage1_function bai_garbage1_odex_system;
extern BAI_DLL ba0_garbage2_function bai_garbage2_odex_system;
extern BAI_DLL ba0_copy_function bai_copy_odex_system;

extern BAI_DLL void bai_odex_generate_rhs_C_code 
	(FILE*, char*, bai_odex_system);
extern BAI_DLL void bai_odex_generate_jacobianof_rhs_C_code 
	(FILE*, char*, bai_odex_system);

END_C_DECLS

#endif /* !BAI_ODEX_H */
