#ifndef BAI_ODEX_FUNCTION_H
#define BAI_ODEX_FUNCTION_H 1

#include "bai_common.h"

/*
 * This file contains the definitions understood by the functions 
 * generated by bai_odex_generate_function_C_code.
 *
 * The structure bai_parameters describes the actual value of the
 * last void* parameter provided to the functions to be integrated.
 *
 * parvalues	= an array containing the parameters values.
 * parnames	= a bav_tableof_variable containing the parameters names.
 * 		  Its field alloc provides the number of doubles allocated
 * 		  to parvalues.
 * cmdfnptrs	= an array containing pointers to the command functions.
 * cmdnames	= a bav_tableof_variable containing the functions names.
 * 		  Its field alloc provides the number of doubles allocated
 * 		  to cmdfnptrs.
 * extra	= unused pointer.
 *
 * The command functions receive two parameters: the time and the address
 * of the struct bai_parameters.
 */

BEGIN_C_DECLS

struct bai_parameters {
    double* values;
    void* names;
};

typedef double bai_command_function (double, void*);

struct bai_commands {
    bai_command_function** fptrs;
    void* names;
};

struct bai_params {
    struct bai_parameters pars;
    struct bai_commands cmds;
    void* extra;
};

/*
 * Compatible with the Gnu Scientific Library : GSL_SUCCESS = 0
 */

enum bai_odex_exit_code { bai_odex_success = 0, bai_odex_non_finite = 1 };

END_C_DECLS

#endif /* !BAI_ODEX_FUNCTION_H */
