#include "bap_polynom_COEFF.h"
#include "bap__check_COEFF.h"

#define BAD_FLAG_COEFF
#if !defined (BAD_FLAG_mpfr) || defined (HAVE_MPFR_H)

BAP_DLL void bap__check_ordering_COEFF (bap_polynom_COEFF A)
{
#if defined (BA0_HEAVY_DEBUG)
    ba0_int_p i;

    for (i = 1; i < A->rang_total.size; i++)
	if (bav_R_variable_number (A->rang_total.rg [i-1].var) <=
		bav_R_variable_number (A->rang_total.rg [i].var))
	    BA0_RAISE_EXCEPTION (BA0_ERRALG);

    if (A->clot != (bap_clot_COEFF)0 && 
			ba0_which_stack (A->clot) == (struct ba0_stack*)0)
	BA0_RAISE_EXCEPTION (BA0_ERRALG);
#else
    A = (bap_polynom_COEFF)0;
#endif
}

#if defined (BA0_HEAVY_DEBUG)
static void bap__check_compatible_sens_COEFF 
				(bap_polynom_COEFF A, bap_polynom_COEFF B)
{
    if (A->clot != (bap_clot_COEFF)0 &&
		(bap_monom_sequence_polynom_COEFF (A) != 
					bap_decreasing_monom_sequence &&
		 bap_monom_sequence_polynom_COEFF (A) != 
					bap_increasing_monom_sequence))
	BA0_RAISE_EXCEPTION (BA0_ERRALG);
}
#endif

#if defined (BA0_HEAVY_DEBUG)
static void bap__check_compatible_ordering_COEFF 
				(bap_polynom_COEFF A, bap_polynom_COEFF B)
{
    bap__check_ordering_COEFF (A);
    bap__check_ordering_COEFF (B);
}
#endif

BAP_DLL void bap__check_compatible_COEFF 
				(bap_polynom_COEFF A, bap_polynom_COEFF B)
{
#if defined (BA0_HEAVY_DEBUG)
    bap__check_compatible_sens_COEFF (A, B);
    bap__check_compatible_ordering_COEFF (A, B);
#else
    A = (bap_polynom_COEFF)0;
    B = (bap_polynom_COEFF)0;
#endif
}

#endif
#undef BAD_FLAG_COEFF
