#include "bap_clot_common.h"
#include "bap_global.h"

#define bap_clot_parameters_stack	bap_global.clot_common.stack

BAP_DLL void bap_reset_clot_parameters_stack (void)
{
    bap_clot_parameters_sp = -1;
}

BAP_DLL void bap_push_clot_parameters_stack 
	(enum bap_typeof_termanager type, enum bap_typeof_monom_sequence sens)
{
    bap_clot_parameters_sp++;
    if (bap_clot_parameters_sp < 0 || 
		bap_clot_parameters_sp >= BAP_SIZE_CLOT_PARAMETERS_STACK)
	BA0_RAISE_EXCEPTION (BA0_ERRALG);
    bap_clot_parameters_stack [bap_clot_parameters_sp].type = type;
    bap_clot_parameters_stack [bap_clot_parameters_sp].sens = sens;
}

BAP_DLL void bap_pull_clot_parameters_stack (void)
{
    if (bap_clot_parameters_sp < 0 || 
		bap_clot_parameters_sp >= BAP_SIZE_CLOT_PARAMETERS_STACK)
        BA0_RAISE_EXCEPTION (BA0_ERRALG);
    bap_clot_parameters_sp--;
}

BAP_DLL enum bap_typeof_termanager bap_current_typeof_termanager (void)
{
    if (bap_clot_parameters_sp < 0 || 
		bap_clot_parameters_sp >= BAP_SIZE_CLOT_PARAMETERS_STACK)
        BA0_RAISE_EXCEPTION (BA0_ERRALG);
    return bap_clot_parameters_stack [bap_clot_parameters_sp].type;
}

BAP_DLL enum bap_typeof_monom_sequence bap_current_typeof_monom_sequence (void)
{
    if (bap_clot_parameters_sp < 0 || 
		bap_clot_parameters_sp >= BAP_SIZE_CLOT_PARAMETERS_STACK)
        BA0_RAISE_EXCEPTION (BA0_ERRALG);
    return bap_clot_parameters_stack [bap_clot_parameters_sp].sens;
}

