#ifndef BAP_COMMON_H
#define BAP_COMMON_H 1

#include <bav.h>

/*
 * The _MSC_VER flag is set if the code is compiled under WINDOWS
 * by using Microsoft Visual C (through Visual Studio 2008).
 *
 * In that case, some specific annotations must be added for DLL exports
 * Beware to the fact that this header file is going to be used either
 * for/while building BLAD or for using BLAD from an outer software.
 *
 * In the first case, functions are exported.
 * In the second one, they are imported.
 *
 * The flag BAP_BLAD_BUILDING must thus be set in the Makefile and passed
 * to the C preprocessor at BAP building time. Do not set it when using BAP.
 *
 * When compiling static libraries under Windows, set BA0_STATIC.
 */

#if defined (_MSC_VER) && ! defined (BA0_STATIC)
#    if defined (BAP_BLAD_BUILDING)
#       define BAP_DLL  __declspec(dllexport)
#    else
#       define BAP_DLL  __declspec(dllimport)
#    endif
#else
#    define BAP_DLL
#endif

#include "bap_mesgerr.h"

BEGIN_C_DECLS

#define bap_2_pow		   bap_global.common.two_pow

struct bap_composite_number {
    ba0_int_p primaire;
    ba0_int_p secondaire;
    ba0_int_p global;
};

extern BAP_DLL void bap_reset_all_settings (void);
extern BAP_DLL void bap_restart (ba0_int_p, ba0_int_p);
extern BAP_DLL void bap_terminate (enum ba0_restart_level);
extern BAP_DLL ba0_int_p bap_ceil_log2 (ba0_int_p);

END_C_DECLS

#endif /* !BAP_COMMON_H */
