#ifndef BAP_GCD_POLYNOM_MPZ_H
#define BAP_GCD_POLYNOM_MPZ_H 1

#include "bap_common.h"
#include "bap_polynom_mpz.h"
#include "bap_product_mpz.h"

BEGIN_C_DECLS

typedef struct bap_factored_polynom_mpz {
    struct bap_product_mpz outer;
    struct bap_polynom_mpz poly;
} *bap_factored_polynom_mpz;

typedef struct bap_tableof_factored_polynom_mpz {
    ba0_int_p alloc;
    ba0_int_p size;
    bap_factored_polynom_mpz* tab;
} *bap_tableof_factored_polynom_mpz;

typedef struct bap_gcd_data {
    bool proved_relatively_prime;
    struct bap_product_mpz common;
    struct bap_tableof_factored_polynom_mpz F;
} *bap_gcd_data;

extern BAP_DLL ba0_printf_function bap_printf_gcd_data;

extern BAP_DLL void bap_gcd_univariate_tableof_polynom_mpz
			(bap_polynom_mpz, bap_tableof_polynom_mpz);
extern BAP_DLL void bap_gcdheu_tableof_polynom_mpz
			(bap_polynom_mpz, bap_tableof_polynom_mpz, ba0_int_p);
extern BAP_DLL void bap_extended_Zassenhaus_gcd_tableof_polynom_mpz
			(bap_product_mpz, bap_tableof_polynom_mpz, bool);

extern BAP_DLL void bap_gcd_tableof_polynom_mpz 
			(bap_product_mpz, bap_tableof_polynom_mpz, bool);
extern BAP_DLL void bap_gcd_polynom_mpz 
			(bap_polynom_mpz, bap_polynom_mpz, bap_polynom_mpz,
			 bap_polynom_mpz, bap_polynom_mpz);

extern BAP_DLL void bap_content_tableof_polynom_mpz
			(bap_product_mpz, bap_tableof_polynom_mpz, 
			 bav_variable, bool);
extern BAP_DLL void bap_content_polynom_mpz
			(bap_polynom_mpz, bap_polynom_mpz, bav_variable);

extern BAP_DLL void bap_primpart_polynom_mpz
			(bap_polynom_mpz, bap_polynom_mpz, bav_variable);

extern BAP_DLL void bap_Yun_polynom_mpz
			(bap_product_mpz, bap_polynom_mpz, bool);
extern BAP_DLL void bap_squarefree_polynom_mpz
			(bap_product_mpz, bap_polynom_mpz);

extern BAP_DLL void bap_factor_easy_polynom_mpz
			(bap_product_mpz, bap_polynom_mpz,
			 bap_listof_polynom_mpz);
END_C_DECLS

#endif /*! BAP_GCD_POLYNOM_MPZ_H */

