#ifndef BAP_GLOBAL_H
#define BAP_GLOBAL_H 1

#include "bap_common.h"
#include "bap_clot_common.h"

BEGIN_C_DECLS

struct bap_global {
    struct {
/*
 * Table of powers of 2. 
 * Initialized by bap_common then readonly.
 */
	ba0_int_p two_pow [BA0_NBBITS_INT_P];
    } common;
    struct {
/*
 * Gives the current setting for CLOTS.
 * sp = the stack pointer (the last used element).
 * Local to bap_common, bap_clot_common.
 */
	struct bap_clot_parameters stack [BAP_SIZE_CLOT_PARAMETERS_STACK];
	ba0_int_p sp;
    } clot_common;
    struct {
/*
 * Two variables local to bap_itercoeff_COEFF.
 * The values are meaningless between two calls.
 */
	bav_Inumber last_number;
	bav_term term;
    } itercoeff;
};

extern BAP_DLL struct bap_global bap_global;

END_C_DECLS

#endif /* !BAP_GLOBAL_H */
