#ifndef BAP_ITERATOR_INDEX_H
#define BAP_ITERATOR_INDEX_H 1

#include "bap_common.h"
#include "bap_indexed_access.h"

BEGIN_C_DECLS

typedef struct bap_iterator_index {
    bap_indexed_access ind;
    struct bap_composite_number num;
} *bap_iterator_index;

typedef struct bap_creator_index {
    bap_indexed_access ind;
    struct bap_composite_number num;
} *bap_creator_index;

extern BAP_DLL void bap_begin_creator_index 
				(bap_creator_index, bap_indexed_access);
extern BAP_DLL void bap_write_creator_index (bap_creator_index, ba0_int_p);
extern BAP_DLL void bap_close_creator_index (bap_creator_index);

extern BAP_DLL void bap_begin_iterator_index 
				(bap_iterator_index, bap_indexed_access);
extern BAP_DLL void bap_end_iterator_index 
				(bap_iterator_index, bap_indexed_access);
extern BAP_DLL bool bap_outof_iterator_index (bap_iterator_index);
extern BAP_DLL void bap_next_iterator_index (bap_iterator_index);
extern BAP_DLL void bap_prev_iterator_index (bap_iterator_index);
extern BAP_DLL void bap_goto_iterator_index (bap_iterator_index, ba0_int_p);
extern BAP_DLL ba0_int_p bap_index_iterator_index (bap_iterator_index);
extern BAP_DLL ba0_int_p bap_read_iterator_index (bap_iterator_index);
extern BAP_DLL void bap_swapindex_iterator_index
                                (bap_iterator_index, bap_iterator_index);
extern BAP_DLL void bap_set_iterator_index 
				(bap_iterator_index, bap_iterator_index);

END_C_DECLS

#endif /* !BAP_ITERATOR_INDEX_H */
