#ifndef BAP_POLYSPEC_MPZ_H
#define BAP_POLYSPEC_MPZ_H 1

#include "bap_common.h"
#include "bap_polynom_mpz.h"
#include "bap_product_mpz.h"
#include "bap_polynom_mpzm.h"
#include "bap_product_mpzm.h"
#include "bap_polynom_mpq.h"

BEGIN_C_DECLS

extern BAP_DLL void bap_polynom_mpq_to_mpz (bap_polynom_mpz, bap_polynom_mpq);

extern BAP_DLL void bap_coeftayl_polynom_mpz 
				(bap_polynom_mpz, bap_polynom_mpz, 
				 struct bav_ev_value, bav_Idegree);
extern BAP_DLL void bap_maxnorm_polynom_mpz (ba0_mpz_t, bap_polynom_mpz);
extern BAP_DLL void bap_normal_sign_polynom_mpz 
				(bap_polynom_mpz, bap_polynom_mpz);
extern BAP_DLL void bap_numeric_content_polynom_mpz (ba0_mpz_t, bap_polynom_mpz);
extern BAP_DLL void bap_signed_numeric_content_polynom_mpz 
				(ba0_mpz_t, bap_polynom_mpz);
extern BAP_DLL void bap_numeric_primpart_polynom_mpz 
				(bap_polynom_mpz, bap_polynom_mpz);
extern BAP_DLL void bap_normal_numeric_primpart_polynom_mpz 
				(bap_polynom_mpz, bap_polynom_mpz);
extern BAP_DLL void bap_exquo_polynom_numeric_mpz 
				(bap_polynom_mpz, bap_polynom_mpz, ba0_mpz_t);
extern BAP_DLL bool bap_is_numeric_factor_polynom_mpz 
				(bap_polynom_mpz, ba0_mpz_t, bap_polynom_mpz);
extern BAP_DLL void bap_genpoly_polynom_mpz 
				(bap_polynom_mpz, bap_polynom_mpz, 
				 ba0_mpz_t, bav_variable);
extern BAP_DLL void bap_new_ev_point_mpz
				(bav_ev_point, bap_tableof_polynom_mpz, 
				 bap_product_mpz, ba0_int_p);

typedef struct bap_ideal_lifting {
    bap_polynom_mpz A;
    bap_polynom_mpz initial;
    struct bap_product_mpz factors_initial;
    struct bap_product_mpzm factors_mod_point;
    struct bav_ev_point point;
    ba0_mpz_t p;
    ba0_int_p l;
} *bap_ideal_lifting;

extern BAP_DLL void bap_HL_init_ideal_lifting (bap_ideal_lifting);
extern BAP_DLL void bap_HL_printf_ideal_lifting (void*);
extern BAP_DLL void bap_HL_integer_divisors
			(ba0_mpz_t*, bap_ideal_lifting, ba0_mpz_t*);
extern BAP_DLL void bap_HL_end_redistribute
			(bap_ideal_lifting, ba0_mpz_t*, 
			 bap_polynom_mpz, ba0_mpz_t);
extern BAP_DLL void bap_HL_begin_redistribute
			(bap_ideal_lifting, ba0_mpz_t*,
			 bap_polynom_mpz, ba0_mpz_t);
extern BAP_DLL void bap_HL_redistribute_the_factors_of_the_initial
			(bap_ideal_lifting);
extern BAP_DLL void bap_HL_ideal_Hensel_lifting
			(bap_product_mpz, bap_ideal_lifting);

extern BAP_DLL void bap_monomial_reduce_polynom_mpz
			(bap_polynom_mpz, bap_polynom_mpz, ba0_mpz_t,
			 bap_polynom_mpz, bap_polynom_mpz);
extern BAP_DLL void bap_gcd_pseudo_division_polynom_mpz 
			(bap_polynom_mpz, bap_polynom_mpz, bap_product_mpz, 
			 bap_polynom_mpz, bap_polynom_mpz, bav_variable);
extern BAP_DLL void bap_gcd_prem_polynom_mpz 
			(bap_polynom_mpz, bap_product_mpz, 
			 bap_polynom_mpz, bap_polynom_mpz, bav_variable);
extern BAP_DLL void bap_gcd_pquo_polynom_mpz 
			(bap_polynom_mpz, bap_product_mpz, 
			 bap_polynom_mpz, bap_polynom_mpz, bav_variable);

END_C_DECLS

#endif /* !BAP_POLYSPEC_MPZ_H */
