#ifndef BAP_RATFRAC_MPZ_H
#define BAP_RATFRAC_MPZ_H 1

#include "bap_common.h"
#include "bap_polynom_mpz.h"

BEGIN_C_DECLS

typedef struct bap_ratfrac_mpz {
    struct bap_polynom_mpz numer;
    struct bap_polynom_mpz denom;
} *bap_ratfrac_mpz;

typedef struct bap_listof_ratfrac_mpz {
    bap_ratfrac_mpz value;
    struct bap_listof_ratfrac_mpz* next;
} *bap_listof_ratfrac_mpz;

typedef struct bap_tableof_ratfrac_mpz {
    ba0_int_p alloc;
    ba0_int_p size;
    bap_ratfrac_mpz* tab;
} *bap_tableof_ratfrac_mpz;

typedef struct bap_matrixof_ratfrac_mpz {
    ba0_int_p alloc;
    ba0_int_p nrow;
    ba0_int_p ncol;
    bap_ratfrac_mpz* entry;
} *bap_matrixof_ratfrac_mpz;

extern BAP_DLL void bap_init_ratfrac_mpz (bap_ratfrac_mpz);
extern BAP_DLL void bap_init_readonly_ratfrac_mpz (bap_ratfrac_mpz);

extern BAP_DLL bap_ratfrac_mpz bap_new_ratfrac_mpz (void);

extern BAP_DLL void bap_set_ratfrac_mpz (bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_set_ratfrac_zero_mpz (bap_ratfrac_mpz);
extern BAP_DLL void bap_set_ratfrac_one_mpz (bap_ratfrac_mpz);
extern BAP_DLL void bap_set_ratfrac_polynom_mpz (bap_ratfrac_mpz, bap_polynom_mpz);
extern BAP_DLL void bap_set_ratfrac_fraction_mpz 
			(bap_ratfrac_mpz, bap_polynom_mpz, bap_polynom_mpz);

extern BAP_DLL ba0_scanf_function bap_scanf_ratfrac_eqn_mpz;
extern BAP_DLL ba0_scanf_function bap_scanf_ratfrac_mpz;
extern BAP_DLL ba0_scanf_function bap_scanf_product_ratfrac_mpz;
extern BAP_DLL ba0_scanf_function bap_scanf_expanded_ratfrac_mpz;
extern BAP_DLL ba0_scanf_function bap_scanf_careful_expanded_ratfrac_mpz;
extern BAP_DLL ba0_printf_function bap_printf_ratfrac_mpz;
extern BAP_DLL ba0_garbage1_function bap_garbage1_ratfrac_mpz;
extern BAP_DLL ba0_garbage2_function bap_garbage2_ratfrac_mpz;
extern BAP_DLL ba0_copy_function bap_copy_ratfrac_mpz;

extern BAP_DLL bool bap_is_zero_ratfrac_mpz (bap_ratfrac_mpz);
extern BAP_DLL bool bap_is_one_ratfrac_mpz (bap_ratfrac_mpz);
extern BAP_DLL bool bap_is_numeric_ratfrac_mpz (bap_ratfrac_mpz);
extern BAP_DLL bool bap_depend_ratfrac_mpz (bap_ratfrac_mpz, bav_variable);
extern BAP_DLL bool bap_equal_ratfrac_mpz (bap_ratfrac_mpz, bap_ratfrac_mpz);

extern BAP_DLL void bap_sort_ratfrac_mpz (bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_physort_ratfrac_mpz 
				(bap_ratfrac_mpz, enum bap_typeof_transform);

extern BAP_DLL void bap_numer_ratfrac_mpz (bap_polynom_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_denom_ratfrac_mpz (bap_polynom_mpz, bap_ratfrac_mpz);
extern BAP_DLL bav_variable bap_leader_ratfrac_mpz (bap_ratfrac_mpz);

extern BAP_DLL void bap_reduce_ratfrac_mpz (bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_reduce_numeric_ratfrac_mpz 
					(bap_ratfrac_mpz, bap_ratfrac_mpz);

extern BAP_DLL void bap_neg_ratfrac_mpz (bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_add_ratfrac_mpz 
			(bap_ratfrac_mpz, bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_sub_ratfrac_mpz 
			(bap_ratfrac_mpz, bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_mul_ratfrac_numeric_mpz 
			(bap_ratfrac_mpz, bap_ratfrac_mpz, ba0_mpz_t);
extern BAP_DLL void bap_mul_ratfrac_mpz 
			(bap_ratfrac_mpz, bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_pow_ratfrac_mpz
			(bap_ratfrac_mpz, bap_ratfrac_mpz, bav_Idegree);
extern BAP_DLL void bap_invert_ratfrac_mpz (bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_div_ratfrac_mpz 
			(bap_ratfrac_mpz, bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_separant_ratfrac_mpz (bap_ratfrac_mpz, bap_ratfrac_mpz);
extern BAP_DLL void bap_separant2_ratfrac_mpz 
			(bap_ratfrac_mpz, bap_ratfrac_mpz, bav_variable);
extern BAP_DLL void bap_diff_ratfrac_mpz 
	(bap_ratfrac_mpz, bap_ratfrac_mpz, bav_symbol, bav_tableof_variable);

END_C_DECLS

#endif /* !BAP_RATFRAC_MPZ_H */
