#ifndef BAP_TERMANAGER_H
#define BAP_TERMANAGER_H 1

#include "bap_common.h"

BEGIN_C_DECLS

enum bap_typeof_termanager 
    { bap_basic_termanager, bap_zipping_termanager, bap_hashing_termanager };

typedef ba0_int_p bap_termkey;

typedef struct bap_termanager {
    struct bav_term rang_total;
    enum bap_typeof_termanager type;
    union {
	struct _basic {
	    ba0_int_p alloc;
	    ba0_int_p size;
	} basic;
	struct _zipping {
	    ba0_int_p alloc;
	    ba0_int_p size;
	    unsigned char* nbbits;
	    unsigned ba0_int_p* mask;
	} zipping;
    } u;
} *bap_termanager;

extern BAP_DLL void bap_init_termanager 
	(bap_termanager, enum bap_typeof_termanager, bav_term);
extern BAP_DLL void bap_reset_termanager 
	(bap_termanager, enum bap_typeof_termanager, bav_term, bool*);
extern BAP_DLL bool bap_equal_termanager (bap_termanager, bap_termanager);
extern BAP_DLL void bap_init_set_termanager (bap_termanager, bap_termanager);
extern BAP_DLL void bap_init_termkey_array_termanager 
	(bap_termanager, bap_termkey*, ba0_int_p);
extern BAP_DLL void bap_set_termkey_from_termkey_termanager 
	(bap_termanager, bap_termkey*, bap_termanager, bap_termkey);
extern BAP_DLL void bap_set_termkey_from_term_termanager 
	(bap_termanager, bap_termkey*, bav_term);
extern BAP_DLL void bap_set_term_from_termkey_termanager 
	(bap_termanager, bav_term, bap_termkey);

extern BAP_DLL ba0_garbage1_function bap_garbage1_termanager;
extern BAP_DLL ba0_garbage2_function bap_garbage2_termanager;

/*
 * Should be garbage1 and garbage2 functions.
 */

extern BAP_DLL bool bap_worth_garbage_termkey_termanager (bap_termanager);
extern BAP_DLL ba0_int_p bap_garbage1_termkey_termanager 
			(bap_termanager, bap_termkey, enum ba0_garbage_code);
extern BAP_DLL bap_termkey bap_garbage2_termkey_termanager 
			(bap_termanager, bap_termkey, enum ba0_garbage_code);

extern BAP_DLL void bap_switch_ring_termanager 
			(bap_termanager, bav_differential_ring);
END_C_DECLS

#endif /* !BAP_TERMANAGER_H */
