#include "bap.h"

int main ()
{
    struct bap_tableof_polynom_mpz V;
    struct bap_polynom_mpz P, Q, S;
    bav_variable v;
    bav_Iordering r;

    bap_restart (0, 0);

    ba0_sscanf2 ("ordering (derivations = [], blocks = [t])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&V);
    ba0_realloc2_table 
		((ba0_table)&V, 3, (ba0_new_function*)&bap_new_polynom_mpz);
    V.size = 3;

    bap_init_polynom_mpz (&P);
    bap_init_polynom_mpz (&Q);

    ba0_sscanf2 ("5*t^17 - 30*t^14 + 9*t^11 + 60*t^9 + 104*t^8 - 180*t^6 - 73*t^5 + 90*t^3 + 8*t^2 + 27*t - 24", "%Az", &P);
    ba0_sscanf2 ("t^14 - 5*t^11 + 16*t^8 - 6*t^6 - 22*t^5 + 12*t^3 + 10*t^2 - 6", "%Az", &Q);

    ba0_sscanf2 ("t", "%v", &v);
    bap_init_polynom_mpz (&S);

    bap_lsr3_Ducos_polynom_mpz (&V, &P, &Q, v);

    ba0_scanf_printf ("%Az", "%Az - (%Az)*(%Az) - (%Az)*(%Az)", 
			&S, V.tab [0], V.tab [1], &P, V.tab [2], &Q);

    if (! bap_is_zero_polynom_mpz (&S))
	return 1;

    bap_resultant2_Ducos_polynom_mpz (&S, &P, &Q, v);

    if (! bap_equal_polynom_mpz (&S, V.tab [0]))
	return 1;

    bav_R_pull_ordering ();
    bap_terminate (ba0_init_level);
    return 0;
}
