#include "bap.h"

int main ()
{
    struct bap_tableof_polynom_mpz V;
    struct bap_polynom_mpz P, Q, S;
    bav_variable v;
    bav_Iordering r;

    bap_restart (0, 0);

    ba0_sscanf2 ("ordering (derivations = [], blocks = [u, v, w])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&V);
    ba0_realloc2_table 
		((ba0_table)&V, 3, (ba0_new_function*)&bap_new_polynom_mpz);
    V.size = 3;

    bap_init_polynom_mpz (&P);
    bap_init_polynom_mpz (&Q);

    ba0_sscanf2 ("v*u^3 + (v+1)*u^2 - (3*v+w-1)*u + v", "%Az", &P);
    ba0_sscanf2 ("(5*v+w)*u^2 + (v^2-v-17)*u + w^2 + w - 3", "%Az", &Q);

    ba0_sscanf2 ("u", "%v", &v);

    bap_lsr3_Ducos_polynom_mpz (&V, &P, &Q, v);

    bap_init_polynom_mpz (&S);
    ba0_scanf_printf ("%Az", "%Az - (%Az)*(%Az) - (%Az)*(%Az)", 
			&S, V.tab [0], V.tab [1], &P, V.tab [2], &Q);

    if (! bap_is_zero_polynom_mpz (&S))
	return 1;

    bap_resultant2_Ducos_polynom_mpz (&S, &P, &Q, v);
    if (! bap_equal_polynom_mpz (&S, V.tab [0]))
	return 1;

    bav_R_pull_ordering ();
    bap_terminate (ba0_init_level);
    return 0;
}
