#include "bap.h"

int main ()
{   struct bap_product_mpz H;
    struct bap_polynom_mpz Q, R, A, B;
    bav_Iordering r;
    ba0_mpz_t c;
    bool b;
    static char buffer [512];
   
    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [t], blocks = [x,y,p])", "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_mpz_init (c);
    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&B);
    bap_init_polynom_mpz (&Q);
    bap_init_polynom_mpz (&R);

    ba0_sscanf2 ("-4*y[t]^2*y^2-8*y[t]^2*y*p-8*y[t]^2*y-4*y[t]^2*p^2-8*y[t]^2*p-5*y[t]^2-6*y[t]*y*p[t]-6*y[t]*p[t]*p-5*y[t]*p[t]-2*y*p[t,t]-2*p[t,t]*p-2*p[t,t]", "%Az", &A);
    ba0_sscanf2 ("2*y[t]*y+2*y[t]*p+y[t]+p[t]", "%Az", &B);

    bap_monomial_reduce_polynom_mpz (&Q, &R, c, &A, &B);

    ba0_sprintf (buffer, "%Az", &R);
    b = strcmp (buffer, "-2*y[t]^2 - 2*y*p[t,t] - 2*p[t,t]*p - 2*p[t,t] + 2*p[t]^2") == 0;

    ba0_scanf_printf 
	("%Az", "(%z)*(%Az) - ((%Az)*(%Az) + %Az)", &R, c, &A, &Q, &B, &R);
    b = b && bap_is_zero_polynom_mpz (&R);

    bap_init_product_mpz (&H);
    bap_gcd_pseudo_division_polynom_mpz (&Q, &R, &H, &A, &B, BAV_NOT_A_VARIABLE);

    ba0_sprintf (buffer, "%Az", &R);
    b = b && strcmp (buffer, "-8*y^3*p[t,t] - 24*y^2*p[t,t]*p - 16*y^2*p[t,t] + 8*y^2*p[t]^2 - 24*y*p[t,t]*p^2 - 32*y*p[t,t]*p - 10*y*p[t,t] + 16*y*p[t]^2*p + 8*y*p[t]^2 - 8*p[t,t]*p^3 - 16*p[t,t]*p^2 - 10*p[t,t]*p - 2*p[t,t] + 8*p[t]^2*p^2 + 8*p[t]^2*p") == 0;

    ba0_scanf_printf
        ("%Az", "(%Pz)*(%Az) - ((%Az)*(%Az) + %Az)", &R, &H, &A, &Q, &B, &R);
    b = b && bap_is_zero_polynom_mpz (&R);

    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}
