#include "bap.h"

int main ()
{   struct bap_ratfrac_mpz Q;
    struct bap_polynom_mpz A;
    static char buffer [256];
    struct ba0_exception_code code;
    bav_Iordering r;
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2
        ("ordering (derivations = [x,y], blocks = [u,v,w,z])",
         "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_sscanf2 ("[u(x), v, w(y,x)]", "%t[%param]", &bav_parameters);

    bap_init_polynom_mpz (&A);
    ba0_sscanf2 ("u[y]", "%careful_expanded_Az", &A);
    ba0_sprintf (buffer, "%Az", &A);

    b = strcmp (buffer, "0") == 0;

    ba0_sscanf2 ("z[x,y] - z[y,x] + z - 1", "%careful_expanded_Az", &A);
    ba0_sprintf (buffer, "%Az", &A);
    b = b && strcmp (buffer, "z - 1") == 0;

    bap_init_ratfrac_mpz (&Q);
    BA0_PUSH_EXCEPTION (code);
    if (ba0_exception_is_set (code))
    {	ba0_sscanf2 ("u/u[y]", "%careful_expanded_Qz", &Q);
	return 1;
    } else if (ba0_mesgerr != BA0_ERRIVZ)
	return 1;
/*
 * Reinitialize Q
 */
    bap_init_ratfrac_mpz (&Q);
    ba0_sscanf2 ("(z[x,y] - z[y,x] - z + 1)/(v[y] - v)", "%careful_expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    b = b && strcmp (buffer, "(z - 1)/(v)") == 0;

    ba0_sscanf2 ("(z[x,y] - z[y,x] - v[y])/(v + 1)", "%careful_expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    b = b && strcmp (buffer, "0") == 0;

    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}
