#include "bap.h"

int main ()
{   struct bap_polynom_mpz A, C, R;
    bav_variable v;
    bav_Iordering r;
    char buffer [256];
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x], blocks = [u])", 
		 "%ordering", &r);
    bav_R_push_ordering (r);

    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&C);
    bap_init_polynom_mpz (&R);

    ba0_sscanf2 ("u[x,x]*u[x]^2*u + u[x,x]*u[x]*u + 2*u[x,x]*u[x] + u[x]^2 + 5*u + 1", 
		 "%Az", &A);

    ba0_sscanf2 ("u", "%v", &v);
    bap_coeff_and_reductum_polynom_mpz (&C, &R, &A, v, 1);
    ba0_sprintf (buffer, "%Az | %Az", &C, &R);
    b = strcmp (buffer, "u[x,x]*u[x]^2 + u[x,x]*u[x] + 5 | 2*u[x,x]*u[x] + u[x]^2 + 1") == 0;
    if (! b)
	return 1;

    bap_coeff_and_reductum_polynom_mpz (&C, &R, &A, v, 2);
    ba0_sprintf (buffer, "%Az | %Az", &C, &R);
    b = strcmp (buffer, "0 | u[x,x]*u[x]^2*u + u[x,x]*u[x]*u + 2*u[x,x]*u[x] + u[x]^2 + 5*u + 1") == 0;
    if (! b)
        return 1;

    bap_coeff_and_reductum_polynom_mpz (&C, &R, &A, v, 0);
    ba0_sprintf (buffer, "%Az | %Az", &C, &R);
    b = strcmp (buffer, "2*u[x,x]*u[x] + u[x]^2 + 1 | u[x,x]*u[x]^2*u + u[x,x]*u[x]*u + 5*u") == 0;
    if (! b)
        return 1;

    ba0_sscanf2 ("u[x]", "%v", &v);
    bap_coeff_and_reductum_polynom_mpz (&C, &R, &A, v, 2);
    ba0_sprintf (buffer, "%Az | %Az", &C, &R);
    b = strcmp (buffer, "u[x,x]*u + 1 | u[x,x]*u[x]*u + 2*u[x,x]*u[x] + 5*u + 1") == 0;
    if (! b)
        return 1;

    bav_R_pull_ordering ();
    bap_terminate (ba0_init_level);
    return 0;
}
