#include "bap.h"

int main ()
{   struct bap_polynom_mpz A, R;
    struct bav_term theta;
    struct bav_tableof_variable nulles;
    bav_symbol s;
    bav_Iordering r;
    bool b;
    char buffer [512];

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [u,v,p])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_init_table ((ba0_table)&nulles);
    ba0_sscanf2 ("[p[x], p[y]]", "%t[%v]", &nulles);

    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&R);
    ba0_sscanf2 ("u[x]^2 - p*u", "%Az", &A);

    ba0_sscanf2 ("x", "%y", &s);
    bap_diff_polynom_mpz (&R, &A, s, &nulles);
    ba0_sprintf (buffer, "%Az", &R);
    b = strcmp (buffer, "2*u[x,x]*u[x] - u[x]*p") == 0;

    bav_init_term (&theta);
    bap_diff2_polynom_mpz (&A, &A, &theta, &nulles);
    bap_diff2_polynom_mpz (&R, &A, &theta, &nulles);

    ba0_sprintf (buffer, "%Az", &R);
    b = b && strcmp (buffer, "u[x]^2 - u*p") == 0;

    ba0_sscanf2 ("x^2*y", "%term", &theta);
    bap_diff2_polynom_mpz (&R, &A, &theta, &nulles);

    ba0_sprintf (buffer, "%Az", &R);
    b = b && strcmp (buffer, "2*u[x,x,x,y]*u[x] + 2*u[x,x,x]*u[x,y] + 4*u[x,x,y]*u[x,x] - u[x,x,y]*p") == 0;

    bap_diff2_polynom_mpz (&A, &A, &theta, &nulles);

    ba0_sprintf (buffer, "%Az", &R);
    b = b && strcmp (buffer, "2*u[x,x,x,y]*u[x] + 2*u[x,x,x]*u[x,y] + 4*u[x,x,y]*u[x,x] - u[x,x,y]*p") == 0;

    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

