#include "bap.h"

int main ()
{   struct bap_product_mpz H;
    struct bap_polynom_mpz A, B, Q, R;
    bav_variable x;
    bav_Iordering r;
    char buffer [4096];
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x,y,z,t])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&B);
    bap_init_polynom_mpz (&Q);
    bap_init_polynom_mpz (&R);
    bap_init_product_mpz (&H);

    b = true;
/*
 * Basic
 */
    ba0_sscanf2 ("t*y^3-y^2+(z+1)*y-z", "%Az", &A);
    ba0_sscanf2 ("t*y^2+z*y-t", "%Az", &B);
    ba0_sscanf2 ("y", "%v", &x);

    bap_gcd_pseudo_division_polynom_mpz (&Q, &R, &H, &A, &B, x);
    ba0_sprintf (buffer, "(%Pz)*(%Az) - ((%Az)*(%Az) + (%Az))", &H, &A, &B, &Q, &R);

    b = b && strcmp (buffer, "(t)*(y^3*t - y^2 + y*z + y - z) - ((y^2*t + y*z - t)*(y*t - z - 1) + (y*z^2 + y*z*t + y*z + y*t^2 + y*t - 2*z*t - t))") == 0;
/*
 * A depends on a variable greater than the leader of B
 */
    ba0_sscanf2 ("t*x*y^3-x^2+(z+1)*x*y-z", "%Az", &A);
    ba0_sscanf2 ("t*y^2+z*y-t", "%Az", &B);
    ba0_sscanf2 ("y", "%v", &x);

    bap_gcd_pseudo_division_polynom_mpz (&Q, &R, &H, &A, &B, x);
    ba0_sprintf (buffer, "(%Pz)*(%Az) - ((%Az)*(%Az) + (%Az))", &H, &A, &B, &Q, &R);
    b = b && strcmp (buffer, "(t)*(-x^2 + x*y^3*t + x*y*z + x*y - z) - ((y^2*t + y*z - t)*(x*y*t - x*z) + (-x^2*t + x*y*z^2 + x*y*z*t + x*y*t^2 + x*y*t - x*z*t - z*t))") == 0;
/*
 * A depends on a variable lower than leader (B), which does not occur in B
 */
    ba0_sscanf2 ("t*x*y^3-x^2+(z+1)*x*y-z", "%Az", &A);
    ba0_sscanf2 ("t*x^2+z*x-t", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_gcd_pseudo_division_polynom_mpz (&Q, &R, &H, &A, &B, x);
    ba0_sprintf (buffer, "(%Pz)*(%Az) - ((%Az)*(%Az) + (%Az))", &H, &A, &B, &Q, &R);
    b = b && strcmp (buffer, "(t)*(-x^2 + x*y^3*t + x*y*z + x*y - z) - ((x^2*t + x*z - t)*(-1) + (x*y^3*t^2 + x*y*z*t + x*y*t + x*z - z*t - t))") == 0;
/*
 * B does not depend on the variable wrt which the pseudo-division is done
 */
    ba0_sscanf2 ("t*x*y^3-x^2+(z+1)*x*y-z", "%Az", &A);
    ba0_sscanf2 ("(z+t)*y^2+z*y-t", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_gcd_pseudo_division_polynom_mpz (&Q, &R, &H, &A, &B, x);
    ba0_sprintf (buffer, "(%Pz)*(%Az) - ((%Az)*(%Az) + (%Az))", &H, &A, &B, &Q, &R);
/*
 * The minus sign may change of place
 */
    b = b && 
       (strcmp (buffer, "((y^2*z + y^2*t + y*z - t))*(-x^2 + x*y^3*t + x*y*z + x*y - z) - ((y^2*z + y^2*t + y*z - t)*(-x^2 + x*y^3*t + x*y*z + x*y - z) + (0))") == 0 || 
	strcmp (buffer, "(- (y^2*z + y^2*t + y*z - t))*(-x^2 + x*y^3*t + x*y*z + x*y - z) - ((y^2*z + y^2*t + y*z - t)*(x^2 - x*y^3*t - x*y*z - x*y + z) + (0))") == 0);
/*
 * A does not depend either
 */
    ba0_sscanf2 ("t*y^4-t*y^2+t^3*(z+1)*y^2-z*t", "%Az", &A);
    ba0_sscanf2 ("t*y^2+t*y-t", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_gcd_pseudo_division_polynom_mpz (&Q, &R, &H, &A, &B, x);
    ba0_sprintf (buffer, "(%Pz)*(%Az) - ((%Az)*(%Az) + (%Az))", &H, &A, &B, &Q, &R);
    b = b && strcmp (buffer, "((y^2 + y - 1))*(y^4*t + y^2*z*t^3 + y^2*t^3 - y^2*t - z*t) - ((y^2*t + y*t - t)*(y^4 + y^2*z*t^2 + y^2*t^2 - y^2 - z) + (0))") == 0;
/*
 * A is zero
 */
    ba0_sscanf2 ("0", "%Az", &A);
    ba0_sscanf2 ("(z+t)*y^2+z*y-t", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_gcd_pseudo_division_polynom_mpz (&Q, &R, &H, &A, &B, x);
    ba0_sprintf (buffer, "(%Pz)*(%Az) - ((%Az)*(%Az) + (%Az))", &H, &A, &B, &Q, &R);
    b = b && strcmp (buffer, "(1)*(0) - ((y^2*z + y^2*t + y*z - t)*(0) + (0))") == 0;
/*
 * B is numeric
 */
    ba0_sscanf2 ("t*y^4-y^2+(z+1)*y^2-z", "%Az", &A);
    ba0_sscanf2 ("17", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_gcd_pseudo_division_polynom_mpz (&Q, &R, &H, &A, &B, x);
    ba0_sprintf (buffer, "(%Pz)*(%Az) - ((%Az)*(%Az) + (%Az))", &H, &A, &B, &Q, &R);
    b = b && strcmp (buffer, "(17)*(y^4*t + y^2*z - z) - ((17)*(y^4*t + y^2*z - z) + (0))") == 0;

    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

