#include "bap.h"

int main ()
{
#ifdef HAVE_MPFR_H

    bap_polynom_mpfr A, B, C;
    bap_polynom_mpfr zero;
    bav_Iordering r;
    struct ba0_mark M;

    bap_restart (0, 0);
    ba0_record (&M);
    ba0_sscanf2 ("ordering (derivations = [x, y], blocks = [u, v])", 
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_alloc (10);
    zero = bap_new_polynom_mpfr ();
    ba0_garbage ("%Afr", &M, &zero);
    if (! bap_is_zero_polynom_mpfr (zero))
	return 1;
    
    A = bap_new_polynom_mpfr ();
    B = bap_new_polynom_mpfr ();
    C = bap_new_polynom_mpfr ();
    ba0_sscanf2 ("0.3*u[x] + 1e7*u", "%Afr", A);
    ba0_sscanf2 (".21e-1*u[x] - 5*u", "%Afr", B);
    bap_mul_polynom_mpfr (A, A, B);
    ba0_sscanf2 (".63e-2*u[x]^2+209998.5*u[x]*u-.5e8*u^2", "%Afr", C);
    bap_sub_polynom_mpfr (B, A, C);
    if (! bap_is_zero_polynom_mpfr (B))
	return 1;

    ba0_sscanf2 ("0.3*u[x] + 1e7*u", "%Afr", A);
    ba0_sscanf2 (".21e-1*u[x] - 5*u", "%Afr", B);
    ba0_garbage ("%Afr %Afr %Afr", &M, &A, &B, &C);
    bap_mul_polynom_mpfr (A, A, B);
    bap_sub_polynom_mpfr (B, A, C);
    if (! bap_is_zero_polynom_mpfr (B))
	return 1;

    bav_R_pull_ordering ();
    ba0_restore (&M);
    bap_terminate (ba0_init_level);

#endif

    return 0;
}
