#include "bap.h"

int main ()
{   struct bap_polynom_mpz A, B, S, P;
    bap_polynom_mpz zero;
    bav_Iordering r;
    char buffer [256];
    ba0_int_p i;
    struct ba0_mark M;

    bap_restart (0, 0);
    ba0_record (&M);
    ba0_sscanf2 ("ordering (derivations = [x, y], blocks = [u, v])", 
		 "%ordering", &r);
    bav_R_push_ordering (r);

    ba0_alloc (10);
    zero = bap_new_polynom_mpz ();
    ba0_garbage ("%Az", &M, &zero);
    if (! bap_is_zero_polynom_mpz (zero))
	return 1;
    
    for (i = 0; i < 3; i++)
    {	if (i == 1)
	    bap_push_clot_parameters_stack 
		(bap_basic_termanager, bap_decreasing_monom_sequence);
	else if (i == 2)
	    bap_push_clot_parameters_stack
		(bap_hashing_termanager, bap_decreasing_monom_sequence);

	bap_init_polynom_mpz (&A);
	ba0_sscanf2 ("3*u[x]+v[x,y]-u^2+1", "%Az", &A);
	ba0_sprintf (buffer, "%Az", &A);
	if (strcmp (buffer, "3*u[x] - u^2 + v[x,y] + 1") != 0)
	    return 1;
	bap_init_polynom_mpz (&B);
	ba0_sscanf2 ("-v[x,y]+(u-1)*(u+1)", "%Az", &B);
	ba0_sprintf (buffer, "%Az", &B);
	if (strcmp (buffer, "u^2 - v[x,y] - 1") != 0)
	    return 1;
	bap_init_polynom_mpz (&S);
	bap_add_polynom_mpz (&S, &A, &B);
	ba0_sprintf (buffer, "%Az", &S);
	if (strcmp (buffer, "3*u[x]") != 0)
	    return 1;
	bap_init_polynom_mpz (&P);
	bap_mul_polynom_mpz (&P, &A, &B);
	ba0_sprintf (buffer, "%Az", &P);
	if (strcmp (buffer, "3*u[x]*u^2 - 3*u[x]*v[x,y] - 3*u[x] - u^4 + 2*u^2*v[x,y] + 2*u^2 - v[x,y]^2 - 2*v[x,y] - 1") != 0)
	    return 1;
    }
    bav_R_pull_ordering ();
    ba0_restore (&M);
    bap_terminate (ba0_init_level);
    return 0;
}
