#include "bap.h"

int main ()
{   struct bap_polynom_mpz A, B, Q, R;
    bav_variable x;
    bav_Iordering r;
    bav_Idegree d;
    char buffer [4096];
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x,y,z,t])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    bap_init_polynom_mpz (&A);
    bap_init_polynom_mpz (&B);
    bap_init_polynom_mpz (&Q);
    bap_init_polynom_mpz (&R);

    b = true;
/*
 * Basic
 */
    ba0_sscanf2 ("t*y^3-y^2+(z+1)*y-z", "%Az", &A);
    ba0_sscanf2 ("(z+t)*y^2+z*y-t", "%Az", &B);
    ba0_sscanf2 ("y", "%v", &x);

    bap_pseudo_division_polynom_mpz (&Q, &R, &d, &A, &B, x);
    ba0_sprintf (buffer, "Q = %Az, R = %Az, d = %d", &Q, &R, d);
    b = b && strcmp (buffer, "Q = y*z*t + y*t^2 - z*t - z - t, R = y*z^3 + 3*y*z^2*t + 2*y*z^2 + 2*y*z*t^2 + 3*y*z*t + y*t^3 + y*t^2 - z^3 - 2*z^2*t - 2*z*t^2 - z*t - t^2, d = 2") == 0;
/*
 * A depends on a variable greater than the leader of B
 */
    ba0_sscanf2 ("t*x*y^3-x^2+(z+1)*x*y-z", "%Az", &A);
    ba0_sscanf2 ("(z+t)*y^2+z*y-t", "%Az", &B);
    ba0_sscanf2 ("y", "%v", &x);

    bap_pseudo_division_polynom_mpz (&Q, &R, &d, &A, &B, x);
    ba0_sprintf (buffer, "Q = %Az, R = %Az, d = %d", &Q, &R, d);
    b = b && strcmp (buffer, "Q = x*y*z*t + x*y*t^2 - x*z*t, R = -x^2*z^2 - 2*x^2*z*t - x^2*t^2 + x*y*z^3 + 3*x*y*z^2*t + x*y*z^2 + 2*x*y*z*t^2 + 2*x*y*z*t + x*y*t^3 + x*y*t^2 - x*z*t^2 - z^3 - 2*z^2*t - z*t^2, d = 2") == 0;
/*
 * A depends on a variable lower than leader (B), which does not occur in B
 */
    ba0_sscanf2 ("t*x*y^3-x^2+(z+1)*x*y-z", "%Az", &A);
    ba0_sscanf2 ("(z+t)*x^2+z*x-t", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_pseudo_division_polynom_mpz (&Q, &R, &d, &A, &B, x);
    ba0_sprintf (buffer, "Q = %Az, R = %Az, d = %d", &Q, &R, d);
    b = b && strcmp (buffer, "Q = -1, R = x*y^3*z*t + x*y^3*t^2 + x*y*z^2 + x*y*z*t + x*y*z + x*y*t + x*z - z^2 - z*t - t, d = 1") == 0;
/*
 * B does not depend on the variable wrt which the pseudo-division is done
 */
    ba0_sscanf2 ("t*x*y^3-x^2+(z+1)*x*y-z", "%Az", &A);
    ba0_sscanf2 ("(z+t)*y^2+z*y-t", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_pseudo_division_polynom_mpz (&Q, &R, &d, &A, &B, x);
    ba0_sprintf (buffer, "Q = %Az, R = %Az, d = %d", &Q, &R, d);
    b = b && strcmp (buffer, "Q = -x^2*y^4*z^2 - 2*x^2*y^4*z*t - x^2*y^4*t^2 - 2*x^2*y^3*z^2 - 2*x^2*y^3*z*t - x^2*y^2*z^2 + 2*x^2*y^2*z*t + 2*x^2*y^2*t^2 + 2*x^2*y*z*t - x^2*t^2 + x*y^7*z^2*t + 2*x*y^7*z*t^2 + x*y^7*t^3 + 2*x*y^6*z^2*t + 2*x*y^6*z*t^2 + x*y^5*z^3 + 3*x*y^5*z^2*t + x*y^5*z^2 - x*y^5*z*t^2 + 2*x*y^5*z*t - 2*x*y^5*t^3 + x*y^5*t^2 + 2*x*y^4*z^3 + 2*x*y^4*z^2*t + 2*x*y^4*z^2 - 2*x*y^4*z*t^2 + 2*x*y^4*z*t + x*y^3*z^3 - 2*x*y^3*z^2*t + x*y^3*z^2 - 2*x*y^3*z*t^2 - 2*x*y^3*z*t + x*y^3*t^3 - 2*x*y^3*t^2 - 2*x*y^2*z^2*t - 2*x*y^2*z*t + x*y*z*t^2 + x*y*t^2 - y^4*z^3 - 2*y^4*z^2*t - y^4*z*t^2 - 2*y^3*z^3 - 2*y^3*z^2*t - y^2*z^3 + 2*y^2*z^2*t + 2*y^2*z*t^2 + 2*y*z^2*t - z*t^2, R = 0, d = 3") == 0;
/*
 * A does not depend either
 */
    ba0_sscanf2 ("t*y^4-y^2+(z+1)*y^2-z", "%Az", &A);
    ba0_sscanf2 ("(z+t)*y^2+z*y-t", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_pseudo_division_polynom_mpz (&Q, &R, &d, &A, &B, x);
    ba0_sprintf (buffer, "Q = %Az, R = %Az, d = %d", &Q, &R, d);
    b = b && strcmp (buffer, "Q = y^4*t + y^2*z - z, R = 0, d = 1") == 0;
/*
 * A is zero
 */
    ba0_sscanf2 ("0", "%Az", &A);
    ba0_sscanf2 ("(z+t)*y^2+z*y-t", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_pseudo_division_polynom_mpz (&Q, &R, &d, &A, &B, x);
    ba0_sprintf (buffer, "Q = %Az, R = %Az, d = %d", &Q, &R, d);
    b = b && strcmp (buffer, "Q = 0, R = 0, d = 0") == 0;
/*
 * B is numeric
 */
    ba0_sscanf2 ("t*y^4-y^2+(z+1)*y^2-z", "%Az", &A);
    ba0_sscanf2 ("17", "%Az", &B);
    ba0_sscanf2 ("x", "%v", &x);

    bap_pseudo_division_polynom_mpz (&Q, &R, &d, &A, &B, x);
    ba0_sprintf (buffer, "Q = %Az, R = %Az, d = %d", &Q, &R, d);
    b = b && strcmp (buffer, "Q = y^4*t + y^2*z - z, R = 0, d = 1") == 0;

    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

