#include "bap.h"

int main ()
{
    bav_Iordering r;
    struct bap_ratfrac_mpz Q;
    char buffer [256];

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [x,y], blocks = [u, v])",
		 "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_ratfrac_mpz (&Q);
    ba0_sscanf2 ("0", "%expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "0") != 0)
        return 1;
    ba0_sscanf2 ("1+v", "%expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "v + 1") != 0)
        return 1;
    ba0_sscanf2 ("2/3/u", "%expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(2)/(3*u)") != 0)
        return 1;
    ba0_sscanf2 ("1/2*u[x,x] + u[x] + 1/2*u", "%expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(u[x,x] + 2*u[x] + u)/(2)") != 0)
        return 1;
    ba0_sscanf2 ("1/2*(u[x,x]+4*u[x]+u)/v", "%expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(u[x,x] + 4*u[x] + u)/(2*v)") != 0)
        return 1;
    ba0_sscanf2 ("(u[x]*u[y] + v)/(u[y])", "%expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(u[x]*u[y] + v)/(u[y])") != 0)
        return 1;
    ba0_sscanf2 ("-3/4*u[x]/u[y]", "%expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(-3*u[x])/(4*u[y])") != 0)
        return 1;
    ba0_sscanf2 ("1/u", "%expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(1)/(u)") != 0)
        return 1;
/*
 * Fix me
    ba0_sscanf2 ("2/u*u[x]", "%expanded_Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(2*u[x])/(u)") != 0)
        return 1;
*/
    ba0_sscanf2 ("2/u*u[x]", "%Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(2*u[x])/(u)") != 0)
        return 1;
    ba0_sscanf2 ("u[x] +v/u[y]", "%Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(u[x]*u[y] + v)/(u[y])") != 0)
	return 1;
    ba0_sscanf2 ("1/((u[x] + v/u[y])/(u - x))", "%Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(u[y]*u - u[y]*x)/(u[x]*u[y] + v)") != 0)
        return 1;
    ba0_sscanf2 ("1/((u[x] + v/u[y])/(u - x)) - u[y]/((u[x]*u[y] + v))*u", 
								"%Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "(-u[y]*x)/(u[x]*u[y] + v)") != 0)
	return 1;
    ba0_sscanf2 ("0", "%Qz", &Q);
    ba0_sprintf (buffer, "%Qz", &Q);
    if (strcmp (buffer, "0")  != 0)
        return 1;
    bav_R_pull_ordering ();
    bav_terminate (ba0_init_level);
    return 0;
}
