#include "bap.h"

int main ()
{   struct bap_polynom_mpz A;
    bap_polynom_mpz B;
    bav_differential_ring R;
    bav_Iordering r;
    struct ba0_stack H;
    void *cell;
    ba0_int_p size;
    char buffer [256];
    bool b;

    bap_restart (0, 0);

    ba0_push_stack (&ba0_quiet_stack);
    ba0_alloc (10);
    ba0_pull_stack ();

    ba0_sscanf2 ("ordering (derivations = [t], blocks = [u,v])",
		 "%ordering", &r);
    bav_R_push_ordering (r);

    bap_init_polynom_mpz (&A);
    ba0_sscanf2 ("123456789*u[t]*t + u + 1", "%Az", &A);

    size = bav_sizeof_differential_ring (&bav_R) +
	   bap_sizeof_polynom_mpz (&A);

    cell = (void*)malloc (size);

    ba0_init_one_cell_stack (&H, "local stack", cell, size);

    ba0_push_stack (&H);
    R = bav_new_differential_ring ();
    bav_set_differential_ring (R, &bav_R);
    B = bap_new_polynom_mpz ();
    bap_set_polynom_mpz (B, &A);
    bap_switch_ring_polynom_mpz (B, R);
    ba0_pull_stack ();

    ba0_clear_one_cell_stack (&H);
    bap_terminate (ba0_init_level);

    bap_restart (0, 0);
    ba0_push_stack (&ba0_quiet_stack);
    bav_set_differential_ring (&bav_R, R);

    ba0_sprintf (buffer, "%Az", B);
    b = strcmp (buffer, "123456789*u[t]*t + u + 1") == 0;

    bap_terminate (ba0_init_level);

    free (cell);

    return b ? 0 : 1;
}
     

