#include "bap.h"

int main ()
{   bav_Iordering r;
    struct bap_polynom_mpz A;
    struct bap_product_mpz P;
    char buffer [256];
    bool b;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [g])", 
		 "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
/*
 * The given polynomials must be numerically primitive, with no factor
 * of the form x^k. But a numerical factor (-1) is allowed
 */
    ba0_sscanf2 ("-g^4 - 2*g^2 - 1", "%Az", &A);
    bap_init_product_mpz (&P);
    bap_squarefree_polynom_mpz (&P, &A);
    ba0_sprintf (buffer, "%Pz", &P);
    b = strcmp (buffer, "- (g^2 + 1)^2") == 0;

    ba0_sscanf2 ("-(2*g+3)^3", "%Az", &A);
    bap_squarefree_polynom_mpz (&P, &A);
    ba0_sprintf (buffer, "%Pz", &P);
    b = b && strcmp (buffer, "- (2*g + 3)^3") == 0;

    ba0_sscanf2 ("-(2*g^2+3*g-1)^2", "%Az", &A);
    bap_squarefree_polynom_mpz (&P, &A);
    ba0_sprintf (buffer, "%Pz", &P);
    b = b && strcmp (buffer, "- (2*g^2 + 3*g - 1)^2") == 0;

    ba0_sscanf2 ("-(2*g^2+3*g-1)^4", "%Az", &A);
    bap_squarefree_polynom_mpz (&P, &A);
    ba0_sprintf (buffer, "%Pz", &P);
    b = b && strcmp (buffer, "- (2*g^2 + 3*g - 1)^4") == 0;


    bap_terminate (ba0_init_level);
    return b ? 0 : 1;
}

