#include "bav_block.h"

BAV_DLL void bav_init_block (bav_block b)
{
    ba0_init_table ((ba0_table)&b->indices);
    ba0_init_table ((ba0_table)&b->strs);
}

BAV_DLL void bav_reset_block (bav_block b)
{
    ba0_reset_table ((ba0_table)&b->indices);
    ba0_reset_table ((ba0_table)&b->strs);
}

BAV_DLL bool bav_is_empty_block (bav_block b)
{
    return b->strs.size == 0;
}

BAV_DLL bav_block bav_new_block (void)
{   bav_block b;

    b = (bav_block)ba0_alloc (sizeof (struct bav_block));
    bav_init_block (b);
    return b;
}

BAV_DLL void* bav_scanf_block (void* z)
{   bav_block b;

    if (z == (void*)0)
	b = bav_new_block ();
    else
	b = (bav_block)z;

    if (ba0_sign_token_analex ("["))
    {	bav_is_subranking ("grlexA", &b->subr);
	ba0_scanf ("%t[%six]", &b->strs);
    } else if (ba0_type_token_analex () != ba0_string_token)
    {	BA0_RAISE_PARSER_EXCEPTION (BAV_ERRBLO);
    } else if (bav_is_subranking (ba0_value_token_analex (), &b->subr))
    {	ba0_get_token_analex ();
	ba0_scanf ("%t[%six]", &b->strs);
    } else
    {	bav_is_subranking ("grlexA", &b->subr);
	ba0_realloc_table ((ba0_table)&b->strs, 1);
	b->strs.tab [0] = (char*)ba0_scanf_indexed_string (0);
	b->strs.size = 1;
    }

    ba0_reset_table ((ba0_table)&b->indices);
    return b;
}

BAV_DLL void bav_printf_block (void* z)
{   bav_block b = (bav_block)z;

    ba0_printf ("%s%t[%s]", bav_subranking_table [b->subr].ident, &b->strs);
}


