#ifndef BAV_DIFFERENTIAL_RING_H
#define BAV_DIFFERENTIAL_RING_H 1

#include "bav_common.h"
#include "bav_block.h"
#include "bav_symbol.h"
#include "bav_variable.h"
#include "bav_operator.h"
#include "bav_ordering.h"

BEGIN_C_DECLS

#define BAV_NOT_AN_OPINDEX	-1

/*
   ders [i] = the index in vars of the independent variable which has
	root->derivation_index = i.
*/

typedef struct bav_differential_ring {
    bool empty;
    struct ba0_tableof_string strs;
    struct bav_tableof_symbol syms;
    struct bav_tableof_variable vars;
    struct ba0_tableof_int_p  ders;
    struct ba0_tableof_int_p  deps;
    struct ba0_tableof_int_p  tmps;
    struct ba0_tableof_int_p  tmps_in_use;
    ba0_int_p opra;
    struct bav_tableof_ordering ords;
    struct bav_tableof_Iordering ord_stack;
} *bav_differential_ring;

#define bav_R	bav_global.differential_ring.R

extern  BAV_DLL void bav_init_differential_ring (bav_differential_ring);
extern  BAV_DLL bav_differential_ring bav_new_differential_ring (void);
extern  BAV_DLL unsigned ba0_int_p bav_sizeof_differential_ring 
			(bav_differential_ring);
extern  BAV_DLL void bav_set_differential_ring 
			(bav_differential_ring, bav_differential_ring);
extern  BAV_DLL void bav_R_init (void);
extern  BAV_DLL bool bav_R_is_empty (void);
extern  BAV_DLL void bav_R_create 
			(ba0_tableof_string, bav_tableof_block, bav_block);
extern  BAV_DLL bav_Iordering bav_R_new_ranking 
			(ba0_tableof_string, bav_tableof_block, bav_block);
extern  BAV_DLL bav_Iordering bav_R_copy_ordering (bav_Iordering);
extern  BAV_DLL bav_variable bav_R_new_temporary_variable (void);
extern  BAV_DLL bool bav_R_ambiguous_symbols (void);
extern  BAV_DLL void bav_R_free_temporary_variable (bav_variable);
extern  BAV_DLL void bav_R_set_maximal_variable (bav_variable);
extern  BAV_DLL void bav_R_swap_ordering (bav_Iordering, bav_Iordering);
extern  BAV_DLL void bav_R_free_ordering (bav_Iordering);
extern  BAV_DLL ba0_extra_restore_function bav_R_restore_ords_size;
extern  BAV_DLL void bav_R_push_ordering (bav_Iordering);
extern  BAV_DLL void bav_R_pull_ordering (void);
extern  BAV_DLL bool bav_exists_ordering (bav_Iordering);
extern  BAV_DLL bav_Iordering bav_R_Iordering (void);
extern  BAV_DLL bav_ordering bav_R_ordering (void);
extern  BAV_DLL bav_Inumber bav_R_variable_number (bav_variable);
#define bav_variable_number bav_R_variable_number
extern  BAV_DLL bav_Inumber bav_R_symbol_block_number (bav_symbol, ba0_int_p*);
#define bav_symbol_block_number bav_R_symbol_block_number
extern  BAV_DLL bav_variable bav_R_derivative (bav_variable, bav_symbol);
extern  BAV_DLL bav_variable bav_R_symbol_to_variable (bav_symbol);
#define bav_symbol_to_variable bav_R_symbol_to_variable
extern  BAV_DLL bav_symbol bav_R_string_to_symbol (char*);
extern  BAV_DLL bav_symbol bav_R_string_to_derivation (char*);
extern  BAV_DLL bav_variable bav_R_string_to_variable (char*);
extern  BAV_DLL bav_variable bav_R_derivation_index_to_derivation (ba0_int_p);
extern  BAV_DLL void bav_R_mark_variables (ba0_int_p);
extern  BAV_DLL void bav_R_marked_variables (bav_tableof_variable, ba0_int_p);

END_C_DECLS

#endif /* !BAV_DIFFERENTIAL_RING_H */
