#include "bav_ev_point.h"

BAV_DLL void bav_init_ev_point (bav_ev_point point)
{
    point->alloc = 0;
    point->size = 0;
    point->tab = (struct bav_ev_value*)0;
}

BAV_DLL void bav_realloc_ev_point (bav_ev_point point, ba0_int_p n)
{   struct bav_ev_value* tab;

    if (n > point->alloc)
    {	tab = (struct bav_ev_value*)ba0_alloc 
				(sizeof (struct bav_ev_value) * n);
	memcpy (tab, point->tab, point->size * sizeof (struct bav_ev_value));
	point->tab = tab;
	point->alloc = n;
    }
}

BAV_DLL void bav_set_ev_point (bav_ev_point P, bav_ev_point Q)
{
    P->size = 0;
    bav_realloc_ev_point (P, Q->size);
    memcpy (P->tab, Q->tab, Q->size * sizeof (struct bav_ev_value));
    P->size = Q->size;
}

BAV_DLL void* bav_scanf_ev_point (void* z)
{
    BA0_RAISE_EXCEPTION (BA0_ERRNYP);
    return z;
}

/*
\paragraph{void bav_printf_ev_point (void* z)}
Imprime le {\tt bav_ev_point} $z$.
*/

BAV_DLL void bav_printf_ev_point (void* z)
{   bav_ev_point point = (bav_ev_point)z;
    ba0_int_p i;

    ba0_put_char ('[');
    for (i = 0; i < point->size; i++)
    {	bav_printf_variable (point->tab [i].var);
	ba0_put_string (" = ");
	ba0_put_int_p (point->tab [i].value);
	if (i < point->size - 1)
	    ba0_put_string (", ");
    }
    ba0_put_char (']');
}

BAV_DLL ba0_int_p bav_garbage1_ev_point (void* z, enum ba0_garbage_code code)
{
    BA0_RAISE_EXCEPTION (BA0_ERRNYP);
    z = 0;		/* to avoid a warning */
    code = ba0_isolated;
    return 0;
}

BAV_DLL void* bav_garbage2_ev_point (void* z, enum ba0_garbage_code code)
{
    BA0_RAISE_EXCEPTION (BA0_ERRNYP);
    code = ba0_isolated;
    return z;
}

BAV_DLL void* bav_copy_ev_point (void* z)
{
    BA0_RAISE_EXCEPTION (BA0_ERRNYP);
    return z;
}

BAV_DLL void bav_shift_ev_point (bav_ev_point A, bav_ev_point B)
{
    if (B->size == 0)
	BA0_RAISE_EXCEPTION (BA0_ERRALG);

    if (A != B)
    {	A->size = 0;
	bav_realloc_ev_point (A, B->size - 1);
    }
    memmove (A->tab, B->tab + 1, (B->size - 1) * sizeof (struct bav_ev_value));
    A->size = B->size - 1;
}

