#ifndef BAV_PARAMETER_H
#define BAV_PARAMETER_H 1

#include "bav_symbol.h"

BEGIN_C_DECLS

typedef struct bav_parameter {
    bav_symbol root;
    struct bav_tableof_symbol dep;
} *bav_parameter;

typedef struct bav_tableof_parameter {
    ba0_int_p alloc;
    ba0_int_p size;
    bav_parameter* tab;
} *bav_tableof_parameter;

#define bav_parameters	bav_global.parameter.table

extern BAV_DLL void bav_init_parameters (bav_tableof_parameter);
extern BAV_DLL bav_tableof_parameter bav_new_parameters (void);
extern BAV_DLL void bav_reset_parameters (bav_tableof_parameter);
extern BAV_DLL unsigned ba0_int_p bav_sizeof_parameters 
			(bav_tableof_parameter);
extern BAV_DLL void bav_set_parameters 
			(bav_tableof_parameter, bav_tableof_parameter);

struct bav_differential_ring;
extern BAV_DLL void bav_switch_ring_parameters 
		(bav_tableof_parameter, struct bav_differential_ring*);

extern BAV_DLL void bav_init_parameter (bav_parameter);
extern BAV_DLL bav_parameter bav_new_parameter (void);
extern BAV_DLL void bav_set_parameter (bav_parameter, bav_parameter);
extern BAV_DLL void bav_set_parameter_symbol_table 
			(bav_parameter, bav_symbol, bav_tableof_symbol);

extern BAV_DLL bool bav_is_a_parameter 
			(bav_symbol, ba0_int_p*, bav_tableof_parameter);

struct bav_variable;
extern BAV_DLL bool bav_is_zero_derivative_of_parameter 
			(struct bav_variable*, bav_tableof_parameter);

struct bav_tableof_variable;
extern BAV_DLL void bav_zero_derivatives_of_parameter
			(struct bav_tableof_variable*, bav_parameter);
extern BAV_DLL void bav_zero_derivatives_of_tableof_parameter
			(struct bav_tableof_variable*, bav_tableof_parameter);

extern BAV_DLL ba0_scanf_function bav_scanf_parameter;
extern BAV_DLL ba0_printf_function bav_printf_parameter;

END_C_DECLS

#endif /*! BAV_PARAMETER_H */
