#ifndef BAV_RANK_H
#define BAV_RANK_H 1

#include "bav_common.h"
#include "bav_variable.h"

BEGIN_C_DECLS

typedef struct bav_rank {
    bav_variable var;
    bav_Idegree deg;
} *bav_rank;

extern BAV_DLL void bav_init_rank (bav_rank);
extern BAV_DLL bav_rank bav_new_rank (void);
extern BAV_DLL bool bav_is_zero_rank (bav_rank);
extern BAV_DLL bool bav_is_constant_rank (bav_rank);
extern BAV_DLL bool bav_lt_rank (bav_rank, bav_rank);
extern BAV_DLL bool bav_gt_rank (bav_rank, bav_rank);
extern BAV_DLL bool bav_equal_rank (bav_rank, bav_rank);

extern BAV_DLL int bav_inv_comp_rank (const void*, const void*);

extern BAV_DLL struct bav_rank bav_zero_rank (void);
extern BAV_DLL struct bav_rank bav_constant_rank (void);

extern BAV_DLL void bav_set_settings_rank (ba0_printf_function*);
extern BAV_DLL void bav_get_settings_rank (ba0_printf_function**);

extern BAV_DLL ba0_scanf_function bav_scanf_rank;
extern BAV_DLL ba0_printf_function bav_printf_rank;
extern BAV_DLL ba0_printf_function bav_printf_default_rank;

typedef struct bav_tableof_rank {
    ba0_int_p alloc;
    ba0_int_p size;
    struct bav_rank* *tab;
} *bav_tableof_rank;

END_C_DECLS
#endif /* !BAV_RANK_H */
