#include "bav_symbol.h"
#include "bav_differential_ring.h"
#include "bav_global.h"

#define bav_custom_scanf_symbol bav_initialized_global.symbol.scanf
#define bav_custom_printf_symbol bav_initialized_global.symbol.printf

BAV_DLL void bav_set_settings_symbol 
			(ba0_scanf_function* s, ba0_printf_function* p)
{
    bav_custom_scanf_symbol = s ? s : &bav_scanf_default_symbol;
    bav_custom_printf_symbol = p ? p : &bav_printf_default_symbol;
}

BAV_DLL void bav_get_settings_symbol 
			(ba0_scanf_function** s, ba0_printf_function** p)
{
    if (s) *s = bav_custom_scanf_symbol;
    if (p) *p = bav_custom_printf_symbol;
}

BAV_DLL void bav_init_symbol (bav_symbol s)
{
    s->ident = (char*)0;
}

BAV_DLL bav_symbol bav_new_symbol (void)
{   bav_symbol s;

    s = (bav_symbol)ba0_alloc (sizeof (struct bav_symbol));
    bav_init_symbol (s);
    return s;
}

BAV_DLL bav_symbol bav_not_a_symbol (void)
{
    return BAV_NOT_A_SYMBOL;
}

BAV_DLL bool bav_is_a_derivation (char* string)
{
    return bav_R_string_to_derivation (string) != BAV_NOT_A_SYMBOL;
}

BAV_DLL bav_symbol bav_switch_ring_symbol 
				(bav_symbol s, bav_differential_ring R)
{
    return R->syms.tab [s->index];
}

BAV_DLL void* bav_scanf_default_symbol (void* z)
{   char* s;
    ba0_indexed x;
    bav_symbol y;
    struct ba0_mark M;
    
    ba0_push_another_stack ();
    ba0_record (&M);
    x = ba0_scanf_indexed (0, 0, 0);
    s = ba0_indexed_to_string (x);
    ba0_pull_stack ();

    y = bav_R_string_to_symbol (s); 
    if (y == BAV_NOT_A_SYMBOL)
    {	(*bav_custom_unknown) (x);
	BA0_RAISE_PARSER_EXCEPTION (BAV_ERRUSY);
    }
    if (z != (void*)0)
	*(bav_symbol*)z = y;
    ba0_restore (&M);
    return y;
}

BAV_DLL void* bav_scanf_basic_symbol (void* z)
{   char* s;
    bav_symbol y;
    struct ba0_mark M;

    ba0_push_another_stack ();
    ba0_record (&M);
    s = ba0_scanf_string (0);
    ba0_pull_stack ();

    y = bav_R_string_to_symbol (s);
    if (y == BAV_NOT_A_SYMBOL)
        BA0_RAISE_PARSER_EXCEPTION (BAV_ERRUSY);
    if (z != (void*)0)
        *(bav_symbol*)z = y;
    ba0_restore (&M);
    return y;
}

BAV_DLL void bav_printf_default_symbol (void* z)
{   bav_symbol s = (bav_symbol) z;
    ba0_put_string (s->ident);
}

BAV_DLL void bav_printf_numbered_symbol (void* z)
{   bav_symbol s = (bav_symbol) z;

    if (s->type == bav_independent_symbol || s->type == bav_dependent_symbol)
	ba0_printf ("%s%d", "_", s->index);
    else
	BA0_RAISE_EXCEPTION (BA0_ERRALG);
}

BAV_DLL void* bav_scanf_symbol (void* z)
{   void* r = (void*)0;

    if (bav_custom_scanf_symbol != (ba0_scanf_function*)0)
	r = (*bav_custom_scanf_symbol) (z);
    else
	BA0_RAISE_EXCEPTION (BA0_ERRALG);
    return r;
}

BAV_DLL void bav_printf_symbol (void* z)
{
    if (bav_custom_printf_symbol != (ba0_printf_function*)0)
	(*bav_custom_printf_symbol) (z);
    else
	BA0_RAISE_EXCEPTION (BA0_ERRALG);
}

