#ifndef BAV_TERM_H
#define BAV_TERM_H 1

#include "bav_common.h"
#include "bav_rank.h"
#include "bav_ev_point.h"
#include "bav_parameter.h"

BEGIN_C_DECLS

typedef struct bav_term {
    ba0_int_p alloc;
    ba0_int_p size;
    struct bav_rank* rg;
} *bav_term;

typedef struct bav_listof_term {
    bav_term value;
    struct bav_listof_term* next;
} *bav_listof_term;

typedef struct bav_tableof_term {
    ba0_int_p alloc;
    ba0_int_p size;
    bav_term* tab;
} *bav_tableof_term;

extern BAV_DLL void bav_realloc_term (bav_term, ba0_int_p);
extern BAV_DLL void bav_init_term (bav_term);
extern BAV_DLL bav_term bav_new_term (void);
extern BAV_DLL void bav_set_term_one (bav_term);
extern BAV_DLL void bav_set_term_variable (bav_term, bav_variable, bav_Idegree);
extern BAV_DLL void bav_set_term_rank (bav_term, bav_rank);
extern BAV_DLL void bav_set_term (bav_term, bav_term);
extern BAV_DLL void bav_shift_term (bav_term, bav_term);
extern BAV_DLL void bav_strip_term (bav_term, bav_term, bav_Inumber);
extern BAV_DLL bool bav_is_one_term (bav_term);
extern BAV_DLL bav_variable bav_leader_term (bav_term);
extern BAV_DLL bav_Idegree bav_leading_degree_term (bav_term);
extern BAV_DLL bav_Idegree bav_total_degree_term (bav_term);
extern BAV_DLL bav_Idegree bav_degree_term (bav_term, bav_variable);
extern BAV_DLL bav_Iorder bav_total_order_term (bav_term);
extern BAV_DLL bav_Idegree bav_maximal_degree_term (bav_term);
extern BAV_DLL struct bav_rank bav_rank_term (bav_term);
extern BAV_DLL bool bav_disjoint_term (bav_term, bav_term);
extern BAV_DLL bool bav_equal_term (bav_term, bav_term);
extern BAV_DLL void bav_sort_term (bav_term);
extern BAV_DLL void bav_lcm_term (bav_term, bav_term, bav_term);
extern BAV_DLL void bav_gcd_term (bav_term, bav_term, bav_term);
extern BAV_DLL void bav_mul_term (bav_term, bav_term, bav_term);
extern BAV_DLL void bav_mul_term_rank (bav_term, bav_term, bav_rank);
extern BAV_DLL void bav_mul_term_variable 
			(bav_term, bav_term, bav_variable, bav_Idegree);
extern BAV_DLL void bav_pow_term (bav_term, bav_term, bav_Idegree);
extern BAV_DLL void bav_exquo_term (bav_term, bav_term, bav_term);
extern BAV_DLL void bav_exquo_term_variable 
			(bav_term, bav_term, bav_variable, bav_Idegree);
extern BAV_DLL bool bav_is_factor_term (bav_term, bav_term, bav_term);
extern BAV_DLL void bav_diff_term 
			(bav_term, bav_term, bav_symbol, bav_tableof_variable);
extern BAV_DLL void bav_marked_ranks_term (bav_term);
extern BAV_DLL void bav_term_at_ev_point (ba0_mpz_t, bav_term, bav_ev_point);

extern BAV_DLL ba0_garbage1_function bav_garbage1_term;
extern BAV_DLL ba0_garbage2_function bav_garbage2_term;
extern BAV_DLL ba0_scanf_function bav_scanf_term;
extern BAV_DLL ba0_printf_function bav_printf_term;
extern BAV_DLL ba0_copy_function bav_copy_term;

struct bav_differential_ring;

extern BAV_DLL void bav_switch_ring_term 
				(bav_term, struct bav_differential_ring*);
extern BAV_DLL bool bav_depends_on_zero_derivatives_of_parameter_term
				(bav_term, bav_tableof_parameter);

END_C_DECLS
#endif /* !BAV_TERM_H */
