#ifndef BAV_VARIABLE_H
#define BAV_VARIABLE_H 1

#include "bav_common.h"
#include "bav_symbol.h"

BEGIN_C_DECLS

struct bav_variable;

typedef struct bav_tableof_variable {
    ba0_int_p alloc;
    ba0_int_p size;
    struct bav_variable* *tab;
} *bav_tableof_variable;

typedef struct bav_tableof_tableof_variable {
    ba0_int_p alloc;
    ba0_int_p size;
    struct bav_tableof_variable* *tab;
} *bav_tableof_tableof_variable;

typedef struct bav_variable {
    bav_symbol	root;
    ba0_int_p   hack;
    ba0_int_p	index;
    struct bav_tableof_Inumber number;
    struct bav_tableof_Iorder order;
    struct bav_tableof_variable derivative;
} *bav_variable;

#define BAV_NOT_A_VARIABLE	(bav_variable)0
#define BAV_TEMP_STRING		"_"

#define bav_temp_string         bav_initialized_global.variable.temp_string

struct bav_term;

extern BAV_DLL void bav_set_settings_variable 
			(ba0_scanf_function*, ba0_printf_function*, char*);
extern BAV_DLL void bav_get_settings_variable 
			(ba0_scanf_function**, ba0_printf_function**, char**);

extern BAV_DLL void bav_init_variable (bav_variable);
extern BAV_DLL bav_variable bav_new_variable (void);
extern BAV_DLL bav_variable bav_not_a_variable (void);
extern BAV_DLL bav_Iorder bav_order_variable (bav_variable, bav_symbol);
extern BAV_DLL bav_Iorder bav_total_order_variable (bav_variable);
extern BAV_DLL bav_variable bav_diff_variable (bav_variable, bav_symbol);
extern BAV_DLL bav_variable bav_diff2_variable (bav_variable, struct bav_term*);
extern BAV_DLL bav_variable bav_int_variable (bav_variable, bav_symbol);
extern BAV_DLL enum bav_typeof_symbol bav_symbol_type_variable (bav_variable);
extern BAV_DLL bav_variable bav_order_zero_variable (bav_variable);
extern BAV_DLL bav_variable bav_lcd_variable (bav_variable, bav_variable);
extern BAV_DLL bool bav_disjoint_variables (bav_variable, bav_variable);
extern BAV_DLL bool bav_is_derivative (bav_variable, bav_variable);
extern BAV_DLL bool bav_is_proper_derivative (bav_variable, bav_variable);
extern BAV_DLL bool bav_is_d_derivative 
				(bav_variable, bav_variable, bav_symbol);
extern BAV_DLL bool bav_is_derivative2 (bav_variable, bav_tableof_variable);
extern BAV_DLL bav_variable bav_derivation_between_derivatives 
				(bav_variable, bav_variable);
extern BAV_DLL void bav_operator_between_derivatives 
				(struct bav_term*, bav_variable, bav_variable);
extern BAV_DLL  bav_variable bav_next_derivative 
				(bav_variable, bav_tableof_variable);

extern BAV_DLL ba0_mint_hp bav_random_eval_variable_to_mint_hp (bav_variable);

extern BAV_DLL ba0_scanf_function bav_scanf_jet_variable;
extern BAV_DLL ba0_scanf_function bav_scanf_diff_variable;
extern BAV_DLL ba0_scanf_function bav_scanf_Diff_variable;

extern BAV_DLL ba0_printf_function bav_printf_jet_variable;
extern BAV_DLL ba0_printf_function bav_printf_jet_wesb_variable;
extern BAV_DLL ba0_printf_function bav_printf_LaTeX_variable;
extern BAV_DLL ba0_printf_function bav_printf_diff_variable;
extern BAV_DLL ba0_printf_function bav_printf_Diff_variable;

extern BAV_DLL ba0_scanf_function bav_scanf_variable;
extern BAV_DLL ba0_printf_function bav_printf_variable;
extern BAV_DLL ba0_cmp_function bav_gt_index_variable;
extern BAV_DLL ba0_cmp_function bav_gt_variable;

extern BAV_DLL void bav_sort_tableof_just_created_variable 
				(bav_tableof_variable);
extern BAV_DLL void bav_sort_tableof_variable 
				(bav_tableof_variable, enum ba0_sort_mode);
extern BAV_DLL void bav_independent_variables (bav_tableof_variable);

struct bav_differential_ring;

extern BAV_DLL bav_variable bav_switch_ring_variable 
				(bav_variable, struct bav_differential_ring*);
END_C_DECLS

#endif /* !BAV_VARIABLE_H */
