#include "ba0.h"

/*
   The Faugre garbage collection mechanism.
*/

static void wedge 
		(ba0_tableof_int_p R, ba0_tableof_int_p A, ba0_tableof_int_p B)
{   struct ba0_tableof_int_p T;
/*
   One just wastes memory here.
*/
    ba0_init_table ((ba0_table)&T);
    ba0_realloc_table ((ba0_table)&T, 3);
    T.size = 3;
    T.tab [0] = A->tab [1]*B->tab [2] - A->tab [2]*B->tab [1];
    T.tab [1] = - A->tab [0]*B->tab [2] + A->tab [2]*B->tab [0];
    T.tab [2] = A->tab [0]*B->tab [1] - A->tab [1]*B->tab [0];
    ba0_set_table ((ba0_table)R, (ba0_table)&T);
}

int main ()
{   struct ba0_mark M;
    ba0_tableof_int_p R, A, B;
/*
   Before any computation, one records the value of the free pointer of
   the current stack.
*/
    ba0_restart (0, 0);
    ba0_record (&M);

    R = (ba0_tableof_int_p)ba0_new_table ();
    A = (ba0_tableof_int_p)ba0_new_table ();
    B = (ba0_tableof_int_p)ba0_new_table ();

    ba0_sscanf2 ("[2, 3, 4]", "%t[%d]", A);
    ba0_sscanf2 ("[3, 1, -2]", "%t[%d]", B);

    wedge (R, A, B);
/*
   One just specifies what one wants to keep between the recorded value 
   in M and the current value of the free pointer. The data structure R
   is compressed as close to M as possible (not so easy to implement).
   And the free pointer is updated.
*/
    ba0_garbage ("%t[%d]", &M, &R);
    ba0_printf ("result = %t[%d]\n", R);
    ba0_terminate (ba0_init_level);
    return 0;
}
