#include "blad.h"

/*
   Same example as in bla_pardi
*/

int main ()
{   bav_Iordering r, rbar;
    bad_regchain C, Cbar;
    struct ba0_mark M;
/*
   Any sequence of calls to the bad library is enclosed between a call
   to bad_restart and a call to bad_terminate. The two parameters given
   to bad_restart give the time limit (in secs) and the memory limit (in Mb).
   A zero value means: no limit.
*/
    bad_restart (0, 0);
    ba0_record (&M);
/*
   The variable r receives an ordering identifier.
   The ordering is described by the first parameter of ba0_sscanf2.
*/
    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [[v, u]])", "%ordering", &r);
    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [u, v])", "%ordering", &rbar);
/*
   r becomes the current ordering.
*/
    bav_R_push_ordering (r);
/*
   The variable C receives a regular chain. The chain is read in the first
   parameter of ba0_sscanf2.
*/
    C = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([v[x,x]-u[x], 4*v[y]*u+u[x]*u[y]-u[x]*u[y]*u, u[x]^2-4*u, u[y]^2-2*u], [differential, prime, autoreduced, primitive, squarefree, coherent])", "%regchain", C);
/*
   The chain is printed.
*/
    ba0_printf ("before: %regchain\n\n", C);
    Cbar = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([], [autoreduced, primitive])", "%regchain", Cbar);
/*
   The call to pardi
*/
    bad_pardi (Cbar, rbar, C);
/*
   All the memory used between the call to ba0_record (&M) and now is freed
   apart the one necessary for the chain Cbar.
*/
    ba0_garbage ("%regchain", &M, &Cbar);
    ba0_printf ("after: %regchain\n", Cbar);
    bav_R_pull_ordering ();
    bad_terminate (ba0_init_level);
    return 0;
}

