#include "blad.h"

/*
   This example shows how to catch raised exceptions.
   Look at comments in bad_pardi.
*/

int main ()
{   bav_Iordering r, rbar;
    bad_regchain C, Cbar;
    struct ba0_mark M;
    struct ba0_exception_code code;

    bad_restart (0, 0);
/*
   An exception catching point is set.
*/
    BA0_PUSH_EXCEPTION (code);
/*
   The following condition is evaluated for the first time just after
   the exception catching point is set and possibly at some other time
   if an exception is raised.
*/
    if (ba0_exception_is_raised (code))
    {	fprintf (stderr, "exception caught: %s\n", ba0_mesgerr);
	exit (1);
    }

    ba0_record (&M);
/*
  FIX ME to avoid the exception raising :
  a parenthesis is missing.
*/
    ba0_sscanf2 
	("ordering derivations = [x,y], blocks = [[v, u]])", "%ordering", &r);
    ba0_sscanf2 
	("ordering (derivations = [x,y], blocks = [u, v])", "%ordering", &rbar);
    bav_R_push_ordering (r);
    C = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([v[x,x]-u[x], 4*v[y]*u+u[x]*u[y]-u[x]*u[y]*u, u[x]^2-4*u, u[y]^2-2*u], [differential, prime, autoreduced, primitive, squarefree, coherent])", "%regchain", C);
    ba0_printf ("before: %regchain\n\n", C);
    Cbar = bad_new_regchain ();
    ba0_sscanf2 ("regchain ([], [autoreduced, primitive])", "%regchain", Cbar);
    bad_pardi (Cbar, rbar, C);
    ba0_garbage ("%regchain", &M, &Cbar);
    ba0_printf ("after: %regchain\n", Cbar);
    bav_R_pull_ordering ();
/*
   The exception catching point is cleared.
*/
    ba0_pull_exception (code);
    bad_terminate (ba0_init_level);
    return 0;
}

