#include <bap.h>

int main ()
{   struct bap_polynom_mpz A, B, coeff;
    struct bap_itercoeff_mpz iter;
    struct bav_term term;
    bav_Iordering r;
    bav_variable v;

    bap_restart (0, 0);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [x,y,z])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_polynom_mpz (&A);
    ba0_sscanf2 ("x*y*z^2 - 3*x*z + z^2 - y*x^2 - 1", "%Az", &A);
    ba0_sscanf2 ("y", "%v", &v);
    bap_init_polynom_mpz (&coeff);
    bav_init_term (&term);
    ba0_printf ("Polynomial : %Az\n", &A);
    bap_begin_itercoeff_mpz (&iter, &A, v);
    while (! bap_outof_itercoeff_mpz (&iter))
    {	bap_term_itercoeff_mpz (&term, &iter);
	bap_coeff_itercoeff_mpz (&coeff, &iter);
	ba0_printf ("coeff = %Az, term = %term\n", &coeff, &term);
	bap_next_itercoeff_mpz (&iter);
    }
    bap_close_itercoeff_mpz (&iter);
    ba0_sscanf2 ("ordering (derivations = [], blocks = [z,y,x])", "%ordering", &r);
    bav_R_push_ordering (r);
    bap_init_readonly_polynom_mpz (&B);
    bap_sort_polynom_mpz (&B, &A);
    ba0_sscanf2 ("z", "%v", &v);
    ba0_printf ("Polynomial : %Az\n", &B);
    bap_begin_itercoeff_mpz (&iter, &B, v);
    while (! bap_outof_itercoeff_mpz (&iter))
    {   bap_term_itercoeff_mpz (&term, &iter);
        bap_coeff_itercoeff_mpz (&coeff, &iter);
        ba0_printf ("coeff = %Az, term = %term\n", &coeff, &term);
        bap_next_itercoeff_mpz (&iter);
    }
    bap_close_itercoeff_mpz (&iter);
    bap_terminate (ba0_init_level);
    return 0;
}

